VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPortableDeviceCapabilities"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Const CLSID_PortableDeviceCapabilities As String = ""

Private Const IID_IPortableDeviceCapabilities As String = _
    "{2C8C6DBF-E3DC-4061-BECC-8542E810D126}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetSupportedCommands
    vtb_GetCommandOptions
    vtb_GetFunctionalCategories
    vtb_GetFunctionalObjects
    vtb_GetSupportedContentTypes
    vtb_GetSupportedFormats
    vtb_GetSupportedFormatProperties
    vtb_GetFixedPropertyAttributes
    vtb_Cancel
    vtb_GetSupportedEvents
    vtb_GetEventOptions
End Enum

Public Function GetInterfacePtr() As Long

    GetInterfacePtr = m_Interface.ifc

End Function

Public Function GetSupportedCommands() As clsIPortableDeviceKeyCollection

    Dim pCommands As Long
    Dim ppCommands As Long
    Dim IPortableDeviceKeyCollection As clsIPortableDeviceKeyCollection
    
    ppCommands = VarPtr(pCommands)
    
    If x_OleInvoke(vtb_GetSupportedCommands, ppCommands) Then
    
        Set IPortableDeviceKeyCollection = New clsIPortableDeviceKeyCollection
        Call IPortableDeviceKeyCollection.Initialize(pCommands)

    End If
    
    Set GetSupportedCommands = IPortableDeviceKeyCollection
    
End Function

Friend Function GetCommandOptions(ByRef Command As PropertyKey) As clsIPortableDeviceValues

    Dim pCommand As Long
    Dim pOptions As Long
    Dim ppOptions As Long
    Dim IPortableDeviceValues As clsIPortableDeviceValues
    
    pCommand = VarPtr(Command)
    ppOptions = VarPtr(pOptions)
    
    If x_OleInvoke(vtb_GetSupportedCommands, pCommand, ppOptions) Then
    
        Set IPortableDeviceValues = New clsIPortableDeviceValues
        Call IPortableDeviceValues.Initialize(pOptions)

    End If
    
    Set GetCommandOptions = IPortableDeviceValues

End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_PortableDeviceCapabilities, _
            IID_IPortableDeviceCapabilities)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIPortableDeviceCapabilities", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub

