VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPortableDeviceProperties"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Const CLSID_PortableDeviceProperties As String = ""

Private Const IID_IPortableDeviceProperties As String = _
    "{7F6D695C-03DF-4439-A809-59266BEEE3A6}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetSupportedProperties
    vtb_GetPropertyAttributes
    vtb_GetValues
    vtb_SetValues
    vtb_Delete
    vtb_Cancel
End Enum

Public Function GetInterfacePtr() As Long

    GetInterfacePtr = m_Interface.ifc

End Function

Public Function GetSupportedProperties(ByVal szObjectID As String) As clsIPortableDeviceKeyCollection

    Dim pszObjectID As Long
    Dim pKeys As Long
    Dim ppKeys As Long
    Dim IPortableDeviceKeyCollection As clsIPortableDeviceKeyCollection
    
    pszObjectID = StrPtr(szObjectID)
    ppKeys = VarPtr(pKeys)
    
    If x_OleInvoke(vtb_GetSupportedProperties, pszObjectID, ppKeys) Then

        Set IPortableDeviceKeyCollection = New clsIPortableDeviceKeyCollection
        Call IPortableDeviceKeyCollection.Initialize(pKeys)
        
    End If

    Set GetSupportedProperties = IPortableDeviceKeyCollection
    
End Function

Friend Function GetPropertyAttributes(ByVal szObjectID As String, ByRef Key As PropertyKey) As clsIPortableDeviceValues

    Dim pszObjectID As Long
    Dim pKey As Long
    Dim pAttributes As Long
    Dim ppAttributes As Long
    Dim IPortableDeviceValues As clsIPortableDeviceValues
    
    pszObjectID = StrPtr(szObjectID)
    pKey = VarPtr(Key)
    ppAttributes = VarPtr(pAttributes)
    
    If x_OleInvoke(vtb_GetPropertyAttributes, pszObjectID, pKey, ppAttributes) Then

        Set IPortableDeviceValues = New clsIPortableDeviceValues
        Call IPortableDeviceValues.Initialize(pAttributes)
        
    End If

    Set GetPropertyAttributes = IPortableDeviceValues

End Function

Public Function GetValues(ByVal szObjectID As String, ByVal pKeys As clsIPortableDeviceKeyCollection) As clsIPortableDeviceValues
    
    Dim pszObjectID As Long
    Dim pValues As Long
    Dim ppValues As Long
    Dim IPortableDeviceValues As clsIPortableDeviceValues
    
    pszObjectID = StrPtr(szObjectID)
    ppValues = VarPtr(pValues)

    If x_OleInvoke(vtb_GetValues, pszObjectID, pKeys.GetInterfacePtr, ppValues) Then

        Set IPortableDeviceValues = New clsIPortableDeviceValues
        Call IPortableDeviceValues.Initialize(pValues)
        
    End If

    Set GetValues = IPortableDeviceValues

End Function

Public Function GetAllValues(ByVal szObjectID As String) As clsIPortableDeviceValues
    
    Dim pszObjectID As Long
    Dim pValues As Long
    Dim ppValues As Long
    Dim IPortableDeviceValues As clsIPortableDeviceValues
    
    pszObjectID = StrPtr(szObjectID)
    ppValues = VarPtr(pValues)

    If x_OleInvoke(vtb_GetValues, pszObjectID, 0&, ppValues) Then

        Set IPortableDeviceValues = New clsIPortableDeviceValues
        Call IPortableDeviceValues.Initialize(pValues)
        
    End If

    Set GetAllValues = IPortableDeviceValues

End Function


Public Function SetValues(ByVal szObjectID As String, ByVal Values As clsIPortableDeviceValues) As clsIPortableDeviceValues

    Dim pszObjectID As Long
    Dim pResults As Long
    Dim ppResults As Long
    Dim IPortableDeviceValues As clsIPortableDeviceValues
    
    pszObjectID = StrPtr(szObjectID)
    ppResults = VarPtr(pResults)

    If x_OleInvoke(vtb_SetValues, pszObjectID, Values.GetInterfacePtr, ppResults) Then

        Set IPortableDeviceValues = New clsIPortableDeviceValues
        Call IPortableDeviceValues.Initialize(pResults)
        
    End If

    Set SetValues = IPortableDeviceValues

End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_PortableDeviceProperties, _
            IID_IPortableDeviceProperties)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
    
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIPortableDeviceProperties", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub

