Attribute VB_Name = "modMain"
Option Explicit

Public Type PDF
    PDFF_ObjectId As String
    PDFF_ParentId As String
    PDFF_Name As String
    PDFF_OriginalName As String
    PDFF_Type As String
End Type

Public Type NeededFilesProperties
    FileName As String
    FileSize As Currency
End Type

Public Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

Public Type PropertyKey
    fmtid As GUID
    pid As Long
End Type

Public Enum tagVARENUM
   VT_EMPTY = &H0
   VT_NULL = &H1
   VT_I2 = &H2
   VT_I4 = &H3
   VT_R4 = &H4
   VT_R8 = &H5
   VT_CY = &H6
   VT_DATE = &H7
   VT_BSTR = &H8
   VT_DISPATCH = &H9
   VT_ERROR = &HA
   VT_BOOL = &HB
   VT_VARIANT = &HC
   VT_UNKNOWN = &HD
   VT_DECIMAL = &HE
   VT_I1 = &H10
   VT_UI1 = &H11
   VT_UI2 = &H12
   VT_UI4 = &H13
   VT_I8 = &H14
   VT_UI8 = &H15
   VT_INT = &H16
   VT_UINT = &H17
   VT_VOID = &H18
   VT_HRESULT = &H19
   VT_PTR = &H1A
   VT_SAFEARRAY = &H1B
   VT_CARRAY = &H1C
   VT_USERDEFINED = &H1D
   VT_LPSTR = &H1E
   VT_LPWSTR = &H1F
   VT_RECORD = &H24
   VT_INT_PTR = &H25
   VT_UINT_PTR = &H26
   VT_ARRAY = &H2000
   VT_BYREF = &H4000
End Enum

Public Type PropVariant
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
'  union {
'    CHAR              cVal;
'    UCHAR             bVal;
'    SHORT             iVal;
'    USHORT            uiVal;
'    LONG              lVal;
'    ULONG             ulVal;
'    INT               intVal;
'    UINT              uintVal;
'    LARGE_INTEGER     hVal;
'    ULARGE_INTEGER    uhVal;
'    FLOAT             fltVal;
'    DOUBLE            dblVal;
'    VARIANT_BOOL      boolVal;
'    SCODE             scode;
'    CY                cyVal;
'    DATE              date;
'    FILETIME          filetime;
'    CLSID             *puuid;
'    CLIPDATA          *pclipdata;
'    BSTR              bstrVal;
'    BSTRBLOB          bstrblobVal;
'    BLOB              blob;
'    LPSTR             pszVal;
     pwszVal As Long
'    IUnknown          *punkVal;
'    IDispatch         *pdispVal;
'    IStream           *pStream;
'    IStorage          *pStorage;
'    LPVERSIONEDSTREAM pVersionedStream;
'    LPSAFEARRAY       parray;
'    CAC               cac;
'    CAUB              caub;
'    CAI               cai;
'    CAUI              caui;
'    CAL               cal;
'    CAUL              caul;
'    CAH               cah;
'    CAUH              cauh;
'    CAFLT             caflt;
'    CADBL             cadbl;
'    CABOOL            cabool;
'    CASCODE           cascode;
'    CACY              cacy;
'    CADATE            cadate;
'    CAFILETIME        cafiletime;
'    CACLSID           cauuid;
'    CACLIPDATA        caclipdata;
'    CABSTR            cabstr;
'    CABSTRBLOB        cabstrblob;
'    CALPSTR           calpstr;
'    CALPWSTR          calpwstr;
'    CAPROPVARIANT     capropvar;
'    CHAR              *pcVal;
'    UCHAR             *pbVal;
'    SHORT             *piVal;
'    USHORT            *puiVal;
'    LONG              *plVal;
'    ULONG             *pulVal;
'    INT               *pintVal;
'    UINT              *puintVal;
'    FLOAT             *pfltVal;
'    DOUBLE            *pdblVal;
'    VARIANT_BOOL      *pboolVal;
'    DECIMAL           *pdecVal;
'    SCODE             *pscode;
'    CY                *pcyVal;
'    DATE              *pdate;
'    BSTR              *pbstrVal;
'    IUnknown          **ppunkVal;
'    IDispatch         **ppdispVal;
'    LPSAFEARRAY       *pparray;
'    PROPVARIANT       *pvarVal;
End Type

Public Const WPD_DEVICE_OBJECT_ID As String = "DEVICE"

Public Const REG_NONE As Long = 0
Public Const REG_SZ As Long = 1
Public Const REG_EXPAND_SZ As Long = 2
Public Const REG_BINARY As Long = 3
Public Const REG_DWORD As Long = 4
Public Const REG_DWORD_LITTLE_ENDIAN As Long = 4
Public Const REG_DWORD_BIG_ENDIAN As Long = 5
Public Const REG_LINK As Long = 6
Public Const REG_MULTI_SZ As Long = 7
Public Const REG_RESOURCE_LIST = 8
Public Const REG_QWORD As Long = 11
Public Const REG_QWORD_LITTLE_ENDIAN As Long = 11

Public Const GENERIC_ALL As Long = &H10000000
Public Const GENERIC_EXECUTE As Long = &H20000000
Public Const GENERIC_READ As Long = &H80000000
Public Const GENERIC_WRITE As Long = &H40000000

Public Const GUID_DEVINTERFACE_WPD As String = "{6AC27878-A6FA-4155-BA85-F98F491D4F33}"
Public Const GUID_DEVINTERFACE_WPD_PRIVATE As String = "{BA0C718F-4DED-49B7-BDD3-FABE28661211}"

Public Const WPD_EVENT_NOTIFICATION As String = "{2BA2E40A-6B4C-4295-BB43-26322B99AEB2}"
Public Const WPD_EVENT_OBJECT_ADDED As String = "{A726DA95-E207-4B02-8D44-BEF2E86CBFFC}"
Public Const WPD_EVENT_OBJECT_REMOVED As String = "{BE82AB88-A52C-4823-96E5-D0272671FC38}"
Public Const WPD_EVENT_OBJECT_UPDATED As String = "{1445A759-2E01-485D-9F27-FF07DAE697AB}"
Public Const WPD_EVENT_DEVICE_RESET As String = "{7755CF53-C1ED-44F3-B5A2-451E2C376B27}"
Public Const WPD_EVENT_DEVICE_CAPABILITIES_UPDATED As String = "{36885AA1-CD54-4DAA-B3D0-AFB3E03F5999}"
Public Const WPD_EVENT_STORAGE_FORMAT As String = "{3782616B-22BC-4474-A251-3070F8D38857}"
Public Const WPD_EVENT_OBJECT_TRANSFER_REQUESTED As String = "{8D16A0A1-F2C6-41DA-8F19-5E53721ADBF2}"
Public Const WPD_EVENT_DEVICE_REMOVED As String = "{E4CBCA1B-6918-48B9-85EE-02BE7C850AF9}"

Public Const WPD_CONTENT_TYPE_FUNCTIONAL_OBJECT As String = "{99ED0160-17FF-4C44-9D98-1D7A6F941921}"
Public Const WPD_CONTENT_TYPE_FOLDER As String = "{27E2E392-A111-48E0-AB0C-E17705A05F85}"
Public Const WPD_CONTENT_TYPE_IMAGE As String = "{EF2107D5-A52A-4243-A26B-62D4176D7603}"
Public Const WPD_CONTENT_TYPE_DOCUMENT As String = "{680ADF52-950A-4041-9B41-65E393648155}"
Public Const WPD_CONTENT_TYPE_CONTACT As String = "{EABA8313-4525-4707-9F0E-87C6808E9435}"
Public Const WPD_CONTENT_TYPE_CONTACT_GROUP As String = "{346B8932-4C36-40D8-9415-1828291F9DE9}"
Public Const WPD_CONTENT_TYPE_AUDIO As String = "{4AD2C85E-5E2D-45E5-8864-4F229E3C6CF0}"
Public Const WPD_CONTENT_TYPE_VIDEO As String = "{9261B03C-3D78-4519-85E3-02C5E1F50BB9}"
Public Const WPD_CONTENT_TYPE_PLAYLIST As String = "{1A33F7E4-AF13-48F5-994E-77369DFE04A3}"
Public Const WPD_CONTENT_TYPE_MIXED_CONTENT_ALBUM As String = "{00F0C3AC-A593-49AC-9219-24ABCA5A2563}"
Public Const WPD_CONTENT_TYPE_AUDIO_ALBUM As String = "{AA18737E-5009-48FA-AE21-85F24383B4E6}"
Public Const WPD_CONTENT_TYPE_IMAGE_ALBUM As String = "{75793148-15F5-4A30-A813-54ED8A37E226}"
Public Const WPD_CONTENT_TYPE_VIDEO_ALBUM As String = "{012B0DB7-D4C1-45D6-B081-94B87779614F}"
Public Const WPD_CONTENT_TYPE_MEMO As String = "{9CD20ECF-3B50-414F-A641-E473FFE45751}"
Public Const WPD_CONTENT_TYPE_EMAIL As String = "{8038044A-7E51-4F8F-883D-1D0623D14533}"
Public Const WPD_CONTENT_TYPE_APPOINTMENT As String = "{0FED060E-8793-4B1E-90C9-48AC389AC631}"
Public Const WPD_CONTENT_TYPE_TASK As String = "{63252F2C-887F-4CB6-B1AC-D29855DCEF6C}"
Public Const WPD_CONTENT_TYPE_PROGRAM As String = "{D269F96A-247C-4BFF-98FB-97F3C49220E6}"
Public Const WPD_CONTENT_TYPE_GENERIC_FILE As String = "{0085E0A6-8D34-45D7-BC5C-447E59C73D48}"
Public Const WPD_CONTENT_TYPE_CALENDAR As String = "{A1FD5967-6023-49A0-9DF1-F8060BE751B0}"
Public Const WPD_CONTENT_TYPE_GENERIC_MESSAGE As String = "{E80EAAF8-B2DB-4133-B67E-1BEF4B4A6E5F}"
Public Const WPD_CONTENT_TYPE_NETWORK_ASSOCIATION As String = "{031DA7EE-18C8-4205-847E-89A11261D0F3}"
Public Const WPD_CONTENT_TYPE_CERTIFICATE As String = "{DC3876E8-A948-4060-9050-CBD77E8A3D87}"
Public Const WPD_CONTENT_TYPE_WIRELESS_PROFILE As String = "{0BAC070A-9F5F-4DA4-A8F6-3DE44D68FD6C}"
Public Const WPD_CONTENT_TYPE_MEDIA_CAST As String = "{5E88B3CC-3E65-4E62-BFFF-229495253AB0}"
Public Const WPD_CONTENT_TYPE_SECTION As String = "{821089F5-1D91-4DC9-BE3C-BBB1B35B18CE}"
Public Const WPD_CONTENT_TYPE_UNSPECIFIED As String = "{28D8D31E-249C-454E-AABC-34883168E634}"
Public Const WPD_CONTENT_TYPE_ALL As String = "{80E170D2-1055-4A3E-B952-82CC4F8A8689}"

Public Const WPD_FUNCTIONAL_CATEGORY_DEVICE As String = "{08EA466B-E3A4-4336-A1F3-A44D2B5C438C}"
Public Const WPD_FUNCTIONAL_CATEGORY_STORAGE As String = "{23F05BBC-15DE-4C2A-A55B-A9AF5CE412EF}"
Public Const WPD_FUNCTIONAL_CATEGORY_STILL_IMAGE_CAPTURE As String = "{613CA327-AB93-4900-B4FA-895BB5874B79}"
Public Const WPD_FUNCTIONAL_CATEGORY_AUDIO_CAPTURE As String = "{3F2A1919-C7C2-4A00-855D-F57CF06DEBBB}"
Public Const WPD_FUNCTIONAL_CATEGORY_VIDEO_CAPTURE As String = "{E23E5F6B-7243-43AA-8DF1-0EB3D968A918}"
Public Const WPD_FUNCTIONAL_CATEGORY_SMS As String = "{0044A0B1-C1E9-4AFD-B358-A62C6117C9CF}"
Public Const WPD_FUNCTIONAL_CATEGORY_RENDERING_INFORMATION As String = "{08600BA4-A7BA-4A01-AB0E-0065D0A356D3}"
Public Const WPD_FUNCTIONAL_CATEGORY_NETWORK_CONFIGURATION As String = "{48F4DB72-7C6A-4AB0-9E1A-470E3CDBF26A}"
Public Const WPD_FUNCTIONAL_CATEGORY_ALL As String = "{2D8A6512-A74C-448E-BA8A-F4AC07C49399}"

Public Const WPD_OBJECT_FORMAT_PROPERTIES_ONLY As String = "{30010000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_UNSPECIFIED As String = "{30000000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_SCRIPT As String = "{30020000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_EXECUTABLE As String = "{30030000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_TEXT As String = "{30040000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_HTML As String = "{30050000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_DPOF As String = "{30060000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_AIFF As String = "{30070000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_WAVE As String = "{30080000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_MP3 As String = "{30090000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_AVI As String = "{300A0000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_MPEG As String = "{300B0000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_ASF As String = "{300C0000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_EXIF As String = "{38010000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_TIFFEP As String = "{38020000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_FLASHPIX As String = "{38030000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_BMP As String = "{38040000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_CIFF As String = "{38050000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_GIF As String = "{38070000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_JFIF As String = "{38080000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_PCD As String = "{38090000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_PICT As String = "{380A0000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_PNG As String = "{380B0000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_TIFF As String = "{380D0000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_TIFFIT As String = "{380E0000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_JP2 As String = "{380F0000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_JPX As String = "{38100000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_WINDOWSIMAGEFORMAT As String = "{B8810000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_WMA As String = "{B9010000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_WMV As String = "{B9810000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_WPLPLAYLIST As String = "{BA100000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_M3UPLAYLIST As String = "{BA110000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_MPLPLAYLIST As String = "{BA120000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_ASXPLAYLIST As String = "{BA130000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_PLSPLAYLIST As String = "{BA140000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_ABSTRACT_CONTACT_GROUP As String = "{BA060000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_ABSTRACT_MEDIA_CAST As String = "{BA0B0000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_VCALENDAR1 As String = "{BE020000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_VCARD2 As String = "{BB820000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_VCARD3 As String = "{BB830000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_ICON As String = "{077232ED-102C-4638-9C22-83F142BFC822}"
Public Const WPD_OBJECT_FORMAT_XML As String = "{BA820000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_AAC As String = "{B9030000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_AUDIBLE As String = "{B9040000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_FLAC As String = "{B9060000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_OGG As String = "{B9020000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_MP4 As String = "{B9820000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_MP2 As String = "{B9830000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_MICROSOFT_WORD As String = "{BA830000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_MHT_COMPILED_HTML As String = "{BA840000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_MICROSOFT_EXCEL As String = "{BA850000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_MICROSOFT_POWERPOINT As String = "{BA860000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_NETWORK_ASSOCIATION As String = "{B1020000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_X509V3CERTIFICATE As String = "{B1030000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_MICROSOFT_WFC As String = "{B1040000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_3GP As String = "{B9840000-AE6C-4804-98BA-C57B46965FE7}"
Public Const WPD_OBJECT_FORMAT_ALL As String = "{C1F62EB2-4BB3-479C-9CFA-05B5F3A57B22}"

Public Const WPD_CATEGORY_STILL_IMAGE_CAPTURE As String = "{4FCD6982-22A2-4B05-A48B-62D38BF27B32}"
Public Const WPD_CATEGORY_MTP_EXT_VENDOR_OPERATIONS As String = "{4D545058-1A2E-4106-A357-771E0819FC56}"

Private Const WPD_COMMAND_MTP_EXT_GET_SUPPORTED_VENDOR_OPCODES_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},11"
Private Const WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITHOUT_DATA_PHASE_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},12"
Private Const WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITH_DATA_TO_READ_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},13"
Private Const WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITH_DATA_TO_WRITE_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},14"
Private Const WPD_COMMAND_MTP_EXT_READ_DATA_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},15"
Private Const WPD_COMMAND_MTP_EXT_WRITE_DATA_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},16"
Private Const WPD_COMMAND_MTP_EXT_END_DATA_TRANSFER_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},17"
Private Const WPD_COMMAND_MTP_EXT_GET_VENDOR_EXTENSION_DESCRIPTION_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},18"
Private Const WPD_PROPERTY_MTP_EXT_OPERATION_CODE_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1001"
Private Const WPD_PROPERTY_MTP_EXT_OPERATION_PARAMS_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1002"
Private Const WPD_PROPERTY_MTP_EXT_RESPONSE_CODE_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1003"
Private Const WPD_PROPERTY_MTP_EXT_RESPONSE_PARAMS_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1004"
Private Const WPD_PROPERTY_MTP_EXT_VENDOR_OPERATION_CODES_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1005"
Private Const WPD_PROPERTY_MTP_EXT_TRANSFER_CONTEXT_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1006"
Private Const WPD_PROPERTY_MTP_EXT_TRANSFER_TOTAL_DATA_SIZE_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1007"
Private Const WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_TO_READ_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1008"
Private Const WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_READ_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1009"
Private Const WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_TO_WRITE_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1010"
Private Const WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_WRITTEN_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1011"
Private Const WPD_PROPERTY_MTP_EXT_TRANSFER_DATA_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1012"
Private Const WPD_PROPERTY_MTP_EXT_OPTIMAL_TRANSFER_BUFFER_SIZE_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1013"
Private Const WPD_PROPERTY_MTP_EXT_VENDOR_EXTENSION_DESCRIPTION_FMTID_PID As String = "{4D545058-1A2E-4106-A357-771E0819FC56},1014"
Private Const WPD_API_OPTION_IOCTL_ACCESS_FMTID_PID As String = "{10e54a3e-052d-4777-a13c-de7614be2bc4},3"
Private Const WPD_API_OPTION_USE_CLEAR_DATA_STREAM_FMTID_PID As String = "{10e54a3e-052d-4777-a13c-de7614be2bc4},2"
Private Const WPD_APPOINTMENT_ACCEPTED_ATTENDEES_FMTID_PID As String = "{f99efd03-431d-40d8-a1c9-4e220d9c88d3},10"
Private Const WPD_APPOINTMENT_DECLINED_ATTENDEES_FMTID_PID As String = "{f99efd03-431d-40d8-a1c9-4e220d9c88d3},13"
Private Const WPD_APPOINTMENT_LOCATION_FMTID_PID As String = "{f99efd03-431d-40d8-a1c9-4e220d9c88d3},3"
Private Const WPD_APPOINTMENT_OPTIONAL_ATTENDEES_FMTID_PID As String = "{f99efd03-431d-40d8-a1c9-4e220d9c88d3},9"
Private Const WPD_APPOINTMENT_REQUIRED_ATTENDEES_FMTID_PID As String = "{f99efd03-431d-40d8-a1c9-4e220d9c88d3},8"
Private Const WPD_APPOINTMENT_RESOURCES_FMTID_PID As String = "{f99efd03-431d-40d8-a1c9-4e220d9c88d3},11"
Private Const WPD_APPOINTMENT_TENTATIVE_ATTENDEES_FMTID_PID As String = "{f99efd03-431d-40d8-a1c9-4e220d9c88d3},12"
Private Const WPD_APPOINTMENT_TYPE_FMTID_PID As String = "{f99efd03-431d-40d8-a1c9-4e220d9c88d3},7"
Private Const WPD_CLASS_EXTENSION_OPTIONS_DEVICE_IDENTIFICATION_VALUES_FMTID_PID As String = "{3e3595da-4d71-49fe-a0b4-d4406c3ae93f},3"
Private Const WPD_CLASS_EXTENSION_OPTIONS_DONT_REGISTER_WPD_DEVICE_INTERFACE_FMTID_PID As String = "{6309ffef-a87c-4ca7-8434-797576e40a96},3"
Private Const WPD_CLASS_EXTENSION_OPTIONS_MULTITRANSPORT_MODE_FMTID_PID As String = "{3e3595da-4d71-49fe-a0b4-d4406c3ae93f},2"
Private Const WPD_CLASS_EXTENSION_OPTIONS_REGISTER_WPD_PRIVATE_DEVICE_INTERFACE_FMTID_PID As String = "{6309ffef-a87c-4ca7-8434-797576e40a96},4"
Private Const WPD_CLASS_EXTENSION_OPTIONS_SUPPORTED_CONTENT_TYPES_FMTID_PID As String = "{6309ffef-a87c-4ca7-8434-797576e40a96},2"
Private Const WPD_CLASS_EXTENSION_OPTIONS_TRANSPORT_BANDWIDTH_FMTID_PID As String = "{3e3595da-4d71-49fe-a0b4-d4406c3ae93f},4"
Private Const WPD_CLIENT_DESIRED_ACCESS_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},9"
Private Const WPD_CLIENT_EVENT_COOKIE_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},11"
Private Const WPD_CLIENT_MAJOR_VERSION_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},3"
Private Const WPD_CLIENT_MINOR_VERSION_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},4"
Private Const WPD_CLIENT_NAME_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},2"
Private Const WPD_CLIENT_REVISION_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},5"
Private Const WPD_CLIENT_SECURITY_QUALITY_OF_SERVICE_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},8"
Private Const WPD_CLIENT_SHARE_MODE_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},10"
Private Const WPD_CLIENT_WMDRM_APPLICATION_CERTIFICATE_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},7"
Private Const WPD_CLIENT_WMDRM_APPLICATION_PRIVATE_KEY_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},6"
Private Const WPD_COMMAND_CLASS_EXTENSION_REGISTER_SERVICE_INTERFACES_FMTID_PID As String = "{7f0779b5-fa2b-4766-9cb2-f73ba30b6758},2"
Private Const WPD_COMMAND_CLASS_EXTENSION_UNREGISTER_SERVICE_INTERFACES_FMTID_PID As String = "{7f0779b5-fa2b-4766-9cb2-f73ba30b6758},3"
Private Const WPD_COMMAND_CLASS_EXTENSION_WRITE_DEVICE_INFORMATION_FMTID_PID As String = "{33fb0d11-64a3-4fac-b4c7-3dfeaa99b051},2"
Private Const WPD_COMMAND_COMMIT_KEYPAIR_FMTID_PID As String = "{78f9c6fc-79b8-473c-9060-6bd23dd072c4},3"
Private Const WPD_COMMAND_COMMON_GET_OBJECT_IDS_FROM_PERSISTENT_UNIQUE_IDS_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},3"
Private Const WPD_COMMAND_COMMON_RESET_DEVICE_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},2"
Private Const WPD_COMMAND_COMMON_SAVE_CLIENT_INFORMATION_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},4"
Private Const WPD_COMMAND_DEVICE_HINTS_GET_CONTENT_LOCATION_FMTID_PID As String = "{0d5fb92b-cb46-4c4f-8343-0bc3d3f17c84},2"
Private Const WPD_COMMAND_GENERATE_KEYPAIR_FMTID_PID As String = "{78f9c6fc-79b8-473c-9060-6bd23dd072c4},2"
Private Const WPD_COMMAND_MEDIA_CAPTURE_PAUSE_FMTID_PID As String = "{59b433ba-fe44-4d8d-808c-6bcb9b0f15e8},4"
Private Const WPD_COMMAND_MEDIA_CAPTURE_START_FMTID_PID As String = "{59b433ba-fe44-4d8d-808c-6bcb9b0f15e8},2"
Private Const WPD_COMMAND_MEDIA_CAPTURE_STOP_FMTID_PID As String = "{59b433ba-fe44-4d8d-808c-6bcb9b0f15e8},3"
Private Const WPD_COMMAND_PROCESS_WIRELESS_PROFILE_FMTID_PID As String = "{78f9c6fc-79b8-473c-9060-6bd23dd072c4},4"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_SUPPORTED_METHODS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},2"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_SUPPORTED_METHODS_BY_FORMAT_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},3"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_METHOD_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},4"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_METHOD_PARAMETER_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},5"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_SUPPORTED_FORMATS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},6"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_FORMAT_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},7"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_SUPPORTED_FORMAT_PROPERTIES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},8"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_FORMAT_PROPERTY_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},9"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_SUPPORTED_EVENTS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},10"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_EVENT_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},11"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_EVENT_PARAMETER_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},12"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_INHERITED_SERVICES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},13"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_FORMAT_RENDERING_PROFILES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},14"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_SUPPORTED_COMMANDS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},15"
Private Const WPD_COMMAND_SERVICE_CAPABILITIES_GET_COMMAND_OPTIONS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},16"
Private Const WPD_COMMAND_SERVICE_COMMON_GET_SERVICE_OBJECT_ID_FMTID_PID As String = "{322f071d-36ef-477f-b4b5-6f52d734baee},2"
Private Const WPD_COMMAND_SERVICE_METHODS_CANCEL_INVOKE_FMTID_PID As String = "{2d521ca8-c1b0-4268-a342-cf19321569bc},3"
Private Const WPD_COMMAND_SERVICE_METHODS_END_INVOKE_FMTID_PID As String = "{2d521ca8-c1b0-4268-a342-cf19321569bc},4"
Private Const WPD_COMMAND_SERVICE_METHODS_START_INVOKE_FMTID_PID As String = "{2d521ca8-c1b0-4268-a342-cf19321569bc},2"
Private Const WPD_COMMAND_SMS_SEND_FMTID_PID As String = "{afc25d66-fe0d-4114-9097-970c93e920d1},2"
Private Const WPD_COMMAND_STILL_IMAGE_CAPTURE_INITIATE_FMTID_PID As String = "{4fcd6982-22a2-4b05-a48b-62d38bf27b32},2"
Private Const WPD_COMMAND_STORAGE_EJECT_FMTID_PID As String = "{d8f907a6-34cc-45fa-97fb-d007fa47ec94},4"
Private Const WPD_COMMAND_STORAGE_FORMAT_FMTID_PID As String = "{d8f907a6-34cc-45fa-97fb-d007fa47ec94},2"
Private Const WPD_COMMON_INFORMATION_BODY_TEXT_FMTID_PID As String = "{b28ae94b-05a4-4e8e-be01-72cc7e099d8f},3"
Private Const WPD_COMMON_INFORMATION_END_DATETIME_FMTID_PID As String = "{b28ae94b-05a4-4e8e-be01-72cc7e099d8f},6"
Private Const WPD_COMMON_INFORMATION_NOTES_FMTID_PID As String = "{b28ae94b-05a4-4e8e-be01-72cc7e099d8f},7"
Private Const WPD_COMMON_INFORMATION_PRIORITY_FMTID_PID As String = "{b28ae94b-05a4-4e8e-be01-72cc7e099d8f},4"
Private Const WPD_COMMON_INFORMATION_START_DATETIME_FMTID_PID As String = "{b28ae94b-05a4-4e8e-be01-72cc7e099d8f},5"
Private Const WPD_COMMON_INFORMATION_SUBJECT_FMTID_PID As String = "{b28ae94b-05a4-4e8e-be01-72cc7e099d8f},2"
Private Const WPD_CONTACT_ANNIVERSARY_DATE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},62"
Private Const WPD_CONTACT_ASSISTANT_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},61"
Private Const WPD_CONTACT_BIRTHDATE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},57"
Private Const WPD_CONTACT_BUSINESS_EMAIL_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},34"
Private Const WPD_CONTACT_BUSINESS_EMAIL2_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},35"
Private Const WPD_CONTACT_BUSINESS_FAX_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},45"
Private Const WPD_CONTACT_BUSINESS_FULL_POSTAL_ADDRESS_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},17"
Private Const WPD_CONTACT_BUSINESS_PHONE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},40"
Private Const WPD_CONTACT_BUSINESS_PHONE2_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},41"
Private Const WPD_CONTACT_BUSINESS_POSTAL_ADDRESS_LINE1_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},18"
Private Const WPD_CONTACT_BUSINESS_POSTAL_ADDRESS_LINE2_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},19"
Private Const WPD_CONTACT_BUSINESS_POSTAL_ADDRESS_CITY_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},20"
Private Const WPD_CONTACT_BUSINESS_POSTAL_ADDRESS_REGION_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},21"
Private Const WPD_CONTACT_BUSINESS_POSTAL_ADDRESS_POSTAL_CODE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},22"
Private Const WPD_CONTACT_BUSINESS_POSTAL_ADDRESS_COUNTRY_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},23"
Private Const WPD_CONTACT_BUSINESS_WEB_ADDRESS_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},50"
Private Const WPD_CONTACT_CHILDREN_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},60"
Private Const WPD_CONTACT_COMPANY_NAME_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},54"
Private Const WPD_CONTACT_DISPLAY_NAME_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},2"
Private Const WPD_CONTACT_FIRST_NAME_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},3"
Private Const WPD_CONTACT_INSTANT_MESSENGER_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},51"
Private Const WPD_CONTACT_INSTANT_MESSENGER2_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},52"
Private Const WPD_CONTACT_INSTANT_MESSENGER3_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},53"
Private Const WPD_CONTACT_LAST_NAME_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},5"
Private Const WPD_CONTACT_MIDDLE_NAMES_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},4"
Private Const WPD_CONTACT_MOBILE_PHONE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},42"
Private Const WPD_CONTACT_MOBILE_PHONE2_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},43"
Private Const WPD_CONTACT_OTHER_EMAILS_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},36"
Private Const WPD_CONTACT_OTHER_FULL_POSTAL_ADDRESS_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},24"
Private Const WPD_CONTACT_OTHER_PHONES_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},47"
Private Const WPD_CONTACT_OTHER_POSTAL_ADDRESS_CITY_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},27"
Private Const WPD_CONTACT_OTHER_POSTAL_ADDRESS_LINE1_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},25"
Private Const WPD_CONTACT_OTHER_POSTAL_ADDRESS_LINE2_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},26"
Private Const WPD_CONTACT_OTHER_POSTAL_ADDRESS_POSTAL_CODE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},29"
Private Const WPD_CONTACT_OTHER_POSTAL_ADDRESS_POSTAL_COUNTRY_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},30"
Private Const WPD_CONTACT_OTHER_POSTAL_ADDRESS_REGION_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},28"
Private Const WPD_CONTACT_PAGER_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},46"
Private Const WPD_CONTACT_PERSONAL_EMAIL_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},32"
Private Const WPD_CONTACT_PERSONAL_EMAIL2_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},33"
Private Const WPD_CONTACT_PERSONAL_FAX_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},44"
Private Const WPD_CONTACT_PERSONAL_FULL_POSTAL_ADDRESS_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},10"
Private Const WPD_CONTACT_PERSONAL_PHONE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},38"
Private Const WPD_CONTACT_PERSONAL_PHONE2_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},39"
Private Const WPD_CONTACT_PERSONAL_POSTAL_ADDRESS_LINE1_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},11"
Private Const WPD_CONTACT_PERSONAL_POSTAL_ADDRESS_LINE2_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},12"
Private Const WPD_CONTACT_PERSONAL_POSTAL_ADDRESS_CITY_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},13"
Private Const WPD_CONTACT_PERSONAL_POSTAL_ADDRESS_REGION_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},14"
Private Const WPD_CONTACT_PERSONAL_POSTAL_ADDRESS_POSTAL_CODE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},15"
Private Const WPD_CONTACT_PERSONAL_POSTAL_ADDRESS_COUNTRY_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},16"
Private Const WPD_CONTACT_PERSONAL_WEB_ADDRESS_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},49"
Private Const WPD_CONTACT_PHONETIC_COMPANY_NAME_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},55"
Private Const WPD_CONTACT_PHONETIC_FIRST_NAME_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},8"
Private Const WPD_CONTACT_PHONETIC_LAST_NAME_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},9"
Private Const WPD_CONTACT_PREFIX_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},6"
Private Const WPD_CONTACT_PRIMARY_EMAIL_ADDRESS_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},31"
Private Const WPD_CONTACT_PRIMARY_FAX_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},58"
Private Const WPD_CONTACT_PRIMARY_PHONE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},37"
Private Const WPD_CONTACT_PRIMARY_WEB_ADDRESS_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},48"
Private Const WPD_CONTACT_RINGTONE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},63"
Private Const WPD_CONTACT_ROLE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},56"
Private Const WPD_CONTACT_SPOUSE_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},59"
Private Const WPD_CONTACT_SUFFIX_FMTID_PID As String = "{fbd4fdab-987d-4777-b3f9-726185a9312b},7"
Private Const WPD_DEVICE_DATETIME_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},11"
Private Const WPD_DEVICE_FIRMWARE_VERSION_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},3"
Private Const WPD_DEVICE_FRIENDLY_NAME_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},12"
Private Const WPD_DEVICE_FUNCTIONAL_UNIQUE_ID_FMTID_PID As String = "{463dd662-7fc4-4291-911c-7f4c9cca9799},2"
Private Const WPD_DEVICE_MANUFACTURER_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},7"
Private Const WPD_DEVICE_MODEL_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},8"
Private Const WPD_DEVICE_MODEL_UNIQUE_ID_FMTID_PID As String = "{463dd662-7fc4-4291-911c-7f4c9cca9799},3"
Private Const WPD_DEVICE_NETWORK_IDENTIFIER_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},16"
Private Const WPD_DEVICE_POWER_LEVEL_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},4"
Private Const WPD_DEVICE_POWER_SOURCE_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},5"
Private Const WPD_DEVICE_PROTOCOL_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},6"
Private Const WPD_DEVICE_SERIAL_NUMBER_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},9"
Private Const WPD_DEVICE_SUPPORTED_DRM_SCHEMES_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},13"
Private Const WPD_DEVICE_SUPPORTED_FORMATS_ARE_ORDERED_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},14"
Private Const WPD_DEVICE_SUPPORTS_NON_CONSUMABLE_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},10"
Private Const WPD_DEVICE_SYNC_PARTNER_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},2"
Private Const WPD_DEVICE_TRANSPORT_FMTID_PID As String = "{463dd662-7fc4-4291-911c-7f4c9cca9799},4"
Private Const WPD_DEVICE_TYPE_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},15"
Private Const WPD_DEVICE_USE_DEVICE_STAGE_FMTID_PID As String = "{463dd662-7fc4-4291-911c-7f4c9cca9799},5"
Private Const WPD_EMAIL_BCC_LINE_FMTID_PID As String = "{41f8f65a-5484-4782-b13d-4740dd7c37c5},4"
Private Const WPD_EMAIL_CC_LINE_FMTID_PID As String = "{41f8f65a-5484-4782-b13d-4740dd7c37c5},3"
Private Const WPD_EMAIL_HAS_ATTACHMENTS_FMTID_PID As String = "{41f8f65a-5484-4782-b13d-4740dd7c37c5},9"
Private Const WPD_EMAIL_HAS_BEEN_READ_FMTID_PID As String = "{41f8f65a-5484-4782-b13d-4740dd7c37c5},7"
Private Const WPD_EMAIL_RECEIVED_TIME_FMTID_PID As String = "{41f8f65a-5484-4782-b13d-4740dd7c37c5},8"
Private Const WPD_EMAIL_SENDER_ADDRESS_FMTID_PID As String = "{41f8f65a-5484-4782-b13d-4740dd7c37c5},10"
Private Const WPD_EMAIL_TO_LINE_FMTID_PID As String = "{41f8f65a-5484-4782-b13d-4740dd7c37c5},2"
Private Const WPD_EVENT_ATTRIBUTE_NAME_FMTID_PID As String = "{10c96578-2e81-4111-adde-e08ca6138f6d},2"
Private Const WPD_EVENT_ATTRIBUTE_OPTIONS_FMTID_PID As String = "{10c96578-2e81-4111-adde-e08ca6138f6d},4"
Private Const WPD_EVENT_ATTRIBUTE_PARAMETERS_FMTID_PID As String = "{10c96578-2e81-4111-adde-e08ca6138f6d},3"
Private Const WPD_EVENT_OPTION_IS_AUTOPLAY_EVENT_FMTID_PID As String = "{b3d8dad7-a361-4b83-8a48-5b02ce10713b},3"
Private Const WPD_EVENT_OPTION_IS_BROADCAST_EVENT_FMTID_PID As String = "{b3d8dad7-a361-4b83-8a48-5b02ce10713b},2"
Private Const WPD_EVENT_PARAMETER_CHILD_HIERARCHY_CHANGED_FMTID_PID As String = "{15ab1953-f817-4fef-a921-5676e838f6e0},8"
Private Const WPD_EVENT_PARAMETER_EVENT_ID_FMTID_PID As String = "{15ab1953-f817-4fef-a921-5676e838f6e0},3"
Private Const WPD_EVENT_PARAMETER_OBJECT_CREATION_COOKIE_FMTID_PID As String = "{15ab1953-f817-4fef-a921-5676e838f6e0},7"
Private Const WPD_EVENT_PARAMETER_OBJECT_PARENT_PERSISTENT_UNIQUE_ID_FMTID_PID As String = "{15ab1953-f817-4fef-a921-5676e838f6e0},6"
Private Const WPD_EVENT_PARAMETER_OPERATION_PROGRESS_FMTID_PID As String = "{15ab1953-f817-4fef-a921-5676e838f6e0},5"
Private Const WPD_EVENT_PARAMETER_OPERATION_STATE_FMTID_PID As String = "{15ab1953-f817-4fef-a921-5676e838f6e0},4"
Private Const WPD_EVENT_PARAMETER_PNP_DEVICE_ID_FMTID_PID As String = "{15ab1953-f817-4fef-a921-5676e838f6e0},2"
Private Const WPD_EVENT_PARAMETER_SERVICE_METHOD_CONTEXT_FMTID_PID As String = "{52807b8a-4914-4323-9b9a-74f654b2b846},2"
Private Const WPD_FOLDER_CONTENT_TYPES_ALLOWED_FMTID_PID As String = "{7e9a7abf-e568-4b34-aa2f-13bb12ab177d},2"
Private Const WPD_FORMAT_ATTRIBUTE_MIMETYPE_FMTID_PID As String = "{a0a02000-bcaf-4be8-b3f5-233f231cf58f},3"
Private Const WPD_FORMAT_ATTRIBUTE_NAME_FMTID_PID As String = "{a0a02000-bcaf-4be8-b3f5-233f231cf58f},2"
Private Const WPD_FUNCTIONAL_OBJECT_CATEGORY_FMTID_PID As String = "{8f052d93-abca-4fc5-a5ac-b01df4dbe598},2"
Private Const WPD_IMAGE_BITDEPTH_FMTID_PID As String = "{63d64908-9fa1-479f-85ba-9952216447db},3"
Private Const WPD_IMAGE_COLOR_CORRECTED_STATUS_FMTID_PID As String = "{63d64908-9fa1-479f-85ba-9952216447db},5"
Private Const WPD_IMAGE_CROPPED_STATUS_FMTID_PID As String = "{63d64908-9fa1-479f-85ba-9952216447db},4"
Private Const WPD_IMAGE_EXPOSURE_INDEX_FMTID_PID As String = "{63d64908-9fa1-479f-85ba-9952216447db},8"
Private Const WPD_IMAGE_EXPOSURE_TIME_FMTID_PID As String = "{63d64908-9fa1-479f-85ba-9952216447db},7"
Private Const WPD_IMAGE_FNUMBER_FMTID_PID As String = "{63d64908-9fa1-479f-85ba-9952216447db},6"
Private Const WPD_IMAGE_HORIZONTAL_RESOLUTION_FMTID_PID As String = "{63d64908-9fa1-479f-85ba-9952216447db},9"
Private Const WPD_IMAGE_VERTICAL_RESOLUTION_FMTID_PID As String = "{63d64908-9fa1-479f-85ba-9952216447db},10"

Private Const WPD_MEDIA_ALBUM_ARTIST_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},25"
Private Const WPD_MEDIA_ARTIST_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},24"
Private Const WPD_MEDIA_BITRATE_TYPE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},3"
Private Const WPD_MEDIA_BUY_NOW_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},20"
Private Const WPD_MEDIA_BYTE_BOOKMARK_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},36"
Private Const WPD_MEDIA_COMPOSER_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},11"
Private Const WPD_MEDIA_COPYRIGHT_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},4"
Private Const WPD_MEDIA_DESCRIPTION_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},31"
Private Const WPD_MEDIA_DESTINATION_URL_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},30"
Private Const WPD_MEDIA_DURATION_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},19"
Private Const WPD_MEDIA_EFFECTIVE_RATING_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},12"
Private Const WPD_MEDIA_ENCODING_PROFILE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},21"
Private Const WPD_MEDIA_GENRE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},32"
Private Const WPD_MEDIA_GUID_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},38"
Private Const WPD_MEDIA_HEIGHT_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},23"
Private Const WPD_MEDIA_LAST_ACCESSED_TIME_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},8"
Private Const WPD_MEDIA_LAST_BUILD_DATE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},35"
Private Const WPD_MEDIA_MANAGING_EDITOR_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},27"
Private Const WPD_MEDIA_META_GENRE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},10"
Private Const WPD_MEDIA_OBJECT_BOOKMARK_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},34"
Private Const WPD_MEDIA_OWNER_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},26"
Private Const WPD_MEDIA_PARENTAL_RATING_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},9"
Private Const WPD_MEDIA_RELEASE_DATE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},14"
Private Const WPD_MEDIA_SAMPLE_RATE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},15"
Private Const WPD_MEDIA_SKIP_COUNT_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},7"
Private Const WPD_MEDIA_SOURCE_URL_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},29"
Private Const WPD_MEDIA_STAR_RATING_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},16"
Private Const WPD_MEDIA_SUB_DESCRIPTION_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},39"
Private Const WPD_MEDIA_SUB_TITLE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},13"
Private Const WPD_MEDIA_SUBSCRIPTION_CONTENT_ID_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},5"
Private Const WPD_MEDIA_TIME_BOOKMARK_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},33"
Private Const WPD_MEDIA_TIME_TO_LIVE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},37"
Private Const WPD_MEDIA_TITLE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},18"
Private Const WPD_MEDIA_TOTAL_BITRATE_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},2"
Private Const WPD_MEDIA_USE_COUNT_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},6"
Private Const WPD_MEDIA_USER_EFFECTIVE_RATING_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},17"
Private Const WPD_MEDIA_WEBMASTER_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},28"
Private Const WPD_MEDIA_WIDTH_FMTID_PID As String = "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8},22"

Private Const WPD_METHOD_ATTRIBUTE_ACCESS_FMTID_PID As String = "{f17a5071-f039-44af-8efe-432cf32e432a},4"
Private Const WPD_METHOD_ATTRIBUTE_ASSOCIATED_FORMAT_FMTID_PID As String = "{f17a5071-f039-44af-8efe-432cf32e432a},3"
Private Const WPD_METHOD_ATTRIBUTE_NAME_FMTID_PID As String = "{f17a5071-f039-44af-8efe-432cf32e432a},2"
Private Const WPD_METHOD_ATTRIBUTE_PARAMETERS_FMTID_PID As String = "{f17a5071-f039-44af-8efe-432cf32e432a},5"
Private Const WPD_MUSIC_ALBUM_FMTID_PID As String = "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6},3"
Private Const WPD_MUSIC_LYRICS_FMTID_PID As String = "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6},6"
Private Const WPD_MUSIC_MOOD_FMTID_PID As String = "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6},8"
Private Const WPD_MUSIC_TRACK_FMTID_PID As String = "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6},4"
Private Const WPD_AUDIO_BIT_DEPTH_FMTID_PID As String = "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6},12"
Private Const WPD_AUDIO_BITRATE_FMTID_PID As String = "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6},9"
Private Const WPD_AUDIO_BLOCK_ALIGNMENT_FMTID_PID As String = "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6},13"
Private Const WPD_AUDIO_CHANNEL_COUNT_FMTID_PID As String = "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6},10"
Private Const WPD_AUDIO_FORMAT_CODE_FMTID_PID As String = "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6},11"
Private Const WPD_NETWORK_ASSOCIATION_HOST_NETWORK_IDENTIFIERS_FMTID_PID As String = "{e4c93c1f-b203-43f1-a100-5a07d11b0274},2"
Private Const WPD_NETWORK_ASSOCIATION_X509V3SEQUENCE_FMTID_PID As String = "{e4c93c1f-b203-43f1-a100-5a07d11b0274},3"
Private Const WPD_OBJECT_BACK_REFERENCES_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},21"
Private Const WPD_OBJECT_CAN_DELETE_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},26"
Private Const WPD_OBJECT_CONTAINER_FUNCTIONAL_OBJECT_ID_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},23"
Private Const WPD_OBJECT_CONTENT_TYPE_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},7"
Private Const WPD_OBJECT_DATE_AUTHORED_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},20"
Private Const WPD_OBJECT_DATE_CREATED_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},18"
Private Const WPD_OBJECT_DATE_MODIFIED_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},19"
Private Const WPD_OBJECT_FORMAT_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},6"
Private Const WPD_OBJECT_GENERATE_THUMBNAIL_FROM_RESOURCE_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},24"
Private Const WPD_OBJECT_HINT_LOCATION_DISPLAY_NAME_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},25"
Private Const WPD_OBJECT_ID_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},2"
Private Const WPD_OBJECT_IS_DRM_PROTECTED_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},17"
Private Const WPD_OBJECT_ISHIDDEN_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},9"
Private Const WPD_OBJECT_ISSYSTEM_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},10"
Private Const WPD_OBJECT_KEYWORDS_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},15"
Private Const WPD_OBJECT_LANGUAGE_LOCALE_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},27"
Private Const WPD_OBJECT_NAME_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},4"
Private Const WPD_OBJECT_NON_CONSUMABLE_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},13"
Private Const WPD_OBJECT_ORIGINAL_FILE_NAME_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},12"
Private Const WPD_OBJECT_PARENT_ID_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},3"
Private Const WPD_OBJECT_PERSISTENT_UNIQUE_ID_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},5"
Private Const WPD_OBJECT_REFERENCES_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},14"
Private Const WPD_OBJECT_SIZE_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},11"
Private Const WPD_OBJECT_SYNC_ID_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},16"
Private Const WPD_OPTION_SMS_BINARY_MESSAGE_SUPPORTED_FMTID_PID As String = "{afc25d66-fe0d-4114-9097-970c93e920d1},5001"
Private Const WPD_OPTION_VALID_OBJECT_IDS_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},5001"
Private Const WPD_PARAMETER_ATTRIBUTE_DEFAULT_VALUE_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},5"
Private Const WPD_PARAMETER_ATTRIBUTE_ENUMERATION_ELEMENTS_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},9"
Private Const WPD_PARAMETER_ATTRIBUTE_FORM_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},4"
Private Const WPD_PARAMETER_ATTRIBUTE_MAX_SIZE_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},11"
Private Const WPD_PARAMETER_ATTRIBUTE_NAME_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},13"
Private Const WPD_PARAMETER_ATTRIBUTE_ORDER_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},2"
Private Const WPD_PARAMETER_ATTRIBUTE_RANGE_MAX_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},7"
Private Const WPD_PARAMETER_ATTRIBUTE_RANGE_MIN_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},6"
Private Const WPD_PARAMETER_ATTRIBUTE_RANGE_STEP_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},8"
Private Const WPD_PARAMETER_ATTRIBUTE_REGULAR_EXPRESSION_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},10"
Private Const WPD_PARAMETER_ATTRIBUTE_USAGE_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},3"
Private Const WPD_PARAMETER_ATTRIBUTE_VARTYPE_FMTID_PID As String = "{e6864dd7-f325-45ea-a1d5-97cf73b6ca58},12"
Private Const WPD_PROPERTY_ATTRIBUTE_CAN_DELETE_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},5"
Private Const WPD_PROPERTY_ATTRIBUTE_CAN_READ_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},3"
Private Const WPD_PROPERTY_ATTRIBUTE_CAN_WRITE_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},4"
Private Const WPD_PROPERTY_ATTRIBUTE_DEFAULT_VALUE_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},6"
Private Const WPD_PROPERTY_ATTRIBUTE_ENUMERATION_ELEMENTS_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},11"
Private Const WPD_PROPERTY_ATTRIBUTE_FAST_PROPERTY_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},7"
Private Const WPD_PROPERTY_ATTRIBUTE_FORM_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},2"
Private Const WPD_PROPERTY_ATTRIBUTE_MAX_SIZE_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},13"
Private Const WPD_PROPERTY_ATTRIBUTE_NAME_FMTID_PID As String = "{5d9da160-74ae-43cc-85a9-fe555a80798e},2"
Private Const WPD_PROPERTY_ATTRIBUTE_RANGE_MAX_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},9"
Private Const WPD_PROPERTY_ATTRIBUTE_RANGE_MIN_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},8"
Private Const WPD_PROPERTY_ATTRIBUTE_RANGE_STEP_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},10"
Private Const WPD_PROPERTY_ATTRIBUTE_REGULAR_EXPRESSION_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},12"
Private Const WPD_PROPERTY_ATTRIBUTE_VARTYPE_FMTID_PID As String = "{5d9da160-74ae-43cc-85a9-fe555a80798e},3"
Private Const WPD_COMMAND_CAPABILITIES_GET_COMMAND_OPTIONS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},3"
Private Const WPD_COMMAND_CAPABILITIES_GET_EVENT_OPTIONS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},11"
Private Const WPD_COMMAND_CAPABILITIES_GET_FIXED_PROPERTY_ATTRIBUTES_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},9"
Private Const WPD_COMMAND_CAPABILITIES_GET_FUNCTIONAL_OBJECTS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},5"
Private Const WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_COMMANDS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},2"
Private Const WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_FUNCTIONAL_CATEGORIES_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},4"
Private Const WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_CONTENT_TYPES_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},6"
Private Const WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_FORMATS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},7"
Private Const WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_FORMAT_PROPERTIES_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},8"
Private Const WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_EVENTS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},10"
Private Const WPD_PROPERTY_CAPABILITIES_COMMAND_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1002"
Private Const WPD_PROPERTY_CAPABILITIES_COMMAND_OPTIONS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1003"
Private Const WPD_PROPERTY_CAPABILITIES_CONTENT_TYPES_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1007"
Private Const WPD_PROPERTY_CAPABILITIES_CONTENT_TYPE_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1008"
Private Const WPD_PROPERTY_CAPABILITIES_EVENT_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1014"
Private Const WPD_PROPERTY_CAPABILITIES_EVENT_OPTIONS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1015"
Private Const WPD_PROPERTY_CAPABILITIES_FORMAT_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1010"
Private Const WPD_PROPERTY_CAPABILITIES_FORMATS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1009"
Private Const WPD_PROPERTY_CAPABILITIES_FUNCTIONAL_CATEGORIES_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1004"
Private Const WPD_PROPERTY_CAPABILITIES_FUNCTIONAL_CATEGORY_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1005"
Private Const WPD_PROPERTY_CAPABILITIES_FUNCTIONAL_OBJECTS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1006"
Private Const WPD_PROPERTY_CAPABILITIES_PROPERTY_KEYS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1011"
Private Const WPD_PROPERTY_CAPABILITIES_PROPERTY_ATTRIBUTES_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1012"
Private Const WPD_PROPERTY_CAPABILITIES_SUPPORTED_COMMANDS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1001"
Private Const WPD_PROPERTY_CAPABILITIES_SUPPORTED_EVENTS_FMTID_PID As String = "{0CABEC78-6B74-41C6-9216-2639D1FCE356},1013"
Private Const WPD_PROPERTY_CLASS_EXTENSION_DEVICE_INFORMATION_VALUES_FMTID_PID As String = "{33fb0d11-64a3-4fac-b4c7-3dfeaa99b051},1001"
Private Const WPD_PROPERTY_CLASS_EXTENSION_DEVICE_INFORMATION_WRITE_RESULTS_FMTID_PID As String = "{33fb0d11-64a3-4fac-b4c7-3dfeaa99b051},1002"
Private Const WPD_PROPERTY_CLASS_EXTENSION_SERVICE_OBJECT_ID_FMTID_PID As String = "{7f0779b5-fa2b-4766-9cb2-f73ba30b6758},1001"
Private Const WPD_PROPERTY_CLASS_EXTENSION_SERVICE_INTERFACES_FMTID_PID As String = "{7f0779b5-fa2b-4766-9cb2-f73ba30b6758},1002"
Private Const WPD_PROPERTY_CLASS_EXTENSION_SERVICE_REGISTRATION_RESULTS_FMTID_PID As String = "{7f0779b5-fa2b-4766-9cb2-f73ba30b6758},1003"
Private Const WPD_PROPERTY_COMMON_CLIENT_INFORMATION_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},1009"
Private Const WPD_PROPERTY_COMMON_CLIENT_INFORMATION_CONTEXT_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},1010"
Private Const WPD_PROPERTY_COMMON_COMMAND_CATEGORY_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},1001"
Private Const WPD_PROPERTY_COMMON_COMMAND_ID_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},1002"
Private Const WPD_PROPERTY_COMMON_COMMAND_TARGET_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},1006"
Private Const WPD_PROPERTY_COMMON_DRIVER_ERROR_CODE_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},1004"
Private Const WPD_PROPERTY_COMMON_HRESULT_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},1003 "
Private Const WPD_PROPERTY_COMMON_OBJECT_IDS_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},1008"
Private Const WPD_PROPERTY_COMMON_PERSISTENT_UNIQUE_IDS_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},1007"
Private Const WPD_PROPERTY_DEVICE_HINTS_CONTENT_TYPE_FMTID_PID As String = "{0d5fb92b-cb46-4c4f-8343-0bc3d3f17c84},1001"
Private Const WPD_PROPERTY_DEVICE_HINTS_CONTENT_LOCATIONS_FMTID_PID As String = "{0d5fb92b-cb46-4c4f-8343-0bc3d3f17c84},1002"
Private Const WPD_PROPERTY_NULL_FMTID_PID As String = "{00000000-0000-0000-0000-000000000000},0"
Private Const WPD_COMMAND_OBJECT_ENUMERATION_END_FIND_FMTID_PID As String = "{B7474E91-E7F8-4AD9-B400-AD1A4B58EEEC},4"
Private Const WPD_COMMAND_OBJECT_ENUMERATION_FIND_NEXT_FMTID_PID As String = "{B7474E91-E7F8-4AD9-B400-AD1A4B58EEEC},3"
Private Const WPD_COMMAND_OBJECT_ENUMERATION_START_FIND_FMTID_PID As String = "{B7474E91-E7F8-4AD9-B400-AD1A4B58EEEC},2"
Private Const WPD_PROPERTY_OBJECT_ENUMERATION_CONTEXT_FMTID_PID As String = "{B7474E91-E7F8-4AD9-B400-AD1A4B58EEEC},1004"
Private Const WPD_PROPERTY_OBJECT_ENUMERATION_FILTER_FMTID_PID As String = "{B7474E91-E7F8-4AD9-B400-AD1A4B58EEEC},1002"
Private Const WPD_PROPERTY_OBJECT_ENUMERATION_NUM_OBJECTS_REQUESTED_FMTID_PID As String = "{B7474E91-E7F8-4AD9-B400-AD1A4B58EEEC},1005"
Private Const WPD_PROPERTY_OBJECT_ENUMERATION_OBJECT_IDS_FMTID_PID As String = "{B7474E91-E7F8-4AD9-B400-AD1A4B58EEEC},1003"
Private Const WPD_PROPERTY_OBJECT_ENUMERATION_PARENT_ID_FMTID_PID As String = "{B7474E91-E7F8-4AD9-B400-AD1A4B58EEEC},1001"
Private Const WPD_COMMAND_OBJECT_MANAGEMENT_COMMIT_OBJECT_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},5"
Private Const WPD_COMMAND_OBJECT_MANAGEMENT_COPY_OBJECTS_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},9"
Private Const WPD_COMMAND_OBJECT_MANAGEMENT_CREATE_OBJECT_WITH_PROPERTIES_ONLY_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},2"
Private Const WPD_COMMAND_OBJECT_MANAGEMENT_CREATE_OBJECT_WITH_PROPERTIES_AND_DATA_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},3"
Private Const WPD_COMMAND_OBJECT_MANAGEMENT_DELETE_OBJECTS_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},7"
Private Const WPD_COMMAND_OBJECT_MANAGEMENT_MOVE_OBJECTS_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},8"
Private Const WPD_COMMAND_OBJECT_MANAGEMENT_REVERT_OBJECT_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},6"
Private Const WPD_COMMAND_OBJECT_MANAGEMENT_UPDATE_OBJECT_WITH_PROPERTIES_AND_DATA_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},10"
Private Const WPD_COMMAND_OBJECT_MANAGEMENT_WRITE_OBJECT_DATA_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},4"
Private Const WPD_OPTION_OBJECT_MANAGEMENT_RECURSIVE_DELETE_SUPPORTED_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},5001"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_CONTEXT_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1002"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_COPY_RESULTS_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1013"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_CREATION_PROPERTIES_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1001"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_DATA_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1005"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_DELETE_OPTIONS_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1007"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_DELETE_RESULTS_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1010"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_DESTINATION_FOLDER_OBJECT_ID_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1011"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_MOVE_RESULTS_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1012"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_NUM_BYTES_TO_WRITE_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1003"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_NUM_BYTES_WRITTEN_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1004"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_OBJECT_ID_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1006"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_OBJECT_IDS_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1009"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_OBJECT_FORMAT_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1016"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_OPTIMAL_TRANSFER_BUFFER_SIZE_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1008"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_PROPERTY_KEYS_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1015"
Private Const WPD_PROPERTY_OBJECT_MANAGEMENT_UPDATE_PROPERTIES_FMTID_PID As String = "{EF1E43DD-A9ED-4341-8BCC-186192AEA089},1014"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_LIST_START_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},2"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_LIST_NEXT_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},3"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_LIST_END_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},4"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_FORMAT_START_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},5"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_FORMAT_NEXT_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},6"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_FORMAT_END_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},7"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_BULK_SET_VALUES_BY_OBJECT_LIST_START_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},8"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_BULK_SET_VALUES_BY_OBJECT_LIST_NEXT_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},9"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_BULK_SET_VALUES_BY_OBJECT_LIST_END_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},10"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_BULK_OBJECT_IDS_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},1001"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_BULK_CONTEXT_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},1002"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_BULK_VALUES_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},1003"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_BULK_PROPERTY_KEYS_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},1004"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_BULK_DEPTH_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},1005"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_BULK_PARENT_OBJECT_ID_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},1006"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_BULK_OBJECT_FORMAT_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},1007"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_BULK_WRITE_RESULTS_FMTID_PID As String = "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E},1008"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_DELETE_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},7"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_GET_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},4"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_GET_SUPPORTED_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},2"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_GET_ATTRIBUTES_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},3"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_GET_ALL_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},6"
Private Const WPD_COMMAND_OBJECT_PROPERTIES_SET_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},5"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_OBJECT_ID_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},1001"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_KEYS_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},1002"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_ATTRIBUTES_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},1003"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_VALUES_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},1004"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_WRITE_RESULTS_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},1005"
Private Const WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_DELETE_RESULTS_FMTID_PID As String = "{9E5582E4-0814-44E6-981A-B2998D583804},1006"
Private Const WPD_COMMAND_OBJECT_RESOURCES_CLOSE_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},7"
Private Const WPD_COMMAND_OBJECT_RESOURCES_CREATE_RESOURCE_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},9"
Private Const WPD_COMMAND_OBJECT_RESOURCES_DELETE_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},8"
Private Const WPD_COMMAND_OBJECT_RESOURCES_GET_ATTRIBUTES_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},3"
Private Const WPD_COMMAND_OBJECT_RESOURCES_GET_SUPPORTED_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},2"
Private Const WPD_COMMAND_OBJECT_RESOURCES_OPEN_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},4"
Private Const WPD_COMMAND_OBJECT_RESOURCES_READ_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},5"
Private Const WPD_COMMAND_OBJECT_RESOURCES_REVERT_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},10"
Private Const WPD_COMMAND_OBJECT_RESOURCES_SEEK_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},11"
Private Const WPD_COMMAND_OBJECT_RESOURCES_WRITE_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},6"
Private Const WPD_OPTION_OBJECT_RESOURCES_SEEK_ON_READ_SUPPORTED_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},5001"
Private Const WPD_OPTION_OBJECT_RESOURCES_SEEK_ON_WRITE_SUPPORTED_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},5002"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_ACCESS_MODE_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1002"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_CONTEXT_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1005"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_DATA_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1010"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_TO_READ_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1006"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_READ_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1007"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_TO_WRITE_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1008"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_WRITTEN_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1009"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_OBJECT_ID_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1001"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_OPTIMAL_TRANSFER_BUFFER_SIZE_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1011"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_POSITION_FROM_START_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1014"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_RESOURCE_KEYS_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1003"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_RESOURCE_ATTRIBUTES_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1004"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_SEEK_OFFSET_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1012"
Private Const WPD_PROPERTY_OBJECT_RESOURCES_SEEK_ORIGIN_FLAG_FMTID_PID As String = "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A},1013"
Private Const WPD_PROPERTY_PUBLIC_KEY_FMTID_PID As String = "{78f9c6fc-79b8-473c-9060-6bd23dd072c4},1001"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_SUPPORTED_METHODS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1001"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_FORMAT_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1002"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_METHOD_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1003"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_METHOD_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1004"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_PARAMETER_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1005"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_PARAMETER_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1006"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_FORMATS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1007"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_FORMAT_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1008"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_PROPERTY_KEYS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1009"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_PROPERTY_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1010"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_SUPPORTED_EVENTS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1011"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_EVENT_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1012"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_EVENT_ATTRIBUTES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1013"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_INHERITANCE_TYPE_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1014"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_INHERITED_SERVICES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1015"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_RENDERING_PROFILES_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1016"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_SUPPORTED_COMMANDS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1017"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_COMMAND_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1018"
Private Const WPD_PROPERTY_SERVICE_CAPABILITIES_COMMAND_OPTIONS_FMTID_PID As String = "{24457e74-2e9f-44f9-8c57-1d1bcb170b89},1019"
Private Const WPD_PROPERTY_SERVICE_METHOD_FMTID_PID As String = "{2d521ca8-c1b0-4268-a342-cf19321569bc},1001"
Private Const WPD_PROPERTY_SERVICE_METHOD_CONTEXT_FMTID_PID As String = "{2d521ca8-c1b0-4268-a342-cf19321569bc},1004"
Private Const WPD_PROPERTY_SERVICE_METHOD_HRESULT_FMTID_PID As String = "{2d521ca8-c1b0-4268-a342-cf19321569bc},1005"
Private Const WPD_PROPERTY_SERVICE_METHOD_PARAMETER_VALUES_FMTID_PID As String = "{2d521ca8-c1b0-4268-a342-cf19321569bc},1002"
Private Const WPD_PROPERTY_SERVICE_METHOD_RESULT_VALUES_FMTID_PID As String = "{2d521ca8-c1b0-4268-a342-cf19321569bc},1003"
Private Const WPD_PROPERTY_SERVICE_OBJECT_ID_FMTID_PID As String = "{322f071d-36ef-477f-b4b5-6f52d734baee},1001"
Private Const WPD_PROPERTY_SMS_BINARY_MESSAGE_FMTID_PID As String = "{afc25d66-fe0d-4114-9097-970c93e920d1},1004"
Private Const WPD_PROPERTY_SMS_MESSAGE_TYPE_FMTID_PID As String = "{afc25d66-fe0d-4114-9097-970c93e920d1},1002"
Private Const WPD_PROPERTY_SMS_RECIPIENT_FMTID_PID As String = "{afc25d66-fe0d-4114-9097-970c93e920d1},1001"
Private Const WPD_PROPERTY_SMS_TEXT_MESSAGE_FMTID_PID As String = "{afc25d66-fe0d-4114-9097-970c93e920d1},1003"
Private Const WPD_PROPERTY_STORAGE_DESTINATION_OBJECT_ID_FMTID_PID As String = "{d8f907a6-34cc-45fa-97fb-d007fa47ec94},1002"
Private Const WPD_PROPERTY_STORAGE_OBJECT_ID_FMTID_PID As String = "{d8f907a6-34cc-45fa-97fb-d007fa47ec94},1001"
Private Const WPD_RENDERING_INFORMATION_PROFILE_ENTRY_TYPE_FMTID_PID As String = "{c53d039f-ee23-4a31-8590-7639879870b4},3"
Private Const WPD_RENDERING_INFORMATION_PROFILE_ENTRY_CREATABLE_RESOURCES_FMTID_PID As String = "{c53d039f-ee23-4a31-8590-7639879870b4},4"
Private Const WPD_RENDERING_INFORMATION_PROFILES_FMTID_PID As String = "{c53d039f-ee23-4a31-8590-7639879870b4},2"
Private Const WPD_RESOURCE_ALBUM_ART_FMTID_PID As String = "{f02aa354-2300-4e2d-a1b9-3b6730f7fa21},0"
Private Const WPD_RESOURCE_ATTRIBUTE_CAN_DELETE_FMTID_PID As String = "{1eb6f604-9278-429f-93cc-5bb8c06656b6},5"
Private Const WPD_RESOURCE_ATTRIBUTE_CAN_READ_FMTID_PID As String = "{1eb6f604-9278-429f-93cc-5bb8c06656b6},3"
Private Const WPD_RESOURCE_ATTRIBUTE_CAN_WRITE_FMTID_PID As String = "{1eb6f604-9278-429f-93cc-5bb8c06656b6},4"
Private Const WPD_RESOURCE_ATTRIBUTE_FORMAT_FMTID_PID As String = "{1eb6f604-9278-429f-93cc-5bb8c06656b6},8"
Private Const WPD_RESOURCE_ATTRIBUTE_OPTIMAL_READ_BUFFER_SIZE_FMTID_PID As String = "{1eb6f604-9278-429f-93cc-5bb8c06656b6},6"
Private Const WPD_RESOURCE_ATTRIBUTE_OPTIMAL_WRITE_BUFFER_SIZE_FMTID_PID As String = "{1eb6f604-9278-429f-93cc-5bb8c06656b6},7"
Private Const WPD_RESOURCE_ATTRIBUTE_RESOURCE_KEY_FMTID_PID As String = "{1eb6f604-9278-429f-93cc-5bb8c06656b6},9"
Private Const WPD_RESOURCE_ATTRIBUTE_TOTAL_SIZE_FMTID_PID As String = "{1eb6f604-9278-429f-93cc-5bb8c06656b6},2"
Private Const WPD_RESOURCE_AUDIO_CLIP_FMTID_PID As String = "{3bc13982-85b1-48e0-95a6-8d3ad06be117},0"
Private Const WPD_RESOURCE_BRANDING_ART_FMTID_PID As String = "{b633b1ae-6caf-4a87-9589-22ded6dd5899},0"
Private Const WPD_RESOURCE_CONTACT_PHOTO_FMTID_PID As String = "{2c4d6803-80ea-4580-af9a-5be1a23eddcb},0"
Private Const WPD_RESOURCE_DEFAULT_FMTID_PID As String = "{e81e79be-34f0-41bf-b53f-f1a06ae87842},0"
Private Const WPD_RESOURCE_GENERIC_FMTID_PID As String = "{b9b9f515-ba70-4647-94dc-fa4925e95a07},0"
Private Const WPD_RESOURCE_ICON_FMTID_PID As String = "{f195fed8-aa28-4ee3-b153-e182dd5edc39},0"
Private Const WPD_RESOURCE_THUMBNAIL_FMTID_PID As String = "{c7c407ba-98fa-46b5-9960-23fec124cfde},0"
Private Const WPD_RESOURCE_VIDEO_CLIP_FMTID_PID As String = "{b566ee42-6368-4290-8662-70182fb79f20},0"
Private Const WPD_SECTION_DATA_LENGTH_FMTID_PID As String = "{516afd2b-c64e-44f0-98dc-bee1c88f7d66},3"
Private Const WPD_SECTION_DATA_OFFSET_FMTID_PID As String = "{516afd2b-c64e-44f0-98dc-bee1c88f7d66},2"
Private Const WPD_SECTION_DATA_REFERENCED_OBJECT_RESOURCE_FMTID_PID As String = "{516afd2b-c64e-44f0-98dc-bee1c88f7d66},5"
Private Const WPD_SECTION_DATA_UNITS_FMTID_PID As String = "{516afd2b-c64e-44f0-98dc-bee1c88f7d66},4"
Private Const WPD_SERVICE_VERSION_FMTID_PID As String = "{7510698a-cb54-481c-b8db-0d75c93f1c06},2"
Private Const WPD_SMS_ENCODING_FMTID_PID As String = "{7e1074cc-50ff-4dd1-a742-53be6f093a0d},5"
Private Const WPD_SMS_MAX_PAYLOAD_FMTID_PID As String = "{7e1074cc-50ff-4dd1-a742-53be6f093a0d},4"
Private Const WPD_SMS_PROVIDER_FMTID_PID As String = "{7e1074cc-50ff-4dd1-a742-53be6f093a0d},2"
Private Const WPD_SMS_TIMEOUT_FMTID_PID As String = "{7e1074cc-50ff-4dd1-a742-53be6f093a0d},3"
Private Const WPD_STILL_IMAGE_ARTIST_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},29"
Private Const WPD_STILL_IMAGE_BURST_INTERVAL_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},24"
Private Const WPD_STILL_IMAGE_BURST_NUMBER_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},23"
Private Const WPD_STILL_IMAGE_CAMERA_MANUFACTURER_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},31"
Private Const WPD_STILL_IMAGE_CAMERA_MODEL_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},30"
Private Const WPD_STILL_IMAGE_CAPTURE_DELAY_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},17"
Private Const WPD_STILL_IMAGE_CAPTURE_FORMAT_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},3"
Private Const WPD_STILL_IMAGE_CAPTURE_MODE_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},18"
Private Const WPD_STILL_IMAGE_CAPTURE_RESOLUTION_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},2"
Private Const WPD_STILL_IMAGE_COMPRESSION_SETTING_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},4"
Private Const WPD_STILL_IMAGE_CONTRAST_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},19"
Private Const WPD_STILL_IMAGE_DIGITAL_ZOOM_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},21"
Private Const WPD_STILL_IMAGE_EFFECT_MODE_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},22"
Private Const WPD_STILL_IMAGE_EXPOSURE_BIAS_COMPENSATION_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},16"
Private Const WPD_STILL_IMAGE_EXPOSURE_INDEX_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},15"
Private Const WPD_STILL_IMAGE_EXPOSURE_METERING_MODE_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},11"
Private Const WPD_STILL_IMAGE_EXPOSURE_PROGRAM_MODE_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},14"
Private Const WPD_STILL_IMAGE_EXPOSURE_TIME_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},13"
Private Const WPD_STILL_IMAGE_FLASH_MODE_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},12"
Private Const WPD_STILL_IMAGE_FNUMBER_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},7"
Private Const WPD_STILL_IMAGE_FOCAL_LENGTH_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},8"
Private Const WPD_STILL_IMAGE_FOCUS_DISTANCE_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},9"
Private Const WPD_STILL_IMAGE_FOCUS_METERING_MODE_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},27"
Private Const WPD_STILL_IMAGE_FOCUS_MODE_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},10"
Private Const WPD_STILL_IMAGE_RGB_GAIN_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},6"
Private Const WPD_STILL_IMAGE_SHARPNESS_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},20"
Private Const WPD_STILL_IMAGE_TIMELAPSE_INTERVAL_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},26"
Private Const WPD_STILL_IMAGE_TIMELAPSE_NUMBER_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},25"
Private Const WPD_STILL_IMAGE_UPLOAD_URL_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},28"
Private Const WPD_STILL_IMAGE_WHITE_BALANCE_FMTID_PID As String = "{58c571ec-1bcb-42a7-8ac5-bb291573a260},5"
Private Const WPD_STORAGE_ACCESS_CAPABILITY_FMTID_PID As String = "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A},11"
Private Const WPD_STORAGE_CAPACITY_FMTID_PID As String = "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A},4"
Private Const WPD_STORAGE_CAPACITY_IN_OBJECTS_FMTID_PID As String = "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A},10"
Private Const WPD_STORAGE_DESCRIPTION_FMTID_PID As String = "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A},7"
Private Const WPD_STORAGE_FILE_SYSTEM_TYPE_FMTID_PID As String = "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A},3"
Private Const WPD_STORAGE_FREE_SPACE_IN_BYTES_FMTID_PID As String = "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A},5"
Private Const WPD_STORAGE_FREE_SPACE_IN_OBJECTS_FMTID_PID As String = "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A},6"
Private Const WPD_STORAGE_MAX_OBJECT_SIZE_FMTID_PID As String = "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A},9"
Private Const WPD_STORAGE_SERIAL_NUMBER_FMTID_PID As String = "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A},8"
Private Const WPD_STORAGE_TYPE_FMTID_PID As String = "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A},2"
Private Const WPD_TASK_OWNER_FMTID_PID As String = "{e354e95e-d8a0-4637-a03a-0cb26838dbc7},11"
Private Const WPD_TASK_PERCENT_COMPLETE_FMTID_PID As String = "{e354e95e-d8a0-4637-a03a-0cb26838dbc7},8"
Private Const WPD_TASK_REMINDER_DATE_FMTID_PID As String = "{e354e95e-d8a0-4637-a03a-0cb26838dbc7},10"
Private Const WPD_TASK_STATUS_FMTID_PID As String = "{e354e95e-d8a0-4637-a03a-0cb26838dbc7},6"
Private Const WPD_VIDEO_AUTHOR_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},2"
Private Const WPD_VIDEO_BITRATE_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},13"
Private Const WPD_VIDEO_BUFFER_SIZE_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},8"
Private Const WPD_VIDEO_CREDITS_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},9"
Private Const WPD_VIDEO_FOURCC_CODE_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},14"
Private Const WPD_VIDEO_FRAMERATE_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},15"
Private Const WPD_VIDEO_KEY_FRAME_DISTANCE_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},10"
Private Const WPD_VIDEO_QUALITY_SETTING_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},11"
Private Const WPD_VIDEO_RECORDEDTV_CHANNEL_NUMBER_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},5"
Private Const WPD_VIDEO_RECORDEDTV_REPEAT_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},7"
Private Const WPD_VIDEO_RECORDEDTV_STATION_NAME_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},4"
Private Const WPD_VIDEO_SCAN_TYPE_FMTID_PID As String = "{346F2163-F998-4146-8B01-D19B4C00DE9A},12"
Private Const WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1_FMTID_PID As String = "{8F052D93-ABCA-4FC5-A5AC-B01DF4DBE598},2"


Public Enum DELETE_OBJECT_OPTIONS
    PORTABLE_DEVICE_DELETE_NO_RECURSION = 0
    PORTABLE_DEVICE_DELETE_WITH_RECURSION = 1
End Enum
  
Public Enum TagPropertyKey
    WPD_CLIENT_NAME
    WPD_CLIENT_MAJOR_VERSION
    WPD_CLIENT_MINOR_VERSION
    WPD_CLIENT_REVISION
    WPD_CLIENT_DESIRED_ACCESS
    
    WPD_DEVICE_SYNC_PARTNER
    WPD_DEVICE_FIRMWARE_VERSION
    WPD_DEVICE_POWER_LEVEL
    WPD_DEVICE_POWER_SOURCE
    WPD_DEVICE_PROTOCOL
    WPD_DEVICE_MANUFACTURER
    WPD_DEVICE_MODEL
    WPD_DEVICE_SERIAL_NUMBER
    WPD_DEVICE_SUPPORTS_NON_CONSUMABLE
    WPD_DEVICE_DATETIME
    WPD_DEVICE_FRIENDLY_NAME
    WPD_DEVICE_SUPPORTED_DRM_SCHEMES
    WPD_DEVICE_SUPPORTED_FORMATS_ARE_ORDERED
    WPD_DEVICE_TYPE
    WPD_DEVICE_NETWORK_IDENTIFIER
    WPD_DEVICE_FUNCTIONAL_UNIQUE_ID
    WPD_DEVICE_MODEL_UNIQUE_ID
    WPD_DEVICE_TRANSPORT
    WPD_DEVICE_USE_DEVICE_STAGE
    
    WPD_OBJECT_ID
    WPD_OBJECT_PARENT_ID
    WPD_OBJECT_NAME
    WPD_OBJECT_PERSISTENT_UNIQUE_ID
    WPD_OBJECT_FORMAT
    WPD_OBJECT_CONTENT_TYPE
    WPD_OBJECT_SIZE
    WPD_OBJECT_ORIGINAL_FILE_NAME
    WPD_OBJECT_DATE_CREATED
    WPD_OBJECT_DATE_MODIFIED
    
    WPD_PROPERTY_ATTRIBUTE_CAN_WRITE
    
    WPD_FUNCTIONAL_OBJECT_CATEGORY
    
    WPD_RESOURCE_DEFAULT
    WPD_RESOURCE_ATTRIBUTE_TOTAL_SIZE
    WPD_RESOURCE_ATTRIBUTE_FORMAT
    WPD_RESOURCE_ATTRIBUTE_RESOURCE_KEY
    WPD_RESOURCE_ATTRIBUTE_CAN_WRITE
    
    WPD_STORAGE_FREE_SPACE_IN_BYTES
    
    WPD_COMMAND_OBJECT_PROPERTIES_SET
    WPD_COMMAND_STILL_IMAGE_CAPTURE_INITIATE
    WPD_COMMAND_SMS_SEND
    WPD_COMMAND_STORAGE_FORMAT
    WPD_COMMAND_STORAGE_EJECT
    WPD_COMMAND_DEVICE_HINTS_GET_CONTENT_LOCATION
    WPD_COMMAND_COMMON_RESET_DEVICE
    
    WPD_PROPERTY_COMMON_COMMAND_CATEGORY
    WPD_PROPERTY_COMMON_COMMAND_ID
    WPD_PROPERTY_OBJECT_PROPERTIES_OBJECT_ID
    WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_VALUES
    
    WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1

End Enum

Public Enum tagSTREAM_SEEK
    STREAM_SEEK_SET = 0
    STREAM_SEEK_CUR = 1
    STREAM_SEEK_END = 2
End Enum

Public Enum STGC
    STGC_DEFAULT = 0&
    STGC_OVERWRITE = 1&
    STGC_ONLYIFCURRENT = 2&
    STGC_DANGEROUSLYCOMMITMERELYTODISKCACHE = 4&
    STGC_CONSOLIDATE = 8&
End Enum

Public Enum STGM
    STGM_FAILIFTHERE = 0
    STGM_DIRECT = 0
    STGM_READ = 0
    STGM_WRITE = 1
    STGM_READWRITE = 2
    STGM_SHARE_EXCLUSIVE = &H10
    STGM_SHARE_DENY_WRITE = &H20
    STGM_SHARE_DENY_READ = &H30
    STGM_SHARE_DENY_NONE = &H40
    STGM_CREATE = &H1000
    STGM_TRANSACTED = &H10000
    STGM_CONVERT = &H20000
    STGM_PRIORITY = &H40000
    STGM_NOSCRATCH = &H100000
    STGM_NOSNAPSHOT = &H200000
    STGM_DIRECT_SWMR = &H400000
    STGM_SIMPLE = &H8000000
    STGM_DELETEONRELEASE = &H4000000
End Enum

Public Enum STGTY
    STGTY_STORAGE = 1
    STGTY_STREAM = 2
    STGTY_LOCKBYTES = 3
    STGTY_PROPERTY = 4
End Enum

Public Enum STATFLAG
    STATFLAG_DEFAULT = 0
    STATFLAG_NONAME = 1
    STATFLAG_NOOPEN = 2
End Enum

Public Enum LOCKTYPE
    LOCK_WRITE = 1
    LOCK_EXCLUSIVE = 2
    LOCK_ONLYONCE = 4
End Enum

Public Type STATSTG
    atime As Currency
    cbSize As Currency
    clsid As GUID
    ctime As Currency
    grfLocksSupported As LOCKTYPE
    grfMode As STGM
    grfStateBits As Long
    mtime As Currency
    pwcsName As Long
    reserved As Long
    Type As STGTY
End Type

Public Declare Sub CopyMemory Lib "Kernel32" _
                   Alias "RtlMoveMemory" ( _
                   ByRef pTo As Any, _
                   ByRef uFrom As Any, _
                   ByVal lSize As Long)
                   
Private Declare Function lstrlenW Lib "Kernel32" ( _
                         ByVal lpString As Long) As Long

Private Declare Function CLSIDFromString Lib "ole32.dll" ( _
                         ByVal pString As Long, _
                         ByRef pClsid As GUID) As Long

Private Declare Function StringFromCLSID Lib "ole32.dll" ( _
                         ByRef pClsid As GUID, _
                         ByRef lpszProgID As Long) As Long

Public Function Guid2String(ByRef tGUID As GUID) As String

    Dim lGuid As Long

    Call StringFromCLSID(tGUID, lGuid)

    Guid2String = GetStringFromPointer(lGuid)

End Function

Public Function String2GUID(ByVal sConstName As String) As GUID
    
    Dim pStr As Long
    
    pStr = StrPtr(sConstName)
    Call CLSIDFromString(pStr, String2GUID)

End Function

Public Function GetGuidName(ByVal sValue As String) As String
    Dim sRet As String
    
    Select Case sValue
    
    Case "{38010000-AE6C-4804-98BA-C57B46965FE7}"
        sRet = "WPD_OBJECT_FORMAT_EXIF"
    
    Case "{30090000-AE6C-4804-98BA-C57B46965FE7}"
        sRet = "WPD_OBJECT_FORMAT_MP3"
    
    Case "{B9820000-AE6C-4804-98BA-C57B46965FE7}"
        sRet = "WPD_OBJECT_FORMAT_MP4"
        
    Case "{23F05BBC-15DE-4C2A-A55B-A9AF5CE412EF}"
        sRet = "WPD_FUNCTIONAL_CATEGORY_STORAGE"
    
    Case "{99ED0160-17FF-4C44-9D98-1D7A6F941921}"
        sRet = "WPD_CONTENT_TYPE_Functional_Object"

    Case "{27E2E392-A111-48E0-AB0C-E17705A05F85}"
        sRet = "WPD_CONTENT_TYPE_Folder"

    Case "{EF2107D5-A52A-4243-A26B-62D4176D7603}"
        sRet = "WPD_CONTENT_TYPE_Image"

    Case "{680ADF52-950A-4041-9B41-65E393648155}"
        sRet = "WPD_CONTENT_TYPE_Document"

    Case "{EABA8313-4525-4707-9F0E-87C6808E9435}"
        sRet = "WPD_CONTENT_TYPE_Contact"

    Case "{346B8932-4C36-40D8-9415-1828291F9DE9}"
        sRet = "WPD_CONTENT_TYPE_ContactGroup"

    Case "{4AD2C85E-5E2D-45E5-8864-4F229E3C6CF0}"
        sRet = "WPD_CONTENT_TYPE_Audio"

    Case "{9261B03C-3D78-4519-85E3-02C5E1F50BB9}"
        sRet = "WPD_CONTENT_TYPE_Video"

    Case "{60A169CF-F2AE-4E21-9375-9677F11C1C6E}"
        sRet = "WPD_CONTENT_TYPE_Television"

    Case "{1A33F7E4-AF13-48F5-994E-77369DFE04A3}"
        sRet = "WPD_CONTENT_TYPE_Playlist"

    Case "{00F0C3AC-A593-49AC-9219-24ABCA5A2563}"
        sRet = "WPD_CONTENT_TYPE_MixedContentAlbum"

    Case "{AA18737E-5009-48FA-AE21-85F24383B4E6}"
        sRet = "WPD_CONTENT_TYPE_AudioAlbum"

    Case "{75793148-15F5-4A30-A813-54ED8A37E226}"
        sRet = "WPD_CONTENT_TYPE_ImageAlbum"

    Case "{012B0DB7-D4C1-45D6-B081-94B87779614F}"
        sRet = "WPD_CONTENT_TYPE_VideoAlbum"

    Case "{9CD20ECF-3B50-414F-A641-E473FFE45751}"
        sRet = "WPD_CONTENT_TYPE_Memo"

    Case "{8038044A-7E51-4F8F-883D-1D0623D14533}"
        sRet = "WPD_CONTENT_TYPE_Email"

    Case "{0FED060E-8793-4B1E-90C9-48AC389AC631}"
        sRet = "WPD_CONTENT_TYPE_Appointment"

    Case "{63252F2C-887F-4CB6-B1AC-D29855DCEF6C}"
        sRet = "WPD_CONTENT_TYPE_Task"

    Case "{D269F96A-247C-4BFF-98FB-97F3C49220E6}"
        sRet = "WPD_CONTENT_TYPE_Program"

    Case "{0085E0A6-8D34-45D7-BC5C-447E59C73D48}"
        sRet = "WPD_CONTENT_TYPE_GenericFile"

    Case "{A1FD5967-6023-49A0-9DF1-F8060BE751B0}"
        sRet = "WPD_CONTENT_TYPE_Calendar"

    Case "{E80EAAF8-B2DB-4133-B67E-1BEF4B4A6E5F}"
        sRet = "WPD_CONTENT_TYPE_GenericMessage"

    Case "{031DA7EE-18C8-4205-847E-89A11261D0F3}"
        sRet = "WPD_CONTENT_TYPE_NetworkAssociation"

    Case "{DC3876E8-A948-4060-9050-CBD77E8A3D87}"
        sRet = "WPD_CONTENT_TYPE_Certificate"

    Case "{0BAC070A-9F5F-4DA4-A8F6-3DE44D68FD6C}"
        sRet = "WPD_CONTENT_TYPE_WirelessProfile"

    Case "{5E88B3CC-3E65-4E62-BFFF-229495253AB0}"
        sRet = "WPD_CONTENT_TYPE_MediaCast"

    Case "{821089F5-1D91-4DC9-BE3C-BBB1B35B18CE}"
        sRet = "WPD_CONTENT_TYPE_Section"

    Case "{28D8D31E-249C-454E-AABC-34883168E634}"
        sRet = "WPD_CONTENT_TYPE_Unspecified"

    Case "{80E170D2-1055-4A3E-B952-82CC4F8A8689}"
        sRet = "WPD_CONTENT_TYPE_All"

    Case "{30010000-AE6C-4804-98BA-C57B46965FE7}"
        sRet = "WPD_OBJECT_FORMAT_PROPERTIES_ONLY"

    Case "{08EA466B-E3A4-4336-A1F3-A44D2B5C438C}"
        sRet = "WPD_FUNCTIONAL_CATEGORY_DEVICE"

    Case "{30000000-AE6C-4804-98BA-C57B46965FE7}"
        sRet = "WPD_OBJECT_FORMAT_UNSPECIFIED"

    Case "{4D545058-1A2E-4106-A357-771E0819FC56}"
        sRet = "WPD_CATEGORY_MTP_EXT_VENDOR_OPERATIONS"
    
    Case Else

        sRet = "Unknown GUID: " & sValue
    
    End Select
    
    GetGuidName = sRet
    
End Function

Public Function GetStringFromPropertyKey(ByRef tPropertyKey As PropertyKey) As _
    String

    Dim sFMTID As String
    Dim lPID As Long
    Dim sRet As String

    sFMTID = Guid2String(tPropertyKey.fmtid)
    lPID = tPropertyKey.pid

    Select Case sFMTID
    
    Case "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8}"
        Select Case lPID

        Case 2
            sRet = "WPD_MEDIA_TOTAL_BITRATE"
        Case 3
            sRet = "WPD_MEDIA_BITRATE_TYPE"
        Case 4
            sRet = "WPD_MEDIA_COPYRIGHT"
        Case 5
            sRet = "WPD_MEDIA_SUBSCRIPTION_CONTENT_ID"
        Case 6
            sRet = "WPD_MEDIA_USE_COUNT"
        Case 7
            sRet = "WPD_MEDIA_SKIP_COUNT"
        Case 8
            sRet = "WPD_MEDIA_LAST_ACCESSED_TIME"
        Case 9
            sRet = "WPD_MEDIA_PARENTAL_RATING"
        Case 10
            sRet = "WPD_MEDIA_META_GENRE"
        Case 11
            sRet = "WPD_MEDIA_COMPOSER"
        Case 12
            sRet = "WPD_MEDIA_EFFECTIVE_RATING"
        Case 13
            sRet = "WPD_MEDIA_SUB_TITLE"
        Case 14
            sRet = "WPD_MEDIA_RELEASE_DATE"
        Case 15
            sRet = "WPD_MEDIA_SAMPLE_RATE"
        Case 16
            sRet = "WPD_MEDIA_STAR_RATING"
        Case 17
            sRet = "WPD_MEDIA_USER_EFFECTIVE_RATING"
        Case 18
            sRet = "WPD_MEDIA_TITLE"
        Case 19
            sRet = "WPD_MEDIA_DURATION"
        Case 20
            sRet = "WPD_MEDIA_BUY_NOW"
        Case 21
            sRet = "WPD_MEDIA_ENCODING_PROFILE"
        Case 22
            sRet = "WPD_MEDIA_WIDTH"
        Case 23
            sRet = "WPD_MEDIA_HEIGHT"
        Case 24
            sRet = "WPD_MEDIA_ARTIST"
        Case 25
            sRet = "WPD_MEDIA_ALBUM_ARTIST"
        Case 26
            sRet = "WPD_MEDIA_OWNER"
        Case 27
            sRet = "WPD_MEDIA_MANAGING_EDITOR"
        Case 28
            sRet = "WPD_MEDIA_WEBMASTER"
        Case 29
            sRet = "WPD_MEDIA_SOURCE_URL"
        Case 30
            sRet = "WPD_MEDIA_DESTINATION_URL"
        Case 31
            sRet = "WPD_MEDIA_DESCRIPTION"
        Case 32
            sRet = "WPD_MEDIA_GENRE"
        Case 33
            sRet = "WPD_MEDIA_TIME_BOOKMARK"
        Case 34
            sRet = "WPD_MEDIA_OBJECT_BOOKMARK"
        Case 35
            sRet = "WPD_MEDIA_LAST_BUILD_DATE"
        Case 36
            sRet = "WPD_MEDIA_BYTE_BOOKMARK"
        Case 37
            sRet = "WPD_MEDIA_TIME_TO_LIVE"
        Case 38
            sRet = "WPD_MEDIA_GUID"
        Case 39
            sRet = "WPD_MEDIA_SUB_DESCRIPTION"
        
        End Select
    
    Case "{346F2163-F998-4146-8B01-D19B4C00DE9A}"
        Select Case lPID

        Case 2
            sRet = "WPD_VIDEO_AUTHOR"
        Case 4
            sRet = "WPD_VIDEO_RECORDEDTV_STATION_NAME"
        Case 5
            sRet = "WPD_VIDEO_RECORDEDTV_CHANNEL_NUMBER"
        Case 7
            sRet = "WPD_VIDEO_RECORDEDTV_REPEAT"
        Case 8
            sRet = "WPD_VIDEO_BUFFER_SIZE"
        Case 9
            sRet = "WPD_VIDEO_CREDITS"
        Case 10
            sRet = "WPD_VIDEO_KEY_FRAME_DISTANCE"
        Case 11
            sRet = "WPD_VIDEO_QUALITY_SETTING"
        Case 12
            sRet = "WPD_VIDEO_SCAN_TYPE"
        Case 13
            sRet = "WPD_VIDEO_BITRATE"
        Case 14
            sRet = "WPD_VIDEO_FOURCC_CODE"
        Case 15
            sRet = "WPD_VIDEO_FRAMERATE"
    
        End Select
        
    Case "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6}"
        Select Case lPID

        Case 3
            sRet = "WPD_MUSIC_ALBUM"
        Case 4
            sRet = "WPD_MUSIC_TRACK"
        Case 6
            sRet = "WPD_MUSIC_LYRICS"
        Case 8
            sRet = "WPD_MUSIC_MOOD"
        Case 9
            sRet = "WPD_AUDIO_BITRATE"
        Case 10
            sRet = "WPD_AUDIO_CHANNEL_COUNT"
        Case 11
            sRet = "WPD_AUDIO_FORMAT_CODE"
        Case 12
            sRet = "WPD_AUDIO_BIT_DEPTH"
        Case 13
            sRet = "WPD_AUDIO_BLOCK_ALIGNMENT"
            
        End Select
    
    Case "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A}"
        Select Case lPID

        Case 2
            sRet = "WPD_STORAGE_TYPE"
        Case 3
            sRet = "WPD_STORAGE_FILE_SYSTEM_TYPE"
        Case 4
            sRet = "WPD_STORAGE_CAPACITY"
        Case 5
            sRet = "WPD_STORAGE_FREE_SPACE_IN_BYTES"
        Case 6
            sRet = "WPD_STORAGE_FREE_SPACE_IN_OBJECTS"
        Case 7
            sRet = "WPD_STORAGE_DESCRIPTION"
        Case 8
            sRet = "WPD_STORAGE_SERIAL_NUMBER"
        Case 9
            sRet = "WPD_STORAGE_MAX_OBJECT_SIZE"
        Case 10
            sRet = "WPD_STORAGE_CAPACITY_IN_OBJECTS"
        Case 11
            sRet = "WPD_STORAGE_ACCESS_CAPABILITY"
        
        End Select
    
    Case "{4D545058-1A2E-4106-A357-771E0819FC56}"
        Select Case lPID

        Case 11
            sRet = "WPD_COMMAND_MTP_EXT_GET_SUPPORTED_VENDOR_OPCODES"
        Case 12
            sRet = "WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITHOUT_DATA_PHASE"
        Case 13
            sRet = "WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITH_DATA_TO_READ"
        Case 14
            sRet = "WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITH_DATA_TO_WRITE"
        Case 15
            sRet = "WPD_COMMAND_MTP_EXT_READ_DATA"
        Case 16
            sRet = "WPD_COMMAND_MTP_EXT_WRITE_DATA"
        Case 17
            sRet = "WPD_COMMAND_MTP_EXT_END_DATA_TRANSFER"
        Case 18
            sRet = "WPD_COMMAND_MTP_EXT_GET_VENDOR_EXTENSION_DESCRIPTION"
        Case 1001
            sRet = "WPD_PROPERTY_MTP_EXT_OPERATION_CODE"
        Case 1002
            sRet = "WPD_PROPERTY_MTP_EXT_OPERATION_PARAMS"
        Case 1003
            sRet = "WPD_PROPERTY_MTP_EXT_RESPONSE_CODE"
        Case 1004
            sRet = "WPD_PROPERTY_MTP_EXT_RESPONSE_PARAMS"
        Case 1005
            sRet = "WPD_PROPERTY_MTP_EXT_VENDOR_OPERATION_CODES"
        Case 1006
            sRet = "WPD_PROPERTY_MTP_EXT_TRANSFER_CONTEXT"
        Case 1007
            sRet = "WPD_PROPERTY_MTP_EXT_TRANSFER_TOTAL_DATA_SIZE"
        Case 1008
            sRet = "WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_TO_READ"
        Case 1009
            sRet = "WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_READ"
        Case 1010
            sRet = "WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_TO_WRITE"
        Case 1011
            sRet = "WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_WRITTEN"
        Case 1012
            sRet = "WPD_PROPERTY_MTP_EXT_TRANSFER_DATA"
        Case 1013
            sRet = "WPD_PROPERTY_MTP_EXT_OPTIMAL_TRANSFER_BUFFER_SIZE"
        Case 1014
            sRet = "WPD_PROPERTY_MTP_EXT_VENDOR_EXTENSION_DESCRIPTION"
                
        End Select
    
    Case "{EF1E43DD-A9ED-4341-8BCC-186192AEA089}"
        Select Case lPID

        Case 2
            sRet = "WPD_COMMAND_OBJECT_MANAGEMENT_CREATE_OBJECT_WITH_PROPERTIES_ONLY"
        Case 3
            sRet = "WPD_COMMAND_OBJECT_MANAGEMENT_CREATE_OBJECT_WITH_PROPERTIES_AND_DATA"
        Case 4
            sRet = "WPD_COMMAND_OBJECT_MANAGEMENT_WRITE_OBJECT_DATA"
        Case 5
            sRet = "WPD_COMMAND_OBJECT_MANAGEMENT_COMMIT_OBJECT"
        Case 6
            sRet = "WPD_COMMAND_OBJECT_MANAGEMENT_REVERT_OBJECT"
        Case 7
            sRet = "WPD_COMMAND_OBJECT_MANAGEMENT_DELETE_OBJECTS"
        Case 8
            sRet = "WPD_COMMAND_OBJECT_MANAGEMENT_MOVE_OBJECTS"
        Case 9
            sRet = "WPD_COMMAND_OBJECT_MANAGEMENT_COPY_OBJECTS"
        Case 10
            sRet = "WPD_COMMAND_OBJECT_MANAGEMENT_UPDATE_OBJECT_WITH_PROPERTIES_AND_DATA"
        Case 1001
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_CREATION_PROPERTIES"
        Case 1002
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_CONTEXT"
        Case 1003
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_NUM_BYTES_TO_WRITE"
        Case 1004
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_NUM_BYTES_WRITTEN"
        Case 1005
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_DATA"
        Case 1006
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_OBJECT_ID"
        Case 1007
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_DELETE_OPTIONS"
        Case 1008
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_OPTIMAL_TRANSFER_BUFFER_SIZE"
        Case 1009
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_OBJECT_IDS"
        Case 1010
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_DELETE_RESULTS"
        Case 1011
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_DESTINATION_FOLDER_OBJECT_ID"
        Case 1012
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_MOVE_RESULTS"
        Case 1013
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_COPY_RESULTS"
        Case 1014
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_UPDATE_PROPERTIES"
        Case 1015
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_PROPERTY_KEYS"
        Case 1016
            sRet = "WPD_PROPERTY_OBJECT_MANAGEMENT_OBJECT_FORMAT"
        Case 5001
            sRet = "WPD_OPTION_OBJECT_MANAGEMENT_RECURSIVE_DELETE_SUPPORTED"
        End Select

    Case "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E}"
        Select Case lPID

        Case 2
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_LIST_START"
        Case 3
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_LIST_NEXT"
        Case 4
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_LIST_END"
        Case 5
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_FORMAT_START"
        Case 6
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_FORMAT_NEXT"
        Case 7
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_FORMAT_END"
        Case 8
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_BULK_SET_VALUES_BY_OBJECT_LIST_START"
        Case 9
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_BULK_SET_VALUES_BY_OBJECT_LIST_NEXT"
        Case 10
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_BULK_SET_VALUES_BY_OBJECT_LIST_END"
        Case 1001
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_OBJECT_IDS"
        Case 1002
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_CONTEXT"
        Case 1003
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_VALUES"
        Case 1004
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_PROPERTY_KEYS"
        Case 1005
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_DEPTH"
        Case 1006
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_PARENT_OBJECT_ID"
        Case 1007
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_OBJECT_FORMAT"
        Case 1008
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_WRITE_RESULTS"
        
        End Select
        
    Case "{0CABEC78-6B74-41C6-9216-2639D1FCE356}"
        Select Case lPID

        Case 2
            sRet = "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_COMMANDS"
        Case 3
            sRet = "WPD_COMMAND_CAPABILITIES_GET_COMMAND_OPTIONS"
        Case 4
            sRet = "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_FUNCTIONAL_CATEGORIES"
        Case 5
            sRet = "WPD_COMMAND_CAPABILITIES_GET_FUNCTIONAL_OBJECTS"
        Case 6
            sRet = "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_CONTENT_TYPES"
        Case 7
            sRet = "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_FORMATS"
        Case 8
            sRet = "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_FORMAT_PROPERTIES"
        Case 9
            sRet = "WPD_COMMAND_CAPABILITIES_GET_FIXED_PROPERTY_ATTRIBUTES"
        Case 10
            sRet = "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_EVENTS"
        Case 11
            sRet = "WPD_COMMAND_CAPABILITIES_GET_EVENT_OPTIONS"
        Case 1001
            sRet = "WPD_PROPERTY_CAPABILITIES_SUPPORTED_COMMANDS"
        Case 1002
            sRet = "WPD_PROPERTY_CAPABILITIES_COMMAND"
        Case 1003
            sRet = "WPD_PROPERTY_CAPABILITIES_COMMAND_OPTION"
        Case 1004
            sRet = "WPD_PROPERTY_CAPABILITIES_FUNCTIONAL_CATEGORIES"
        Case 1005
            sRet = "WPD_PROPERTY_CAPABILITIES_FUNCTIONAL_CATEGORY"
        Case 1006
            sRet = "WPD_PROPERTY_CAPABILITIES_FUNCTIONAL_OBJECTS"
        Case 1007
            sRet = "WPD_PROPERTY_CAPABILITIES_CONTENT_TYPES"
        Case 1008
            sRet = "WPD_PROPERTY_CAPABILITIES_CONTENT_TYPE"
        Case 1009
            sRet = "WPD_PROPERTY_CAPABILITIES_FORMATS"
        Case 1010
            sRet = "WPD_PROPERTY_CAPABILITIES_FORMAT"
        Case 1011
            sRet = "WPD_PROPERTY_CAPABILITIES_PROPERTY_KEYS"
        Case 1012
            sRet = "WPD_PROPERTY_CAPABILITIES_PROPERTY_ATTRIBUTES"
        Case 1013
            sRet = "WPD_PROPERTY_CAPABILITIES_SUPPORTED_EVENTS"
        Case 1014
            sRet = "WPD_PROPERTY_CAPABILITIES_EVENT"
        Case 1015
            sRet = "WPD_PROPERTY_CAPABILITIES_EVENT_OPTIONS"
        End Select
    
    Case "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A}"
        Select Case lPID

        Case 2
            sRet = "WPD_COMMAND_OBJECT_RESOURCES_GET_SUPPORTED"
        Case 3
            sRet = "WPD_COMMAND_OBJECT_RESOURCES_GET_ATTRIBUTES"
        Case 4
            sRet = "WPD_COMMAND_OBJECT_RESOURCES_OPEN"
        Case 5
            sRet = "WPD_COMMAND_OBJECT_RESOURCES_READ"
        Case 6
            sRet = "WPD_COMMAND_OBJECT_RESOURCES_WRITE"
        Case 7
            sRet = "WPD_COMMAND_OBJECT_RESOURCES_CLOSE"
        Case 8
            sRet = "WPD_COMMAND_OBJECT_RESOURCES_DELETE"
        Case 9
            sRet = "WPD_COMMAND_OBJECT_RESOURCES_CREATE_RESOURCE"
        Case 10
            sRet = "WPD_COMMAND_OBJECT_RESOURCES_REVERT"
        Case 11
            sRet = "WPD_COMMAND_OBJECT_RESOURCES_SEEK"
        Case 1001
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_OBJECT_ID"
        Case 1002
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_ACCESS_MODE"
        Case 1003
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_RESOURCE_KEYS"
        Case 1004
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_RESOURCE_ATTRIBUTES"
        Case 1005
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_CONTEXT"
        Case 1006
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_TO_READ"
        Case 1007
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_READ"
        Case 1008
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_TO_WRITE"
        Case 1009
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_WRITTEN"
        Case 1010
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_DATA"
        Case 1011
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_OPTIMAL_TRANSFER_BUFFER_SIZE"
        Case 1012
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_SEEK_OFFSET"
        Case 1013
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_SEEK_ORIGIN_FLAG"
        Case 1014
            sRet = "WPD_PROPERTY_OBJECT_RESOURCES_POSITION_FROM_START"
        Case 5001
            sRet = "WPD_OPTION_OBJECT_RESOURCES_SEEK_ON_READ_SUPPORTED"
        Case 5002
            sRet = "WPD_OPTION_OBJECT_RESOURCES_SEEK_ON_WRITE_SUPPORTED"
        End Select
        
    Case "{9E5582E4-0814-44E6-981A-B2998D583804}"
        Select Case lPID

        Case 2
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_GET_SUPPORTED"
    
        Case 3
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_GET_ATTRIBUTES"
    
        Case 4
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_GET"
    
        Case 5
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_SET"
    
        Case 6
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_GET_ALL"
    
        Case 7
            sRet = "WPD_COMMAND_OBJECT_PROPERTIES_DELETE"
    
        Case 1001
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_OBJECT_ID"
    
        Case 1002
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_KEYS"
    
        Case 1003
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_ATTRIBUTES"
    
        Case 1004
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_VALUES"
    
        Case 1005
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_WRITE_RESULTS"
    
        Case 1006
            sRet = "WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_DELETE_RESULTS"
    
        End Select
        
    Case "{B7474E91-E7F8-4AD9-B400-AD1A4B58EEEC}"
        Select Case lPID

        Case 2
            sRet = "WPD_COMMAND_OBJECT_ENUMERATION_START_FIND"
        
        Case 3
            sRet = "WPD_COMMAND_OBJECT_ENUMERATION_FIND_NEXT"
        
        Case 4
            sRet = "WPD_COMMAND_OBJECT_ENUMERATION_END"
        
        Case 1001
            sRet = "WPD_PROPERTY_OBJECT_ENUMERATION_PARENT"
        
        Case 1002
            sRet = "WPD_PROPERTY_OBJECT_ENUMERATION_FILTER"
        
        Case 1003
            sRet = "WPD_PROPERTY_OBJECT_ENUMERATION_OBJECT_IDS"
        
        Case 1004
            sRet = "WPD_PROPERTY_OBJECT_ENUMERATION_CONTEXT"
        
        Case 1005
            sRet = "WPD_PROPERTY_OBJECT_ENUMERATION_NUM_OBJECTS_REQUESTED"
        
        End Select
        
    Case "{26D4979A-E643-4626-9E2B-736DC0C92FDC}"

        Select Case lPID

        Case 2
            sRet = "WPD_DEVICE_SYNC_PARTNER"

        Case 3
            sRet = "WPD_DEVICE_FIRMWARE_VERSION"

        Case 4
            sRet = "WPD_DEVICE_POWER_LEVEL"

        Case 5
            sRet = "WPD_DEVICE_POWER_SOURCE"

        Case 6
            sRet = "WPD_DEVICE_PROTOCOL"

        Case 7
            sRet = "WPD_DEVICE_MANUFACTURER"

        Case 8
            sRet = "WPD_DEVICE_MODEL"

        Case 9
            sRet = "WPD_DEVICE_SERIAL_NUMBER"

        Case 10
            sRet = "WPD_DEVICE_SUPPORTS_NON_CONSUMABLE"

        Case 11
            sRet = "WPD_DEVICE_DATETIME"

        Case 12
            sRet = "WPD_DEVICE_FRIENDLY_NAME"

        Case 13
            sRet = "WPD_DEVICE_SUPPORTED_DRM_SCHEMES"

        Case 14
            sRet = "WPD_DEVICE_SUPPORTED_FORMATS_ARE_ORDERED"

        Case 15
            sRet = "WPD_DEVICE_TYPE"

        Case 16
            sRet = "WPD_DEVICE_NETWORK_IDENTIFIER"

        Case 17
            sRet = "WPD_DEVICE_NETWORK_IDENTIFIER"

        End Select

    Case "{463DD662-7FC4-4291-911C-7F4C9CCA9799}"

        Select Case lPID

        Case 2
            sRet = "WPD_DEVICE_FUNCTIONAL_UNIQUE_ID"

        Case 3
            sRet = "WPD_DEVICE_MODEL_UNIQUE_ID"

        Case 4
            sRet = "WPD_DEVICE_TRANSPORT"

        Case 5
            sRet = "WPD_DEVICE_USE_DEVICE_STAGE"

        End Select

    Case "{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}"

        Select Case lPID

        Case 2
            sRet = "WPD_OBJECT_ID"

        Case 3
            sRet = "WPD_OBJECT_PARENT_ID"

        Case 4
            sRet = "WPD_OBJECT_NAME"

        Case 5
            sRet = "WPD_OBJECT"

        Case 6
            sRet = "WPD_OBJECT_FORMAT"

        Case 7
            sRet = "WPD_OBJECT_CONTENT_TYPE"

        Case 9
            sRet = "WPD_OBJECT_ISHIDDEN"

        Case 10
            sRet = "WPD_OBJECT_ISSYSTEM"

        Case 11
            sRet = "WPD_OBJECT_SIZE"

        Case 12
            sRet = "WPD_OBJECT_ORIGINAL_FILE_NAME"

        Case 13
            sRet = "WPD_OBJECT_NON_CONSUMABLE"

        Case 14
            sRet = "WPD_OBJECT_REFERENCES"

        Case 15
            sRet = "WPD_OBJECT_KEYWORDS"

        Case 16
            sRet = "WPD_OBJECT_SYNC_ID"

        Case 17
            sRet = "WPD_OBJECT_IS_DRM_PROTECTED"

        Case 18
            sRet = "WPD_OBJECT_DATE_CREATED"

        Case 19
            sRet = "WPD_OBJECT_PROPERTIES_V1"

        Case 20
            sRet = "WPD_OBJECT_DATE_AUTHORED"

        Case 21
            sRet = "WPD_OBJECT_BACK_REFERENCES"

        Case 23
            sRet = "WPD_OBJECT_CONTAINER_FUNCTIONAL_OBJECT_ID"

        Case 24
            sRet = "WPD_OBJECT_GENERATE_THUMBNAIL_FROM_RESOURCE"

        Case 25
            sRet = "WPD_OBJECT_HINT_LOCATION_DISPLAY_NAME"

        Case 26
            sRet = "WPD_OBJECT_CAN_DELETE"

        Case 27
            sRet = "WPD_OBJECT_LANGUAGE_LOCALE"

        End Select

    Case "{8F052D93-ABCA-4FC5-A5AC-B01DF4DBE598}"

        Select Case lPID

        Case 2
            sRet = "WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1"

        End Select

    Case "{4D545058-8900-40B3-8F1D-DC246E1E8370}"
        sRet = "WPD_PROPERTIES_MTP_VENDOR_EXTENDED_OBJECT_PROPS"

    Case "{4D545058-4FCE-4578-95C8-8698A9BC0F49}"
        sRet = "WPD_PROPERTIES_MTP_VENDOR_EXTENDED_DEVICE_PROPS"

    Case Else

        sRet = GetGuidName(sFMTID) '"Unknown GUID: " & sFMTID

    End Select

    GetStringFromPropertyKey = sRet

End Function

Private Function SplitPropertyKey(ByVal sConstName As String) As PropertyKey
    
    Dim pStr As Long
    Dim aStr() As String
    aStr = Split(sConstName, ",")
    
    pStr = StrPtr(aStr(0))
    Call CLSIDFromString(pStr, SplitPropertyKey.fmtid)
    SplitPropertyKey.pid = CLng(aStr(1))

End Function

Public Function GetTagPropertyKey(ByVal tTagPropertyKey As TagPropertyKey) As _
    PropertyKey

    Dim pStr As Long
    Dim aStr() As String
    
    Select Case tTagPropertyKey

    Case TagPropertyKey.WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1
        GetTagPropertyKey = SplitPropertyKey(WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1_FMTID_PID)

    Case TagPropertyKey.WPD_CLIENT_NAME
        GetTagPropertyKey = SplitPropertyKey(WPD_CLIENT_NAME_FMTID_PID)
        
    Case TagPropertyKey.WPD_CLIENT_MAJOR_VERSION
        GetTagPropertyKey = SplitPropertyKey(WPD_CLIENT_MAJOR_VERSION_FMTID_PID)
    
    Case TagPropertyKey.WPD_CLIENT_MINOR_VERSION
        GetTagPropertyKey = SplitPropertyKey(WPD_CLIENT_MINOR_VERSION_FMTID_PID)

    Case TagPropertyKey.WPD_CLIENT_REVISION
        GetTagPropertyKey = SplitPropertyKey(WPD_CLIENT_REVISION_FMTID_PID)

    Case TagPropertyKey.WPD_CLIENT_DESIRED_ACCESS
        GetTagPropertyKey = SplitPropertyKey(WPD_CLIENT_DESIRED_ACCESS_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_SYNC_PARTNER
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_SYNC_PARTNER_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_FIRMWARE_VERSION
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_FIRMWARE_VERSION_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_POWER_LEVEL
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_POWER_LEVEL_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_POWER_SOURCE
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_POWER_SOURCE_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_PROTOCOL
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_PROTOCOL_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_MANUFACTURER
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_MANUFACTURER_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_MODEL
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_MODEL_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_SERIAL_NUMBER
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_SERIAL_NUMBER_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_SUPPORTS_NON_CONSUMABLE
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_SUPPORTS_NON_CONSUMABLE_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_DATETIME
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_DATETIME_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_FRIENDLY_NAME
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_FRIENDLY_NAME_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_SUPPORTED_DRM_SCHEMES
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_SUPPORTED_DRM_SCHEMES_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_SUPPORTED_FORMATS_ARE_ORDERED
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_SUPPORTED_FORMATS_ARE_ORDERED_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_TYPE
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_TYPE_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_NETWORK_IDENTIFIER
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_NETWORK_IDENTIFIER_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_FUNCTIONAL_UNIQUE_ID
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_FUNCTIONAL_UNIQUE_ID_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_MODEL_UNIQUE_ID
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_MODEL_UNIQUE_ID_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_TRANSPORT
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_TRANSPORT_FMTID_PID)

    Case TagPropertyKey.WPD_DEVICE_USE_DEVICE_STAGE
        GetTagPropertyKey = SplitPropertyKey(WPD_DEVICE_USE_DEVICE_STAGE_FMTID_PID)
    
    Case TagPropertyKey.WPD_OBJECT_ID
        GetTagPropertyKey = SplitPropertyKey(WPD_OBJECT_ID_FMTID_PID)

    Case TagPropertyKey.WPD_OBJECT_PARENT_ID
        GetTagPropertyKey = SplitPropertyKey(WPD_OBJECT_PARENT_ID_FMTID_PID)

    Case TagPropertyKey.WPD_OBJECT_NAME
        GetTagPropertyKey = SplitPropertyKey(WPD_OBJECT_NAME_FMTID_PID)

    Case TagPropertyKey.WPD_OBJECT_PERSISTENT_UNIQUE_ID
        GetTagPropertyKey = SplitPropertyKey(WPD_OBJECT_PERSISTENT_UNIQUE_ID_FMTID_PID)
    
    Case TagPropertyKey.WPD_OBJECT_FORMAT
        GetTagPropertyKey = SplitPropertyKey(WPD_OBJECT_FORMAT_FMTID_PID)

    Case TagPropertyKey.WPD_OBJECT_CONTENT_TYPE
        GetTagPropertyKey = SplitPropertyKey(WPD_OBJECT_CONTENT_TYPE_FMTID_PID)

    Case TagPropertyKey.WPD_OBJECT_SIZE
        GetTagPropertyKey = SplitPropertyKey(WPD_OBJECT_SIZE_FMTID_PID)

    Case TagPropertyKey.WPD_OBJECT_ORIGINAL_FILE_NAME
        GetTagPropertyKey = SplitPropertyKey(WPD_OBJECT_ORIGINAL_FILE_NAME_FMTID_PID)

    Case TagPropertyKey.WPD_OBJECT_DATE_CREATED
        GetTagPropertyKey = SplitPropertyKey(WPD_OBJECT_DATE_CREATED_FMTID_PID)

    Case TagPropertyKey.WPD_OBJECT_DATE_MODIFIED
        GetTagPropertyKey = SplitPropertyKey(WPD_OBJECT_DATE_MODIFIED_FMTID_PID)

    Case TagPropertyKey.WPD_FUNCTIONAL_OBJECT_CATEGORY
        GetTagPropertyKey = SplitPropertyKey(WPD_FUNCTIONAL_OBJECT_CATEGORY_FMTID_PID)

    Case TagPropertyKey.WPD_RESOURCE_DEFAULT
        GetTagPropertyKey = SplitPropertyKey(WPD_RESOURCE_DEFAULT_FMTID_PID)

    Case TagPropertyKey.WPD_RESOURCE_ATTRIBUTE_TOTAL_SIZE
        GetTagPropertyKey = SplitPropertyKey(WPD_RESOURCE_ATTRIBUTE_TOTAL_SIZE_FMTID_PID)
    
    Case TagPropertyKey.WPD_RESOURCE_ATTRIBUTE_FORMAT
        GetTagPropertyKey = SplitPropertyKey(WPD_RESOURCE_ATTRIBUTE_FORMAT_FMTID_PID)
    
    Case TagPropertyKey.WPD_RESOURCE_ATTRIBUTE_RESOURCE_KEY
        GetTagPropertyKey = SplitPropertyKey(WPD_RESOURCE_ATTRIBUTE_RESOURCE_KEY_FMTID_PID)
   
    Case TagPropertyKey.WPD_RESOURCE_ATTRIBUTE_CAN_WRITE
        GetTagPropertyKey = SplitPropertyKey(WPD_RESOURCE_ATTRIBUTE_CAN_WRITE_FMTID_PID)
       
    Case TagPropertyKey.WPD_STORAGE_FREE_SPACE_IN_BYTES
        GetTagPropertyKey = SplitPropertyKey(WPD_STORAGE_FREE_SPACE_IN_BYTES_FMTID_PID)

    Case TagPropertyKey.WPD_COMMAND_OBJECT_PROPERTIES_SET
        GetTagPropertyKey = SplitPropertyKey(WPD_COMMAND_OBJECT_PROPERTIES_SET_FMTID_PID)
    
    Case TagPropertyKey.WPD_PROPERTY_COMMON_COMMAND_CATEGORY
        GetTagPropertyKey = SplitPropertyKey(WPD_PROPERTY_COMMON_COMMAND_CATEGORY_FMTID_PID)
    
    Case TagPropertyKey.WPD_PROPERTY_COMMON_COMMAND_ID
        GetTagPropertyKey = SplitPropertyKey(WPD_PROPERTY_COMMON_COMMAND_ID_FMTID_PID)
    
    Case TagPropertyKey.WPD_PROPERTY_OBJECT_PROPERTIES_OBJECT_ID
        GetTagPropertyKey = SplitPropertyKey(WPD_PROPERTY_OBJECT_PROPERTIES_OBJECT_ID_FMTID_PID)
    
    Case TagPropertyKey.WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_VALUES
        GetTagPropertyKey = SplitPropertyKey(WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_VALUES_FMTID_PID)
    
    Case TagPropertyKey.WPD_PROPERTY_ATTRIBUTE_CAN_WRITE
        GetTagPropertyKey = SplitPropertyKey(WPD_PROPERTY_ATTRIBUTE_CAN_WRITE_FMTID_PID)
    
    Case TagPropertyKey.WPD_COMMAND_STILL_IMAGE_CAPTURE_INITIATE
        GetTagPropertyKey = SplitPropertyKey(WPD_COMMAND_STILL_IMAGE_CAPTURE_INITIATE_FMTID_PID)
    
    Case TagPropertyKey.WPD_COMMAND_SMS_SEND
        GetTagPropertyKey = SplitPropertyKey(WPD_COMMAND_SMS_SEND_FMTID_PID)
    
    Case TagPropertyKey.WPD_COMMAND_STORAGE_FORMAT
        GetTagPropertyKey = SplitPropertyKey(WPD_COMMAND_STORAGE_FORMAT_FMTID_PID)
    
    Case TagPropertyKey.WPD_COMMAND_STORAGE_EJECT
        GetTagPropertyKey = SplitPropertyKey(WPD_COMMAND_STORAGE_EJECT_FMTID_PID)
    
    Case TagPropertyKey.WPD_COMMAND_DEVICE_HINTS_GET_CONTENT_LOCATION
        GetTagPropertyKey = SplitPropertyKey(WPD_COMMAND_DEVICE_HINTS_GET_CONTENT_LOCATION_FMTID_PID)
    
    Case TagPropertyKey.WPD_COMMAND_COMMON_RESET_DEVICE
        GetTagPropertyKey = SplitPropertyKey(WPD_COMMAND_COMMON_RESET_DEVICE_FMTID_PID)
    
    End Select

End Function

Public Function GetStringFromPointer(ByVal lpStrPointer As Long) As String

    Dim lLen As Long
    Dim bBuffer() As Byte

    lLen = lstrlenW(lpStrPointer) * 2 - 1

    If lLen > 0 Then

        ReDim bBuffer(lLen)

        Call CopyMemory(bBuffer(0), ByVal lpStrPointer, lLen)
        
        Call CoTaskMemFree(lpStrPointer)

        GetStringFromPointer = bBuffer

    End If

End Function

