VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   945
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   2910
   LinkTopic       =   "Form1"
   ScaleHeight     =   945
   ScaleWidth      =   2910
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   525
      Left            =   90
      TabIndex        =   0
      Top             =   60
      Width           =   1395
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'http://157.56.25.106/en-us/library/dd388998(VS.85).aspx

'https://cgeers.wordpress.com/2011/05/22/enumerating-windows-portable-devices/
'https://cgeers.wordpress.com/2011/06/05/wpd-enumerating-content/
'https://cgeers.wordpress.com/2011/08/13/wpd-transferring-content/
'https://cgeers.wordpress.com/2012/04/17/wpd-transfer-content-to-a-device/
'https://cgeers.wordpress.com/2012/04/15/wpd-deleting-resources/

'https://msdn.microsoft.com/en-us/library/windows/desktop/dd319275(v=vs.85).aspx

Private cDevice As clsIPortableDevice
Private cDeviceValue As clsIPortableDeviceValues
Private cDeviceContent As clsIPortableDeviceContent
Private cDeviceProperties As clsIPortableDeviceProperties
Private cIEnumDeviceObjectIDs As clsIEnumPortableDeviceObjectIDs
Private cDeviceManager As clsIPortableDeviceManager

Private Type PDF
    PDFF_Id As String
    PDFF_Name As String
    PDFF_Type As String
    PDFF_ContentType As String
End Type

Private Type NeededFilesProperties
    FileName As String
    FileSize As Currency
End Type

Private Sub Command1_Click()
    
    Dim lItem As Long
    Dim lCount As Long
    Dim lDevIds() As Long
    Dim sDevID As String
    
    If Not cDeviceManager Is Nothing Then
        If cDeviceManager.RefreshDeviceList = True Then
            If cDeviceManager.GetDevices(lCount, lDevIds) = True Then
                If lCount > 0 Then
                    For lItem = 0 To lCount - 1
                        sDevID = vbNullString
                        sDevID = GetStringFromPointer(lDevIds(lItem))
                        
                            Debug.Print "DeviceID = " & sDevID
                            Debug.Print "DeviceFriendlyName = " & cDeviceManager.GetDeviceFriendlyName(sDevID)
                            Debug.Print "DeviceManufacturer = " & cDeviceManager.GetDeviceManufacturer(sDevID)
                            Debug.Print "DeviceDescription = " & cDeviceManager.GetDeviceDescription(sDevID)
                            Debug.Print
                            
                    Next lItem
                End If
            End If
        End If
    End If
    
    sDevID = "\\?\usb#vid_04e8&pid_6860#9885e64c5037514b35#{6ac27878-a6fa-4155-ba85-f98f491d4f33}"
    'sDevID = "\\?\wpdbusenumroot#umb#2&37c186b&0&storage#volume#_??_usbstor#disk&ven_kingston&prod_datatraveler_3.0&rev_pmap#50e549c34450ef60995c0c79&0##{6ac27878-a6fa-4155-ba85-f98f491d4f33}"
    
        If Not cDevice Is Nothing Then
            If Not cDeviceValue Is Nothing Then

'                Call cDeviceValue.SetStringValue(GetTagPropertyKey(WPD_CLIENT_NAME), "MyApplication")
'                Call cDeviceValue.SetStringValue(GetTagPropertyKey(WPD_CLIENT_MAJOR_VERSION), "1")
'                Call cDeviceValue.SetStringValue(GetTagPropertyKey(WPD_CLIENT_MINOR_VERSION), "0")
'                Call cDeviceValue.SetStringValue(GetTagPropertyKey(WPD_CLIENT_REVISION), "0")
'                Call cDeviceValue.SetStringValue(GetTagPropertyKey(WPD_CLIENT_DESIRED_ACCESS), CStr(GENERIC_ALL))



                If cDevice.OpenDevice(sDevID, cDeviceValue) = True Then

                    Set cDeviceContent = cDevice.Content
                    If Not cDeviceContent Is Nothing Then

                        'Call GetSupportedCommands(cDevice)

                        'Call GetSupportedProperties(cDeviceContent, WPD_DEVICE_OBJECT_ID)
                        'Call EnumerateContents(cDeviceContent, WPD_DEVICE_OBJECT_ID)

                        'Call GetSupportedProperties(cDeviceContent, "o1E8494")
                        'Call CopyFileFromDevice(cDeviceContent, "o1E8494", "C:\Users\schueler\Downloads\") ' <- File
                        'Call CreateFolderToDevice(cDeviceContent, "s10001", "Test") ' <- Create Folder
                        
                        Call CopyFileToDevice(cDeviceContent, "s10001", "C:\Users\schueler\Downloads\test.txt")     ' <- File

                        'Call DeleteContent(cDeviceContent, "o1E8497")          'funktioniert
                        'Call CopyContent(cDeviceContent, "o1E8497", "o1E8485") 'funktioniert
                        'Call MoveContent(cDeviceContent, "o1E8497", "o1E8485") 'funktioniert
                        'Call RenameContent(cDeviceContent, "o1E84A9", "Renamed.txt") 'funktioniert
                        'Call RenameContent2(cDevice, "o1E8498", "Renamed.jpg")  'funktioniert

                        'Call ResetDevice(cDevice)
                        'Call ContentLocation(cDevice)
                        'Call StorageEject(cDevice)
                        'Call StorageFormat(cDevice)
                        'Call SmsSend(cDevice)
                        'Call StillImageCapture(cDevice)

                        Set cDeviceContent = Nothing
                    End If
                    cDevice.CloseDevice
                End If
            End If
        End If
    
End Sub

Private Sub ResetDevice(ByVal Device As clsIPortableDevice)
    If GetSupportedCommand(Device, GetTagPropertyKey(WPD_COMMAND_COMMON_RESET_DEVICE)) = True Then
        Debug.Print "ResetDevice on this Device is supported"
    Else
        Debug.Print "ResetDevice on this Device not supported"
    End If
End Sub

Private Sub ContentLocation(ByVal Device As clsIPortableDevice)
    If GetSupportedCommand(Device, GetTagPropertyKey(WPD_COMMAND_DEVICE_HINTS_GET_CONTENT_LOCATION)) = True Then
        Debug.Print "ContentLocation on this Device is supported"
    Else
        Debug.Print "ContentLocation on this Device not supported"
    End If
End Sub

Private Sub StorageEject(ByVal Device As clsIPortableDevice)
    If GetSupportedCommand(Device, GetTagPropertyKey(WPD_COMMAND_STORAGE_EJECT)) = True Then
        Debug.Print "StorageEject on this Device is supported"
    Else
        Debug.Print "StorageEject on this Device not supported"
    End If
End Sub

Private Sub StorageFormat(ByVal Device As clsIPortableDevice)
    If GetSupportedCommand(Device, GetTagPropertyKey(WPD_COMMAND_STORAGE_FORMAT)) = True Then
        Debug.Print "StorageFormat on this Device is supported"
    Else
        Debug.Print "StorageFormat on this Device not supported"
    End If
End Sub

Private Sub StillImageCapture(ByVal Device As clsIPortableDevice)
    If GetSupportedCommand(Device, GetTagPropertyKey(WPD_COMMAND_STILL_IMAGE_CAPTURE_INITIATE)) = True Then
        Debug.Print "StillImageCapture on this Device is supported"
    Else
        Debug.Print "StillImageCapture on this Device not supported"
    End If
End Sub

Private Sub SmsSend(ByVal Device As clsIPortableDevice)
    If GetSupportedCommand(Device, GetTagPropertyKey(WPD_COMMAND_SMS_SEND)) = True Then
        Debug.Print "SmsSend on this Device is supported"
    Else
        Debug.Print "SmsSend on this Device not supported"
    End If
End Sub

Private Sub RenameContent(ByVal Content As clsIPortableDeviceContent, ByVal objectId As String, ByVal newName As String)
    
    Dim Prop As clsIPortableDeviceProperties
    Set Prop = Content.Properties
    
    If Not Prop Is Nothing Then
            
        Dim Attr As clsIPortableDeviceValues
        Set Attr = Prop.GetPropertyAttributes(objectId, GetTagPropertyKey(WPD_OBJECT_ORIGINAL_FILE_NAME))
        
        If Not Attr Is Nothing Then
        
            Dim bCanWrite As Boolean
            bCanWrite = Attr.GetBoolValue(GetTagPropertyKey(WPD_PROPERTY_ATTRIBUTE_CAN_WRITE))
            
            If bCanWrite = True Then
            
                Dim PropToWrite As New clsIPortableDeviceValues
                PropToWrite.Initialize
                
                If Not PropToWrite Is Nothing Then
                    
                    If PropToWrite.SetStringValue(GetTagPropertyKey(WPD_OBJECT_ORIGINAL_FILE_NAME), newName) = True Then
                    
                        Dim PropWriteResults As New clsIPortableDeviceValues
                        Set PropWriteResults = Prop.SetValues(objectId, PropToWrite)
                        
                        If Not PropWriteResults Is Nothing Then
                        
                            Debug.Print "Object '" & objectId & "' renamed to " & newName
                        
                            Set PropWriteResults = Nothing
                        End If
                
                    End If
                    
                    Set PropToWrite = Nothing
                End If
            
            End If
            
            Set Attr = Nothing
        End If
        
        Set Prop = Nothing
    End If
    
End Sub

Private Sub RenameContent2(ByVal Device As clsIPortableDevice, ByVal objectId As String, ByVal newName As String)

    'http://stackoverflow.com/questions/16102700/how-to-rename-an-object-on-a-wpd-device
    
    If GetSupportedCommand(Device, GetTagPropertyKey(WPD_COMMAND_OBJECT_PROPERTIES_SET)) = True Then
    
        Dim Properties As New clsIPortableDeviceValues
        Dim Values As New clsIPortableDeviceValues
        Call Properties.Initialize
        Call Values.Initialize
    
        If Not Properties Is Nothing Then
            If Not Values Is Nothing Then
    
                Call Properties.SetGuidValue(GetTagPropertyKey(WPD_PROPERTY_COMMON_COMMAND_CATEGORY), _
                    GetTagPropertyKey(WPD_COMMAND_OBJECT_PROPERTIES_SET).fmtid)
                
                Call Properties.SetUnsignedIntegerValue(GetTagPropertyKey(WPD_PROPERTY_COMMON_COMMAND_ID), _
                    GetTagPropertyKey(WPD_COMMAND_OBJECT_PROPERTIES_SET).pid)
                    
                Call Properties.SetStringValue(GetTagPropertyKey(WPD_PROPERTY_OBJECT_PROPERTIES_OBJECT_ID), objectId)
                
                Call Values.SetStringValue(GetTagPropertyKey(WPD_OBJECT_ORIGINAL_FILE_NAME), newName)
                
                Call Properties.SetIPortableDeviceValuesValue(GetTagPropertyKey(WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_VALUES), Values)
                
                Dim results As clsIPortableDeviceValues
                Set results = Device.SendCommand(Properties)
                
                If Not results Is Nothing Then
                                    
                    Debug.Print "Object '" & objectId & "' renamed to " & newName
                    
                    Set results = Nothing
                End If
                Set Values = Nothing
            End If
            Set Properties = Nothing
        End If
    End If

End Sub

Private Function GetSupportedCommand(ByVal Device As clsIPortableDevice, ByRef Command As PropertyKey) As Boolean

    Dim bRet As Boolean
    Dim devCapabilities As clsIPortableDeviceCapabilities
    Set devCapabilities = Device.Capabilities
    
    bRet = False
    
    If Not devCapabilities Is Nothing Then
        
        Dim devCommands As clsIPortableDeviceKeyCollection
        Set devCommands = devCapabilities.GetSupportedCommands
        
        If Not devCommands Is Nothing Then
            
            Dim lItem As Long
            Dim lCount As Long
            Dim tPropKey As PropertyKey
            lCount = devCommands.GetCount
           
            For lItem = 0 To lCount - 1
            
                tPropKey = devCommands.GetAt(lItem)
                
                If UCase$(Guid2String(tPropKey.fmtid)) = UCase$(Guid2String(Command.fmtid)) Then
                    If tPropKey.pid = Command.pid Then
                    
                        bRet = True
                        Exit For
                    End If
                End If
                
            Next lItem
            
            Set devCommands = Nothing
        End If
        Set devCapabilities = Nothing
    End If
    
    GetSupportedCommand = bRet
    
End Function


Private Sub GetSupportedCommands(ByVal Device As clsIPortableDevice)

    Dim devCapabilities As clsIPortableDeviceCapabilities
    Set devCapabilities = Device.Capabilities
    
    If Not devCapabilities Is Nothing Then
        
        Dim devCommands As clsIPortableDeviceKeyCollection
        Set devCommands = devCapabilities.GetSupportedCommands
        
        If Not devCommands Is Nothing Then
            
            Dim lItem As Long
            Dim lCount As Long
            Dim tPropKey As PropertyKey
            lCount = devCommands.GetCount
           
            Debug.Print "SupportedCommands = " & CStr(lCount)
            Debug.Print
           
            For lItem = 0 To lCount - 1
            
                tPropKey = devCommands.GetAt(lItem)
                
                Debug.Print "Command " & CStr(lItem + 1)
                Debug.Print "PropertyKey.FMTID = " & Guid2String(tPropKey.fmtid) & " = " & GetStringFromPropertyKey(tPropKey)
                Debug.Print "PropertyKey.PID = " & CStr(tPropKey.pid)
                Debug.Print
            
            Next lItem
            
            Set devCommands = Nothing
        End If
        Set devCapabilities = Nothing
    End If
    
End Sub

Private Sub DeleteContent(ByVal Content As clsIPortableDeviceContent, ByVal szObjectID As String)
    
    Dim ObjectsFailToDelete As clsIPortableDevicePropVariantCollection
    Dim ObjectsToDelete As clsIPortableDevicePropVariantCollection
    Set ObjectsToDelete = New clsIPortableDevicePropVariantCollection
    Call ObjectsToDelete.Initialize
    
    If Not ObjectsToDelete Is Nothing Then
        
        Dim pv As PropVariant
        pv.vt = VT_LPWSTR
        pv.pwszVal = StrPtr(szObjectID)
        
        If ObjectsToDelete.Add(pv) = True Then
        
            Set ObjectsFailToDelete = Content.Delete(PORTABLE_DEVICE_DELETE_NO_RECURSION, ObjectsToDelete)

            If Not ObjectsFailToDelete Is Nothing Then

                Debug.Print "Delete OK"

                Set ObjectsFailToDelete = Nothing
            End If
        End If
    
        Set ObjectsToDelete = Nothing
    End If
    
End Sub

Private Sub CopyContent(ByVal Content As clsIPortableDeviceContent, ByVal szObjectID As String, ByVal DestinationFolderObjectID As String)
    
    Dim ObjectsFailToCopy As clsIPortableDevicePropVariantCollection
    Dim ObjectsToCopy As clsIPortableDevicePropVariantCollection
    Set ObjectsToCopy = New clsIPortableDevicePropVariantCollection
    Call ObjectsToCopy.Initialize
    
    If Not ObjectsToCopy Is Nothing Then
        
        Dim pv As PropVariant
        pv.vt = VT_LPWSTR
        pv.pwszVal = StrPtr(szObjectID)
        
        If ObjectsToCopy.Add(pv) = True Then
        
            Set ObjectsFailToCopy = Content.Copy(ObjectsToCopy, DestinationFolderObjectID)
            
            If Not ObjectsFailToCopy Is Nothing Then
                
                Debug.Print "Copy OK"
                
                Set ObjectsFailToCopy = Nothing
            End If
        
        End If
        
        Set ObjectsToCopy = Nothing
    End If
    
End Sub

Private Sub MoveContent(ByVal Content As clsIPortableDeviceContent, ByVal szObjectID As String, ByVal DestinationFolderObjectID As String)
    
    Dim ObjectsFailToMove As clsIPortableDevicePropVariantCollection
    Dim ObjectsToMove As clsIPortableDevicePropVariantCollection
    Set ObjectsToMove = New clsIPortableDevicePropVariantCollection
    Call ObjectsToMove.Initialize
    
    If Not ObjectsToMove Is Nothing Then
    
        Dim pv As PropVariant
        pv.vt = VT_LPWSTR
        pv.pwszVal = StrPtr(szObjectID)
    
        If ObjectsToMove.Add(pv) = True Then
        
            Set ObjectsFailToMove = Content.Move(ObjectsToMove, DestinationFolderObjectID)
            
            If Not ObjectsFailToMove Is Nothing Then
                
                Debug.Print "Move OK"
                
                Set ObjectsFailToMove = Nothing
            End If
        End If
    
        
        Set ObjectsToMove = Nothing
    End If
    
End Sub

Private Sub CreateFolderToDevice(ByVal Content As clsIPortableDeviceContent, ByVal parentObjectId As String, ByVal Folder As String)

    Dim Values As New clsIPortableDeviceValues
    Values.Initialize
    
    If Not Values Is Nothing Then
    
        Call Values.SetStringValue(GetTagPropertyKey(WPD_OBJECT_PARENT_ID), parentObjectId)
        Call Values.SetStringValue(GetTagPropertyKey(WPD_OBJECT_NAME), Folder)
        Call Values.SetStringValue(GetTagPropertyKey(WPD_OBJECT_ORIGINAL_FILE_NAME), Folder)
        Call Values.SetGuidValue(GetTagPropertyKey(WPD_OBJECT_CONTENT_TYPE), String2GUID(WPD_CONTENT_TYPE_FOLDER))
        
        Dim szObjectID As String
        
        szObjectID = Content.CreateObjectWithPropertiesOnly(Values)
        If szObjectID <> vbNullString Then
            Debug.Print "Folder: " & Folder & " created with OjectId = " & szObjectID
        End If
        
        Set Values = Nothing
    End If

End Sub

Private Sub CopyFileToDevice(ByVal Content As clsIPortableDeviceContent, ByVal _
    parentObjectId As String, ByVal CopyFrom As String)

    Dim Values As clsIPortableDeviceValues
    Set Values = New clsIPortableDeviceValues
    Values.Initialize

    If Not Values Is Nothing Then

        Dim aFN() As String
        Dim sFileName As String
        Dim sFileNameWithoutExt As String
        Dim lFileSize As Long
        Dim cFileSize As Currency

        aFN = Split(CopyFrom, "\")
        sFileName = aFN(UBound(aFN))

        aFN = Split(sFileName, ".")
        sFileNameWithoutExt = aFN(0)

        Dim fileStreamIn As clsIStream

        Set fileStreamIn = GetFileStream(CopyFrom, STGM_READ)

        If Not fileStreamIn Is Nothing Then
            
            cFileSize = fileStreamIn.Seek_Stream(0, STREAM_SEEK_END)

            lFileSize = CLng(cFileSize * 10000)

            Call fileStreamIn.Seek_Stream(0, STREAM_SEEK_SET)

            Debug.Print "FileName = " & sFileName
            Debug.Print "FileSize = " & CStr(lFileSize)

            Call Values.SetStringValue(GetTagPropertyKey(WPD_OBJECT_PARENT_ID), parentObjectId)
            Call Values.SetStringValue(GetTagPropertyKey(WPD_OBJECT_ORIGINAL_FILE_NAME), sFileName)
            Call Values.SetStringValue(GetTagPropertyKey(WPD_OBJECT_NAME), sFileNameWithoutExt)
            Call Values.SetUnsignedLargeIntegerValue(GetTagPropertyKey(WPD_OBJECT_SIZE), cFileSize)
            'Call Values.SetGuidValue(GetTagPropertyKey(WPD_OBJECT_FORMAT), String2GUID(WPD_OBJECT_FORMAT_UNSPECIFIED))
            'Call Values.SetGuidValue(GetTagPropertyKey(WPD_OBJECT_CONTENT_TYPE), String2GUID(WPD_CONTENT_TYPE_UNSPECIFIED))

            Dim optimalTransferSize As Long
            Dim cookie As String

            optimalTransferSize = 0
            cookie = vbNullString

            Dim wpdStream As clsIStream
            Set wpdStream = Content.CreateObjectWithPropertiesAndData(Values, optimalTransferSize, cookie)

            If Not wpdStream Is Nothing Then

                    Debug.Print "optimalTransferSize = " & CStr(optimalTransferSize)
                    Debug.Print "Cookie = " & cookie

                    Dim lFileRead As Long
                    Dim lFileWrite As Long

                    If lFileSize <= optimalTransferSize Then

                        Debug.Print "fileStreamIn.CopyTo"

                        If fileStreamIn.CopyTo(wpdStream.GetInterfacePtr, lFileSize, lFileRead, lFileWrite) = True Then

                            Debug.Print "CopyFileToDevice is ready. FileSize = " & CStr(lFileSize)
                            Debug.Print "CopyFileToDevice is ready. FileRead = " & CStr(lFileRead)
                            Debug.Print "CopyFileToDevice is ready. FileWrite = " & CStr(lFileWrite)

                        End If

                    Else

                        Dim CopyBuff As Long

                        CopyBuff = optimalTransferSize

                        Dim lItem As Long
                        Dim lCount As Long
                        Dim lLast As Long

                        lCount = lFileSize \ CopyBuff
                        lLast = lFileSize - (lCount * CopyBuff)

                        For lItem = 0 To lCount - 1

                            If fileStreamIn.CopyTo(wpdStream.GetInterfacePtr, CopyBuff, lFileRead, lFileWrite) = True Then

                            End If

                        Next lItem

                        If fileStreamIn.CopyTo(wpdStream.GetInterfacePtr, lLast, lFileRead, lFileWrite) = True Then

                        End If

                    End If

                    Debug.Print "Commit"

                    If wpdStream.Commit(STGC_DEFAULT) = True Then

                        Debug.Print "CopyFileToDevice is ready"
                        

                    End If

                    Set wpdStream = Nothing

                End If

            Set fileStreamIn = Nothing

        End If

        Set Values = Nothing

    End If

End Sub

Private Sub CopyFileFromDevice(ByVal Content As clsIPortableDeviceContent, ByVal objectId As String, ByVal CopyTo As String)

    Dim tNeededFilesProperties As NeededFilesProperties
    tNeededFilesProperties = GetNeededFilesProperties(Content, objectId)
    
    Dim resources As clsIPortableDeviceResources
    Set resources = Content.Transfer
    If Not resources Is Nothing Then
    
        Dim property As PropertyKey
        property = GetTagPropertyKey(WPD_RESOURCE_DEFAULT)
        
        Dim optimalTransferSize As Long
        optimalTransferSize = 0
        
        Dim wpdStream As clsIStream
        Set wpdStream = resources.GetStream(objectId, property, STGM_READ, optimalTransferSize)
        
        Debug.Print "optimalTransferSize = " & CStr(optimalTransferSize)
        
        If Not wpdStream Is Nothing Then
        
            Dim bBuffer() As Byte
            Dim FNr As Long
            FNr = FreeFile
            
            Open CopyTo & tNeededFilesProperties.FileName For Binary As #FNr
            
            If tNeededFilesProperties.FileSize <= CCur(optimalTransferSize) Then
                ReDim bBuffer(tNeededFilesProperties.FileSize - 1)
                If wpdStream.Read_Stream(bBuffer, tNeededFilesProperties.FileSize) = tNeededFilesProperties.FileSize Then
                    Put #FNr, , bBuffer
                    Debug.Print "CopyFileFromDevice is ready"
                End If
            Else
                
                Dim CopyBuff As Currency
                CopyBuff = optimalTransferSize
                
                Dim lItem As Long
                Dim lCount As Long
                Dim lLast As Long
                
                lCount = tNeededFilesProperties.FileSize \ CopyBuff
                lLast = tNeededFilesProperties.FileSize - (lCount * CopyBuff)
                
                ReDim bBuffer(CopyBuff - 1)
                For lItem = 0 To lCount - 1
                    If wpdStream.Read_Stream(bBuffer, CopyBuff) = CopyBuff Then
                        Put #FNr, , bBuffer
                    End If
                Next lItem
                
                ReDim bBuffer(lLast - 1)
                If wpdStream.Read_Stream(bBuffer, lLast) = lLast Then
                    Put #FNr, , bBuffer
                    Debug.Print "CopyFileFromDevice is ready"
                End If
            
            End If
            
            Close #FNr
            
            Set wpdStream = Nothing
        End If
        Set resources = Nothing
    End If
    
    
End Sub

Private Function GetNeededFilesProperties(ByVal Content As clsIPortableDeviceContent, ByVal szObjectID As String) As NeededFilesProperties
    
    Dim tNeededFilesProperties As NeededFilesProperties
    Dim Properties As clsIPortableDeviceProperties
    Set Properties = Content.Properties
    If Not Properties Is Nothing Then
        
        Dim propKey As New clsIPortableDeviceKeyCollection
        Call propKey.Initialize
        If Not propKey Is Nothing Then

            Call propKey.Add(GetTagPropertyKey(WPD_OBJECT_NAME))
            Call propKey.Add(GetTagPropertyKey(WPD_OBJECT_SIZE))

            Dim propertyValues As clsIPortableDeviceValues
            Set propertyValues = Properties.GetValues(szObjectID, propKey)
            If Not propertyValues Is Nothing Then

                tNeededFilesProperties.FileName = propertyValues.GetStringValue(GetTagPropertyKey(WPD_OBJECT_NAME))
                tNeededFilesProperties.FileSize = CCur(propertyValues.GetStringValue(GetTagPropertyKey(WPD_OBJECT_SIZE)))
                    
                Set propertyValues = Nothing
            End If

            Set propKey = Nothing
        End If
        
        Set Properties = Nothing
    End If
    
    GetNeededFilesProperties = tNeededFilesProperties
End Function

Private Sub GetSupportedProperty(ByVal Content As clsIPortableDeviceContent, ByVal szObjectID As String, ByRef Keys() As PropertyKey)

    Dim lItem As Long
    Dim lCount As Long
    Dim Properties As clsIPortableDeviceProperties
    Set Properties = Content.Properties
    If Not Properties Is Nothing Then
        
        Dim propKey As New clsIPortableDeviceKeyCollection
        Call propKey.Initialize
        If Not propKey Is Nothing Then
            
            lCount = UBound(Keys)
            
            For lItem = 0 To lCount - 1
            
                Call propKey.Add(Keys(lItem))
            
            Next lItem

            Dim propertyValues As clsIPortableDeviceValues
            Set propertyValues = Properties.GetValues(szObjectID, propKey)
            If Not propertyValues Is Nothing Then
                
                For lItem = 0 To lCount - 1
                    If Mid$(propertyValues.GetStringValue(Keys(lItem)), 1, 1) = "{" Then
                        Debug.Print CStr(lItem + 1) & ": " & "IPortableDeviceValues.GetStringValue " & GetStringFromPropertyKey(Keys(lItem)) & " = " & GetGuidName(propertyValues.GetStringValue(Keys(lItem)))
                    Else
                        Debug.Print CStr(lItem + 1) & ": " & "IPortableDeviceValues.GetStringValue " & GetStringFromPropertyKey(Keys(lItem)) & " = " & propertyValues.GetStringValue(Keys(lItem))
                    End If
                Next lItem
                    
                Set propertyValues = Nothing
            End If

            Set propKey = Nothing
        End If
        
        Set Properties = Nothing
    End If

End Sub

Private Sub GetSupportedProperties(ByVal Content As clsIPortableDeviceContent, ByVal szObjectID As String)

    Dim lItem As Long
    Dim lCount As Long
    Dim tPropKey() As PropertyKey

    Dim Properties As clsIPortableDeviceProperties
    Set Properties = Content.Properties
    If Not Properties Is Nothing Then
        
        Dim propKeyCol As clsIPortableDeviceKeyCollection
        Set propKeyCol = Properties.GetSupportedProperties(szObjectID)
        If Not propKeyCol Is Nothing Then
            
            lCount = propKeyCol.GetCount
            
            ReDim tPropKey(lCount - 1)
            
                Debug.Print
                Debug.Print "Supported Properties = " & CStr(lCount)
                Debug.Print
            
                For lItem = 0 To lCount - 1
                    tPropKey(lItem) = propKeyCol.GetAt(lItem)
                    Debug.Print "PropertyIndex = " & CStr(lItem + 1)
                    Debug.Print "PropertyKey.FMTID = " & Guid2String(tPropKey(lItem).fmtid) & " = " & GetStringFromPropertyKey(tPropKey(lItem))
                    Debug.Print "PropertyKey.PID = " & CStr(tPropKey(lItem).pid)
                    Debug.Print
                Next lItem
            
            Set propKeyCol = Nothing
        End If
        
        Set Properties = Nothing
    End If
    
    Call GetSupportedProperty(Content, szObjectID, tPropKey)
    
End Sub

Private Sub EnumerateContents(ByVal Content As clsIPortableDeviceContent, ByVal _
    parent As String)
    
    Dim currentObject As PDF
    Dim Properties As clsIPortableDeviceProperties
    Set Properties = Content.Properties
    If Not Properties Is Nothing Then

        Dim ObjectIDs As clsIEnumPortableDeviceObjectIDs
        Set ObjectIDs = Content.EnumObjects(parent)
        If Not ObjectIDs Is Nothing Then

            Dim aObjIDs() As Long
            Dim lFetched As Long
            Dim sObjID As String
            
            Do

                If ObjectIDs.NextObject(1, aObjIDs, lFetched) = True _
                    Then

                    If lFetched > 0 Then

                        sObjID = GetStringFromPointer(aObjIDs(0))
                        
                        currentObject = WrapObject(Properties, sObjID)
                        
                        If LCase$(currentObject.PDFF_Id) <> "renderinginformation" Then
                        
                        If currentObject.PDFF_Type = "Storage" Then
                            Debug.Print "Storage = " & currentObject.PDFF_Name & " (" & currentObject.PDFF_Id & ")"
                        End If
                        
                        If currentObject.PDFF_Type = "Folder" Then
                            Debug.Print "Folder = "; currentObject.PDFF_Name & " (" & currentObject.PDFF_Id & ")"
                        End If
                        
                        If currentObject.PDFF_Type = "File" Then
                            Debug.Print "File = "; currentObject.PDFF_Name & " (" & currentObject.PDFF_Id & ")"
                        End If
                        
                        End If
                        
                        If currentObject.PDFF_Type <> "Folder" Then

                            Call EnumerateContents(Content, sObjID)

                        End If

                    End If
                End If

            Loop While lFetched > 0

            Set ObjectIDs = Nothing

        End If

        Set Properties = Nothing

    End If

End Sub

Private Function WrapObject(ByVal Properties As clsIPortableDeviceProperties, ByVal objectId As String) As PDF
    
    Dim tRet As PDF
    Dim Keys As clsIPortableDeviceKeyCollection
    Dim Values As clsIPortableDeviceValues
    Dim Name As String
    Dim sTmp As String
    Dim property As PropertyKey
    Dim contentType As GUID
    
    Set Keys = Properties.GetSupportedProperties(objectId)
    If Not Keys Is Nothing Then

        Set Values = Properties.GetValues(objectId, Keys)
        If Not Values Is Nothing Then
    
            property = GetTagPropertyKey(WPD_OBJECT_NAME)
            Name = Values.GetStringValue(property)
        
            property = GetTagPropertyKey(WPD_OBJECT_CONTENT_TYPE)
            contentType = Values.GetGuidValue(property)
            
            sTmp = Guid2String(contentType)
            tRet.PDFF_ContentType = sTmp
        
            If OrElse_Str(sTmp, WPD_CONTENT_TYPE_FOLDER, WPD_CONTENT_TYPE_FUNCTIONAL_OBJECT) Then
            
                'return new PortableDeviceFolder(objectId, name)
                tRet.PDFF_Id = objectId
                tRet.PDFF_Name = Name
                tRet.PDFF_Type = "Folder"
            Else
            
                'return new PortableDeviceFile(objectId, name)
                tRet.PDFF_Id = objectId
                tRet.PDFF_Name = Name
                tRet.PDFF_Type = "File"
            End If
            
            Set Values = Nothing
        Else
            
            tRet.PDFF_Id = objectId
            tRet.PDFF_Name = objectId
            tRet.PDFF_Type = "Storage"

        End If
        Set Keys = Nothing
    End If
    
    WrapObject = tRet
    
End Function

Private Sub Form_Load()
    
    Set cDeviceManager = New clsIPortableDeviceManager
    Set cDevice = New clsIPortableDevice
    Set cDeviceValue = New clsIPortableDeviceValues
    
    Call cDeviceManager.Initialize
    Call cDevice.Initialize
    Call cDeviceValue.Initialize

End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    Set cDeviceValue = Nothing
    Set cDevice = Nothing
    Set cDeviceManager = Nothing

End Sub

