VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPortableDeviceContent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Const CLSID_PortableDeviceContent As String = ""

Private Const IID_IPortableDeviceContent As String = _
    "{6A96ED84-7C73-4480-9938-BF5AF477D426}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_EnumObjects
    vtb_Properties
    vtb_Transfer
    vtb_CreateObjectWithPropertiesOnly
    vtb_CreateObjectWithPropertiesAndData
    vtb_Delete
    vtb_GetObjectIDsFromPersistentUniqueIDs
    vtb_Cancel
    vtb_Move
    vtb_Copy
End Enum

Public Function GetInterfacePtr() As Long

    GetInterfacePtr = m_Interface.ifc

End Function

Public Function EnumObjects(ByVal szParentObjectID As String) As _
    clsIEnumPortableDeviceObjectIDs

    Dim dwFlags As Long
    Dim pFilter As Long
    Dim pEnum As Long
    Dim ppEnum As Long
    Dim pszParentObjectID As Long
    Dim IEnumPortableDeviceObjectIDs As clsIEnumPortableDeviceObjectIDs

    dwFlags = 0&
    pFilter = 0&

    ppEnum = VarPtr(pEnum)

    pszParentObjectID = StrPtr(szParentObjectID)

    If x_OleInvoke(vtb_EnumObjects, dwFlags, pszParentObjectID, pFilter, ppEnum) _
        Then

        Set IEnumPortableDeviceObjectIDs = New clsIEnumPortableDeviceObjectIDs

        Call IEnumPortableDeviceObjectIDs.Initialize(pEnum)

    End If

    Set EnumObjects = IEnumPortableDeviceObjectIDs

End Function

Public Function Properties() As clsIPortableDeviceProperties

    Dim pProperties As Long
    Dim ppProperties As Long
    Dim IPortableDeviceProperties As clsIPortableDeviceProperties

    ppProperties = VarPtr(pProperties)

    If x_OleInvoke(vtb_Properties, ppProperties) Then

        Set IPortableDeviceProperties = New clsIPortableDeviceProperties

        Call IPortableDeviceProperties.Initialize(pProperties)

    End If

    Set Properties = IPortableDeviceProperties

End Function

Public Function Transfer() As clsIPortableDeviceResources

    Dim pResources As Long
    Dim ppResources As Long
    Dim IPortableDeviceResources As clsIPortableDeviceResources

    ppResources = VarPtr(pResources)

    If x_OleInvoke(vtb_Transfer, ppResources) Then

        Set IPortableDeviceResources = New clsIPortableDeviceResources

        Call IPortableDeviceResources.Initialize(pResources)

    End If

    Set Transfer = IPortableDeviceResources

End Function

Public Function CreateObjectWithPropertiesOnly(ByVal cValues As _
    clsIPortableDeviceValues) As String

    Dim sRet As String
    Dim pszObjectID As Long
    Dim ppszObjectID As Long

    ppszObjectID = VarPtr(pszObjectID)

    If x_OleInvoke(vtb_CreateObjectWithPropertiesOnly, cValues.GetInterfacePtr, _
        ppszObjectID) Then

        sRet = GetStringFromPointer(pszObjectID)

    End If

    CreateObjectWithPropertiesOnly = sRet

End Function

Public Function CreateObjectWithPropertiesAndData(ByVal cValues As _
    clsIPortableDeviceValues, ByRef dwOptimalWriteBufferSize As Long, ByRef _
    szCookie As String) As clsIStream

    Dim pszCookie As Long
    Dim ppszCookie As Long
    Dim pdwOptimalWriteBufferSize As Long
    Dim pData As Long
    Dim ppData As Long
    Dim IStream As clsIStream

    ppszCookie = VarPtr(pszCookie)
    pdwOptimalWriteBufferSize = VarPtr(dwOptimalWriteBufferSize)
    
    ppData = VarPtr(pData)

    If x_OleInvoke(vtb_CreateObjectWithPropertiesAndData, cValues.GetInterfacePtr, _
        ppData, pdwOptimalWriteBufferSize, ppszCookie) Then
        
        Set IStream = New clsIStream
        Call IStream.Initialize(pData)

    End If

    szCookie = GetStringFromPointer(pszCookie)
    
    Set CreateObjectWithPropertiesAndData = IStream

End Function

Public Function Delete(ByVal dwOptions As DELETE_OBJECT_OPTIONS, ByVal ObjectIDs _
    As clsIPortableDevicePropVariantCollection) As _
    clsIPortableDevicePropVariantCollection

    Dim pResults As Long
    Dim ppResults As Long

    Dim IPortableDevicePropVariantCollection As _
        clsIPortableDevicePropVariantCollection
    
    ppResults = VarPtr(pResults)

    If x_OleInvoke(vtb_Delete, dwOptions, ObjectIDs.GetInterfacePtr, ppResults) Then

        Set IPortableDevicePropVariantCollection = New _
            clsIPortableDevicePropVariantCollection

        Call IPortableDevicePropVariantCollection.Initialize(pResults)

    End If

    Set Delete = IPortableDevicePropVariantCollection

End Function

Public Function GetObjectIDsFromPersistentUniqueIDs(ByVal PersistentUniqueIDs As _
    clsIPortableDevicePropVariantCollection) As _
    clsIPortableDevicePropVariantCollection

    Dim pObjectIDs As Long
    Dim ppObjectIDs As Long

    Dim IPortableDevicePropVariantCollection As _
        clsIPortableDevicePropVariantCollection

    ppObjectIDs = VarPtr(pObjectIDs)

    If x_OleInvoke(vtb_GetObjectIDsFromPersistentUniqueIDs, _
        PersistentUniqueIDs.GetInterfacePtr, ppObjectIDs) Then

        Set IPortableDevicePropVariantCollection = New _
            clsIPortableDevicePropVariantCollection

        Call IPortableDevicePropVariantCollection.Initialize(pObjectIDs)

    End If

    Set GetObjectIDsFromPersistentUniqueIDs = IPortableDevicePropVariantCollection

End Function

Public Function Cancel() As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_Cancel) Then

        bRet = True

    End If

    Cancel = bRet

End Function

Public Function Move(ByVal ObjectIDs As clsIPortableDevicePropVariantCollection, _
    ByVal szDestinationFolderObjectID As String) As _
    clsIPortableDevicePropVariantCollection

    Dim pResults As Long
    Dim ppResults As Long
    Dim pszDestinationFolderObjectID As Long

    Dim IPortableDevicePropVariantCollection As _
        clsIPortableDevicePropVariantCollection

    pszDestinationFolderObjectID = StrPtr(szDestinationFolderObjectID)
    ppResults = VarPtr(pResults)

    If x_OleInvoke(vtb_Move, ObjectIDs.GetInterfacePtr, _
        pszDestinationFolderObjectID, ppResults) Then

        Set IPortableDevicePropVariantCollection = New _
            clsIPortableDevicePropVariantCollection

        Call IPortableDevicePropVariantCollection.Initialize(pResults)

    End If

    Set Move = IPortableDevicePropVariantCollection

End Function

Public Function Copy(ByVal ObjectIDs As clsIPortableDevicePropVariantCollection, _
    ByVal szDestinationFolderObjectID As String) As _
    clsIPortableDevicePropVariantCollection

    Dim pResults As Long
    Dim ppResults As Long
    Dim pszDestinationFolderObjectID As Long

    Dim IPortableDevicePropVariantCollection As _
        clsIPortableDevicePropVariantCollection

    pszDestinationFolderObjectID = StrPtr(szDestinationFolderObjectID)
    ppResults = VarPtr(pResults)

    If x_OleInvoke(vtb_Copy, ObjectIDs.GetInterfacePtr, _
        pszDestinationFolderObjectID, ppResults) Then

        Set IPortableDevicePropVariantCollection = New _
            clsIPortableDevicePropVariantCollection

        Call IPortableDevicePropVariantCollection.Initialize(pResults)

    End If

    Set Copy = IPortableDevicePropVariantCollection

End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_PortableDeviceContent, _
            IID_IPortableDeviceContent)

    Else

        m_Interface.ifc = pInterface
        m_initialized = True

    End If

End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIPortableDeviceContent", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub


