VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPortableDeviceKeyCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Const CLSID_PortableDeviceKeyCollection As String = _
    "{DE2D022D-2480-43BE-97F0-D1FA2CF98F4F}"

Private Const IID_IPortableDeviceKeyCollection As String = _
    "{DADA2357-E0AD-492E-98DB-DD61C53BA353}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetCount
    vtb_GetAt
    vtb_Add
    vtb_Clear
    vtb_RemoveAt
End Enum

Public Function GetInterfacePtr() As Long

    GetInterfacePtr = m_Interface.ifc

End Function

Public Function GetCount() As Long
    
    Dim lRet As Long
    Dim cElems As Long
    Dim pcElems As Long
    
    pcElems = VarPtr(cElems)
    
    If x_OleInvoke(vtb_GetCount, pcElems) Then

        lRet = cElems

    End If

    GetCount = lRet
    
End Function

Friend Function GetAt(ByVal dwIndex As Long) As PropertyKey
    
    Dim tPropertyKey As PropertyKey
    Dim pKey As Long
    Dim ppKey As Long
    
    pKey = VarPtr(tPropertyKey)
    ppKey = VarPtr(pKey)
    
    If x_OleInvoke(vtb_GetAt, dwIndex, ppKey) Then

        Call CopyMemory(tPropertyKey, pKey, LenB(tPropertyKey))

    End If
    
    GetAt = tPropertyKey
    
End Function

Friend Function Add(ByRef Key As PropertyKey) As Boolean

    Dim bRet As Boolean
    Dim pKey As Long
    
    bRet = False
    pKey = VarPtr(Key)
    If x_OleInvoke(vtb_Add, pKey) Then

        bRet = True

    End If
    
    Add = bRet
    
End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_PortableDeviceKeyCollection, _
            IID_IPortableDeviceKeyCollection)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIPortableDeviceKeyCollection", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub

