VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPortableDeviceValues"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Const CLSID_PortableDeviceValues As String = _
    "{0C15D503-D017-47CE-9016-7B3F978721CC}"

Private Const IID_IPortableDeviceValues As String = _
    "{6848F6F2-3155-4F86-B6F5-263EEEAB3143}"

Private Const ERR_BASE As Long = 40670

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetCount
    vtb_GetAt
    vtb_SetValue
    vtb_GetValue
    vtb_SetStringValue
    vtb_GetStringValue
    vtb_SetUnsignedIntegerValue
    vtb_GetUnsignedIntegerValue
    vtb_SetSignedIntegerValue
    vtb_GetSignedIntegerValue
    vtb_SetUnsignedLargeIntegerValue
    vtb_GetUnsignedLargeIntegerValue
    vtb_SetSignedLargeIntegerValue
    vtb_GetSignedLargeIntegerValue
    vtb_SetFloatValue
    vtb_GetFloatValue
    vtb_SetErrorValue
    vtb_GetErrorValue
    vtb_SetKeyValue
    vtb_GetKeyValue
    vtb_SetBoolValue
    vtb_GetBoolValue
    vtb_SetIUnknownValue
    vtb_GetIUnknownValue
    vtb_SetGuidValue
    vtb_GetGuidValue
    vtb_SetBufferValue
    vtb_GetBufferValue
    vtb_SetIPortableDeviceValuesValue
    vtb_GetIPortableDeviceValuesValue
    vtb_SetIPortableDevicePropVariantCollectionValue
    vtb_GetIPortableDevicePropVariantCollectionValue
    vtb_SetIPortableDeviceKeyCollectionValue
    vtb_GetIPortableDeviceKeyCollectionValue
    vtb_SetIPortableDeviceValuesCollectionValue
    vtb_GetIPortableDeviceValuesCollectionValue
    vtb_RemoveValue
    vtb_CopyValuesFromPropertyStore
    vtb_CopyValuesToPropertyStore
    vtb_Clear
End Enum

Public Function GetInterfacePtr() As Long

    GetInterfacePtr = m_Interface.ifc

End Function

Public Function GetCount() As Long
    
    Dim lRet As Long
    Dim celt As Long
    Dim pcelt As Long
    
    pcelt = VarPtr(celt)
    
    If x_OleInvoke(vtb_GetCount, pcelt) Then

        lRet = celt

    End If
    
    GetCount = lRet
    
End Function

Friend Function GetAt(ByVal Index As Long, ByRef Key As PropertyKey, ByRef Value As PropVariant) As Boolean
    
    Dim bRet As Boolean
    Dim pKey As Long
    Dim ppKey As Long
    Dim pValue As Long
    Dim ppValue As Long
    
    bRet = False
    ppKey = VarPtr(pKey)
    ppValue = VarPtr(pValue)
    
    If x_OleInvoke(vtb_GetAt, Index, ppKey, ppValue) Then

        bRet = True
        
        Call CopyMemory(Key, pKey, LenB(Key))
        Call CopyMemory(Value, pValue, LenB(Value))

    End If

    GetAt = bRet
    
End Function

Friend Function SetStringValue(ByRef Key As PropertyKey, ByVal Value As String) As _
    Boolean

    Dim bRet As Boolean
    Dim pKey As Long
    Dim pValue As Long

    bRet = False
    pKey = VarPtr(Key)
    pValue = StrPtr(Value)

    If x_OleInvoke(vtb_SetStringValue, pKey, pValue) Then

        bRet = True

    End If

    SetStringValue = bRet

End Function

Friend Function GetStringValue(ByRef Key As PropertyKey) As String

    Dim sRet As String
    Dim pKey As Long
    Dim Value As Long
    Dim pValue As Long

    sRet = vbNullString
    pKey = VarPtr(Key)
    pValue = VarPtr(Value)

    If x_OleInvoke(vtb_GetStringValue, pKey, pValue) Then

        sRet = GetStringFromPointer(Value)
        
    End If

    GetStringValue = sRet

End Function

Friend Function SetUnsignedIntegerValue(ByRef Key As PropertyKey, ByVal Value As _
    Long) As Boolean

    Dim bRet As Boolean
    Dim pKey As Long

    bRet = False
    pKey = VarPtr(Key)

    If x_OleInvoke(vtb_SetUnsignedIntegerValue, pKey, Value) Then

        bRet = True

    End If

    SetUnsignedIntegerValue = bRet

End Function

Friend Function GetUnsignedIntegerValue(ByRef Key As PropertyKey) As Long

    Dim lRet As Long
    Dim Value As Long
    Dim pKey As Long
    Dim pValue As Long

    lRet = 0
    pKey = VarPtr(Key)
    pValue = VarPtr(Value)

    If x_OleInvoke(vtb_GetUnsignedIntegerValue, pKey, pValue) Then

        lRet = Value

    End If
    
    GetUnsignedIntegerValue = lRet
    
End Function

Friend Function SetUnsignedLargeIntegerValue(ByRef Key As PropertyKey, ByVal Value As _
    Currency) As Boolean

    Dim bRet As Boolean
    Dim pKey As Long

    bRet = False
    pKey = VarPtr(Key)
    
    If x_OleInvoke(vtb_SetUnsignedLargeIntegerValue, pKey, Value) Then

        bRet = True

    End If

    SetUnsignedLargeIntegerValue = bRet

End Function

Friend Function GetUnsignedLargeIntegerValue(ByRef Key As PropertyKey) As Long

    Dim lRet As Long
    Dim pValue As Long
    Dim ppValue As Long
    Dim pKey As Long

    pKey = VarPtr(Key)
    ppValue = VarPtr(pValue)
    
    If x_OleInvoke(vtb_GetUnsignedLargeIntegerValue, pKey, ppValue) Then

        lRet = pValue

    End If

    GetUnsignedLargeIntegerValue = lRet

End Function

Friend Function GetBoolValue(ByRef Key As PropertyKey) As Boolean

    Dim lRet As Long
    Dim pValue As Long
    Dim ppValue As Long
    Dim pKey As Long

    pKey = VarPtr(Key)
    ppValue = VarPtr(pValue)
    
    If x_OleInvoke(vtb_GetBoolValue, pKey, ppValue) Then

        lRet = pValue

    End If

    GetBoolValue = CBool(lRet)

End Function

Friend Function SetGuidValue(ByRef Key As PropertyKey, ByRef Value As GUID) As Boolean

    Dim bRet As Boolean
    Dim pKey As Long
    Dim pValue As Long
    
    pKey = VarPtr(Key)
    pValue = VarPtr(Value)

    bRet = False
    
    If x_OleInvoke(vtb_SetGuidValue, pKey, pValue) Then
        
        bRet = True
    End If

    SetGuidValue = bRet

End Function

Friend Function GetGuidValue(ByRef Key As PropertyKey) As GUID

    Dim pKey As Long
    Dim Value As Long
    Dim pValue As Long
    Dim tGUID As GUID
    
    pKey = VarPtr(Key)
    pValue = VarPtr(Value)

    If x_OleInvoke(vtb_GetGuidValue, pKey, pValue) Then
        
        Call CopyMemory(tGUID, Value, LenB(tGUID))
        
    End If

    GetGuidValue = tGUID

End Function

Friend Function SetKeyValue(ByRef Key As PropertyKey, ByRef Value As PropertyKey) As Boolean

    Dim bRet As Boolean
    Dim pKey As Long
    Dim pValue As Long
    Dim tGUID As GUID
    
    bRet = False
    pKey = VarPtr(Key)
    pValue = VarPtr(Value)

    If x_OleInvoke(vtb_SetKeyValue, pKey, pValue) Then
        
        bRet = True
        
    End If

    SetKeyValue = bRet

End Function

Friend Function SetIPortableDeviceValuesValue(ByRef Key As PropertyKey, ByVal Value As clsIPortableDeviceValues) As Boolean

    Dim bRet As Boolean
    Dim pKey As Long
    
    bRet = False
    pKey = VarPtr(Key)

    If x_OleInvoke(vtb_SetIPortableDeviceValuesValue, pKey, Value.GetInterfacePtr) Then
        
        bRet = True
        
    End If

    SetIPortableDeviceValuesValue = bRet

End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_PortableDeviceValues, _
            IID_IPortableDeviceValues)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIPortableDeviceValues", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub

