Attribute VB_Name = "modHelper"
Option Explicit

Private Const LB_SETHORIZONTAL As Long = &H194

Private Declare Sub Sleep Lib "Kernel32" ( _
                    ByVal lngMilliseconds As Long)

Private Declare Function SendMessage Lib "user32" _
                         Alias "SendMessageA" ( _
                         ByVal hWnd As Long, _
                         ByVal wMsg As Long, _
                         ByVal wParam As Long, _
                         ByRef lParam As Any) As Long

Private Declare Function FormatMessage Lib "Kernel32" _
                         Alias "FormatMessageA" ( _
                         ByVal dwFlags As Long, _
                         ByRef lpSource As Any, _
                         ByVal dwMessageId As Long, _
                         ByVal dwLanguageId As Long, _
                         ByVal lpBuffer As String, _
                         ByVal nSize As Long, _
                         ByRef Arguments As Long) As Long
                         
Public Sub GetErrMessage(ByVal ErrorNumber As Long)

    Dim Result As Long
    Dim Buffer As String

    Buffer = Space$(256)
    Result = FormatMessage(&H1000, 0, ErrorNumber, 0&, Buffer, Len(Buffer), ByVal 0&)

    Debug.Print Left$(Buffer, Result)

End Sub

Public Sub SleepLong(ByVal lngSeconds As Long, Optional ByVal blnBeAwake As Boolean _
    = True)

    Dim t As Single, b As Boolean

    t = Timer

    Do

        Sleep 1

        If blnBeAwake Then

            DoEvents

        End If

        b = Timer - t > lngSeconds

    Loop Until b

End Sub

Public Sub SetLbHorzScrollBar(ByVal oFrm As Form, ByVal oListBox As ListBox)

    Dim x As Long
    Dim Max As Long
    Dim Akt As Long
    Dim Result As Long
    Dim cForm As Form

    Set cForm = oFrm

    For x = 0 To oListBox.ListCount - 1

        Akt = cForm.TextWidth(oListBox.List(x))

        If Akt > Max Then Max = Akt

    Next

    Result = SendMessage(oListBox.hWnd, LB_SETHORIZONTAL, Max, ByVal 0)

    Set cForm = Nothing

End Sub



