﻿' Autor: Frank Schüler
' Datum: 01.01.2018
' Status: in Arbeit

Option Strict On
Option Explicit On

Imports System.Runtime.InteropServices

Public Class WpdStruct
    Public Enum STREAM_SEEK
        STREAM_SEEK_SET = 0
        STREAM_SEEK_CUR = 1
        STREAM_SEEK_END = 2
    End Enum

    Public Enum STGC
        STGC_DEFAULT = 0&
        STGC_OVERWRITE = 1&
        STGC_ONLYIFCURRENT = 2&
        STGC_DANGEROUSLYCOMMITMERELYTODISKCACHE = 4&
        STGC_CONSOLIDATE = 8&
    End Enum

    Public Enum STGM
        STGM_FAILIFTHERE = 0
        STGM_DIRECT = 0
        STGM_READ = 0
        STGM_WRITE = 1
        STGM_READWRITE = 2
        STGM_SHARE_EXCLUSIVE = &H10
        STGM_SHARE_DENY_WRITE = &H20
        STGM_SHARE_DENY_READ = &H30
        STGM_SHARE_DENY_NONE = &H40
        STGM_CREATE = &H1000
        STGM_TRANSACTED = &H10000
        STGM_CONVERT = &H20000
        STGM_PRIORITY = &H40000
        STGM_NOSCRATCH = &H100000
        STGM_NOSNAPSHOT = &H200000
        STGM_DIRECT_SWMR = &H400000
        STGM_SIMPLE = &H8000000
        STGM_DELETEONRELEASE = &H4000000
    End Enum

    Public Structure PROPERTYKEY
        Dim fmtid As Guid
        Dim pid As Integer
    End Structure

    Public Enum DELETE_OBJECT_OPTIONS
        PORTABLE_DEVICE_DELETE_NO_RECURSION = 0
        PORTABLE_DEVICE_DELETE_WITH_RECURSION = 1
    End Enum

    Public Enum VARENUM As Short
        VT_EMPTY = &H0
        VT_NULL = &H1
        VT_I2 = &H2
        VT_I4 = &H3
        VT_R4 = &H4
        VT_R8 = &H5
        VT_CY = &H6
        VT_DATE = &H7
        VT_BSTR = &H8
        VT_DISPATCH = &H9
        VT_ERROR = &HA
        VT_BOOL = &HB
        VT_VARIANT = &HC
        VT_UNKNOWN = &HD
        VT_DECIMAL = &HE
        VT_I1 = &H10
        VT_UI1 = &H11
        VT_UI2 = &H12
        VT_UI4 = &H13
        VT_I8 = &H14
        VT_UI8 = &H15
        VT_INT = &H16
        VT_UINT = &H17
        VT_VOID = &H18
        VT_HRESULT = &H19
        VT_PTR = &H1A
        VT_SAFEARRAY = &H1B
        VT_CARRAY = &H1C
        VT_USERDEFINED = &H1D
        VT_LPSTR = &H1E
        VT_LPWSTR = &H1F
        VT_RECORD = &H24
        VT_INT_PTR = &H25
        VT_UINT_PTR = &H26
        VT_ARRAY = &H2000
        VT_BYREF = &H4000
    End Enum

    Public Structure PROPVARIANT
        <FieldOffset(0)> Dim vt As VARENUM
        <FieldOffset(2)> Dim wReserved1 As Short
        <FieldOffset(4)> Dim wReserved2 As Short
        <FieldOffset(6)> Dim wReserved3 As Short
        '    CHAR              cVal;
        '    UCHAR             bVal;
        '    SHORT             iVal;
        '    USHORT            uiVal;
        '    LONG              lVal;
        '    ULONG             ulVal;
        '    INT               intVal;
        '    UINT              uintVal;
        '    LARGE_INTEGER     hVal;
        '    ULARGE_INTEGER    uhVal;
        '    FLOAT             fltVal;
        '    DOUBLE            dblVal;
        '    VARIANT_BOOL      boolVal;
        '    SCODE             scode;
        '    CY                cyVal;
        '    DATE              date;
        '    FILETIME          filetime;
        '    CLSID             *puuid;
        '    CLIPDATA          *pclipdata;
        '    BSTR              bstrVal;
        '    BSTRBLOB          bstrblobVal;
        '    BLOB              blob;
        '    LPSTR             pszVal;
        <FieldOffset(8), MarshalAs(UnmanagedType.LPWStr)> Dim pwszVal As String
        '    IUnknown          *punkVal;
        '    IDispatch         *pdispVal;
        '    IStream           *pStream;
        '    IStorage          *pStorage;
        '    LPVERSIONEDSTREAM pVersionedStream;
        '    LPSAFEARRAY       parray;
        '    CAC               cac;
        '    CAUB              caub;
        '    CAI               cai;
        '    CAUI              caui;
        '    CAL               cal;
        '    CAUL              caul;
        '    CAH               cah;
        '    CAUH              cauh;
        '    CAFLT             caflt;
        '    CADBL             cadbl;
        '    CABOOL            cabool;
        '    CASCODE           cascode;
        '    CACY              cacy;
        '    CADATE            cadate;
        '    CAFILETIME        cafiletime;
        '    CACLSID           cauuid;
        '    CACLIPDATA        caclipdata;
        '    CABSTR            cabstr;
        '    CABSTRBLOB        cabstrblob;
        '    CALPSTR           calpstr;
        '    CALPWSTR          calpwstr;
        '    CAPROPVARIANT     capropvar;
        '    CHAR              *pcVal;
        '    UCHAR             *pbVal;
        '    SHORT             *piVal;
        '    USHORT            *puiVal;
        '    LONG              *plVal;
        '    ULONG             *pulVal;
        '    INT               *pintVal;
        '    UINT              *puintVal;
        '    FLOAT             *pfltVal;
        '    DOUBLE            *pdblVal;
        '    VARIANT_BOOL      *pboolVal;
        '    DECIMAL           *pdecVal;
        '    SCODE             *pscode;
        '    CY                *pcyVal;
        '    DATE              *pdate;
        '    BSTR              *pbstrVal;
        '    IUnknown          **ppunkVal;
        '    IDispatch         **ppdispVal;
        '    LPSAFEARRAY       *pparray;
        '    PROPVARIANT       *pvarVal;
    End Structure

    Public Structure PDF
        Dim PDFF_ObjectId As String
        Dim PDFF_ParentId As String
        Dim PDFF_Name As String
        Dim PDFF_OriginalName As String
        Dim PDFF_Type As String
    End Structure

    <StructLayout(LayoutKind.Sequential)>
    Public Class STATSTG
        <MarshalAs(UnmanagedType.LPWStr)> Dim pwcsName As String
        Dim type As Integer
        <MarshalAs(UnmanagedType.I8)> Dim cbSize As Long
        <MarshalAs(UnmanagedType.I8)> Dim mtime As Long
        <MarshalAs(UnmanagedType.I8)> Dim ctime As Long
        <MarshalAs(UnmanagedType.I8)> Dim atime As Long
        <MarshalAs(UnmanagedType.I4)> Dim grfMode As Integer
        <MarshalAs(UnmanagedType.I4)> Dim grfLocksSupported As Integer
        Dim clsid_data1 As Integer
        <MarshalAs(UnmanagedType.I2)> Dim clsid_data2 As Short
        <MarshalAs(UnmanagedType.I2)> Dim clsid_data3 As Short
        <MarshalAs(UnmanagedType.U1)> Dim clsid_b0 As Byte
        <MarshalAs(UnmanagedType.U1)> Dim clsid_b1 As Byte
        <MarshalAs(UnmanagedType.U1)> Dim clsid_b2 As Byte
        <MarshalAs(UnmanagedType.U1)> Dim clsid_b3 As Byte
        <MarshalAs(UnmanagedType.U1)> Dim clsid_b4 As Byte
        <MarshalAs(UnmanagedType.U1)> Dim clsid_b5 As Byte
        <MarshalAs(UnmanagedType.U1)> Dim clsid_b6 As Byte
        <MarshalAs(UnmanagedType.U1)> Dim clsid_b7 As Byte
        <MarshalAs(UnmanagedType.I4)> Dim grfStateBits As Integer
        <MarshalAs(UnmanagedType.I4)> Dim reserved As Integer
    End Class

End Class

Module HelperFunc

#Region "Public Const"
    Public Const WPD_DEVICE_OBJECT_ID As String = "DEVICE"

    Public Const WPD_FUNCTIONAL_CATEGORY_DEVICE As String = "{08EA466B-E3A4-4336-A1F3-A44D2B5C438C}"
    Public Const WPD_FUNCTIONAL_CATEGORY_STORAGE As String = "{23F05BBC-15DE-4C2A-A55B-A9AF5CE412EF}"
    Public Const WPD_FUNCTIONAL_CATEGORY_STILL_IMAGE_CAPTURE As String = "{613CA327-AB93-4900-B4FA-895BB5874B79}"
    Public Const WPD_FUNCTIONAL_CATEGORY_AUDIO_CAPTURE As String = "{3F2A1919-C7C2-4A00-855D-F57CF06DEBBB}"
    Public Const WPD_FUNCTIONAL_CATEGORY_VIDEO_CAPTURE As String = "{E23E5F6B-7243-43AA-8DF1-0EB3D968A918}"
    Public Const WPD_FUNCTIONAL_CATEGORY_SMS As String = "{0044A0B1-C1E9-4AFD-B358-A62C6117C9CF}"
    Public Const WPD_FUNCTIONAL_CATEGORY_RENDERING_INFORMATION As String = "{08600BA4-A7BA-4A01-AB0E-0065D0A356D3}"
    Public Const WPD_FUNCTIONAL_CATEGORY_NETWORK_CONFIGURATION As String = "{48F4DB72-7C6A-4AB0-9E1A-470E3CDBF26A}"
    Public Const WPD_FUNCTIONAL_CATEGORY_ALL As String = "{2D8A6512-A74C-448E-BA8A-F4AC07C49399}"

    Public Const WPD_CONTENT_TYPE_FUNCTIONAL_OBJECT As String = "{99ED0160-17FF-4C44-9D98-1D7A6F941921}"
    Public Const WPD_CONTENT_TYPE_FOLDER As String = "{27E2E392-A111-48E0-AB0C-E17705A05F85}"
    Public Const WPD_CONTENT_TYPE_IMAGE As String = "{EF2107D5-A52A-4243-A26B-62D4176D7603}"
    Public Const WPD_CONTENT_TYPE_DOCUMENT As String = "{680ADF52-950A-4041-9B41-65E393648155}"
    Public Const WPD_CONTENT_TYPE_CONTACT As String = "{EABA8313-4525-4707-9F0E-87C6808E9435}"
    Public Const WPD_CONTENT_TYPE_CONTACT_GROUP As String = "{346B8932-4C36-40D8-9415-1828291F9DE9}"
    Public Const WPD_CONTENT_TYPE_AUDIO As String = "{4AD2C85E-5E2D-45E5-8864-4F229E3C6CF0}"
    Public Const WPD_CONTENT_TYPE_VIDEO As String = "{9261B03C-3D78-4519-85E3-02C5E1F50BB9}"
    Public Const WPD_CONTENT_TYPE_PLAYLIST As String = "{1A33F7E4-AF13-48F5-994E-77369DFE04A3}"
    Public Const WPD_CONTENT_TYPE_MIXED_CONTENT_ALBUM As String = "{00F0C3AC-A593-49AC-9219-24ABCA5A2563}"
    Public Const WPD_CONTENT_TYPE_AUDIO_ALBUM As String = "{AA18737E-5009-48FA-AE21-85F24383B4E6}"
    Public Const WPD_CONTENT_TYPE_IMAGE_ALBUM As String = "{75793148-15F5-4A30-A813-54ED8A37E226}"
    Public Const WPD_CONTENT_TYPE_VIDEO_ALBUM As String = "{012B0DB7-D4C1-45D6-B081-94B87779614F}"
    Public Const WPD_CONTENT_TYPE_MEMO As String = "{9CD20ECF-3B50-414F-A641-E473FFE45751}"
    Public Const WPD_CONTENT_TYPE_EMAIL As String = "{8038044A-7E51-4F8F-883D-1D0623D14533}"
    Public Const WPD_CONTENT_TYPE_APPOINTMENT As String = "{0FED060E-8793-4B1E-90C9-48AC389AC631}"
    Public Const WPD_CONTENT_TYPE_TASK As String = "{63252F2C-887F-4CB6-B1AC-D29855DCEF6C}"
    Public Const WPD_CONTENT_TYPE_PROGRAM As String = "{D269F96A-247C-4BFF-98FB-97F3C49220E6}"
    Public Const WPD_CONTENT_TYPE_GENERIC_FILE As String = "{0085E0A6-8D34-45D7-BC5C-447E59C73D48}"
    Public Const WPD_CONTENT_TYPE_CALENDAR As String = "{A1FD5967-6023-49A0-9DF1-F8060BE751B0}"
    Public Const WPD_CONTENT_TYPE_GENERIC_MESSAGE As String = "{E80EAAF8-B2DB-4133-B67E-1BEF4B4A6E5F}"
    Public Const WPD_CONTENT_TYPE_NETWORK_ASSOCIATION As String = "{031DA7EE-18C8-4205-847E-89A11261D0F3}"
    Public Const WPD_CONTENT_TYPE_CERTIFICATE As String = "{DC3876E8-A948-4060-9050-CBD77E8A3D87}"
    Public Const WPD_CONTENT_TYPE_WIRELESS_PROFILE As String = "{0BAC070A-9F5F-4DA4-A8F6-3DE44D68FD6C}"
    Public Const WPD_CONTENT_TYPE_MEDIA_CAST As String = "{5E88B3CC-3E65-4E62-BFFF-229495253AB0}"
    Public Const WPD_CONTENT_TYPE_SECTION As String = "{821089F5-1D91-4DC9-BE3C-BBB1B35B18CE}"
    Public Const WPD_CONTENT_TYPE_UNSPECIFIED As String = "{28D8D31E-249C-454E-AABC-34883168E634}"
    Public Const WPD_CONTENT_TYPE_ALL As String = "{80E170D2-1055-4A3E-B952-82CC4F8A8689}"

#End Region

#Region "Private Const"
    Private Const WPD_CLIENT_NAME_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},2"
    Private Const WPD_CLIENT_MAJOR_VERSION_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},3"
    Private Const WPD_CLIENT_MINOR_VERSION_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},4"
    Private Const WPD_CLIENT_REVISION_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},5"
    Private Const WPD_CLIENT_WMDRM_APPLICATION_PRIVATE_KEY_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},6"
    Private Const WPD_CLIENT_WMDRM_APPLICATION_CERTIFICATE_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},7"
    Private Const WPD_CLIENT_SECURITY_QUALITY_OF_SERVICE_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},8"
    Private Const WPD_CLIENT_DESIRED_ACCESS_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},9"
    Private Const WPD_CLIENT_SHARE_MODE_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},10"
    Private Const WPD_CLIENT_EVENT_COOKIE_FMTID_PID As String = "{204d9f0c-2292-4080-9f42-40664e70f859},11"

    Private Const WPD_DEVICE_FUNCTIONAL_UNIQUE_ID_FMTID_PID As String = "{463dd662-7fc4-4291-911c-7f4c9cca9799},2"
    Private Const WPD_DEVICE_SYNC_PARTNER_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},2"
    Private Const WPD_DEVICE_FIRMWARE_VERSION_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},3"
    Private Const WPD_DEVICE_MODEL_UNIQUE_ID_FMTID_PID As String = "{463dd662-7fc4-4291-911c-7f4c9cca9799},3"
    Private Const WPD_DEVICE_POWER_LEVEL_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},4"
    Private Const WPD_DEVICE_TRANSPORT_FMTID_PID As String = "{463dd662-7fc4-4291-911c-7f4c9cca9799},4"
    Private Const WPD_DEVICE_POWER_SOURCE_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},5"
    Private Const WPD_DEVICE_USE_DEVICE_STAGE_FMTID_PID As String = "{463dd662-7fc4-4291-911c-7f4c9cca9799},5"
    Private Const WPD_DEVICE_PROTOCOL_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},6"
    Private Const WPD_DEVICE_MANUFACTURER_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},7"
    Private Const WPD_DEVICE_MODEL_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},8"
    Private Const WPD_DEVICE_SERIAL_NUMBER_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},9"
    Private Const WPD_DEVICE_SUPPORTS_NON_CONSUMABLE_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},10"
    Private Const WPD_DEVICE_DATETIME_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},11"
    Private Const WPD_DEVICE_FRIENDLY_NAME_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},12"
    Private Const WPD_DEVICE_SUPPORTED_DRM_SCHEMES_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},13"
    Private Const WPD_DEVICE_SUPPORTED_FORMATS_ARE_ORDERED_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},14"
    Private Const WPD_DEVICE_TYPE_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},15"
    Private Const WPD_DEVICE_NETWORK_IDENTIFIER_FMTID_PID As String = "{26d4979a-e643-4626-9e2b-736dc0c92fdc},16"

    Private Const WPD_COMMAND_SMS_SEND_FMTID_PID As String = "{afc25d66-fe0d-4114-9097-970c93e920d1},2"
    Private Const WPD_COMMAND_STILL_IMAGE_CAPTURE_INITIATE_FMTID_PID As String = "{4fcd6982-22a2-4b05-a48b-62d38bf27b32},2"
    Private Const WPD_COMMAND_STORAGE_FORMAT_FMTID_PID As String = "{d8f907a6-34cc-45fa-97fb-d007fa47ec94},2"
    Private Const WPD_COMMAND_STORAGE_EJECT_FMTID_PID As String = "{d8f907a6-34cc-45fa-97fb-d007fa47ec94},4"
    Private Const WPD_COMMAND_COMMON_RESET_DEVICE_FMTID_PID As String = "{f0422a9c-5dc8-4440-b5bd-5df28835658a},2"
    Private Const WPD_COMMAND_DEVICE_HINTS_GET_CONTENT_LOCATION_FMTID_PID As String = "{0d5fb92b-cb46-4c4f-8343-0bc3d3f17c84},2"

    Private Const WPD_OBJECT_ID_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},2"
    Private Const WPD_OBJECT_PARENT_ID_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},3"
    Private Const WPD_OBJECT_NAME_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},4"
    Private Const WPD_OBJECT_CONTENT_TYPE_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},7"
    Private Const WPD_OBJECT_SIZE_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},11"
    Private Const WPD_OBJECT_ORIGINAL_FILE_NAME_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},12"
    Private Const WPD_OBJECT_CAN_DELETE_FMTID_PID As String = "{ef6b490d-5cd8-437a-affc-da8b60ee4a3c},26"

    Private Const WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1_FMTID_PID As String = "{8F052D93-ABCA-4FC5-A5AC-B01DF4DBE598},2"

    Private Const WPD_RESOURCE_DEFAULT_FMTID_PID As String = "{e81e79be-34f0-41bf-b53f-f1a06ae87842},0"

    Private Const WPD_PROPERTY_ATTRIBUTE_CAN_WRITE_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},4"
    Private Const WPD_PROPERTY_ATTRIBUTE_CAN_DELETE_FMTID_PID As String = "{ab7943d8-6332-445f-a00d-8d5ef1e96f37},5"

#End Region

#Region "Public Enums"

    Public Enum PropertyKeys
        WPD_CLIENT_NAME
        WPD_CLIENT_MAJOR_VERSION
        WPD_CLIENT_MINOR_VERSION
        WPD_CLIENT_REVISION
        WPD_CLIENT_WMDRM_APPLICATION_PRIVATE_KEY
        WPD_CLIENT_WMDRM_APPLICATION_CERTIFICATE
        WPD_CLIENT_SECURITY_QUALITY_OF_SERVICE
        WPD_CLIENT_DESIRED_ACCESS
        WPD_CLIENT_SHARE_MODE
        WPD_CLIENT_EVENT_COOKIE

        WPD_DEVICE_SYNC_PARTNER
        WPD_DEVICE_FIRMWARE_VERSION
        WPD_DEVICE_POWER_LEVEL
        WPD_DEVICE_POWER_SOURCE
        WPD_DEVICE_PROTOCOL
        WPD_DEVICE_MANUFACTURER
        WPD_DEVICE_MODEL
        WPD_DEVICE_SERIAL_NUMBER
        WPD_DEVICE_SUPPORTS_NON_CONSUMABLE
        WPD_DEVICE_DATETIME
        WPD_DEVICE_FRIENDLY_NAME
        WPD_DEVICE_SUPPORTED_DRM_SCHEMES
        WPD_DEVICE_SUPPORTED_FORMATS_ARE_ORDERED
        WPD_DEVICE_TYPE
        WPD_DEVICE_NETWORK_IDENTIFIER
        WPD_DEVICE_FUNCTIONAL_UNIQUE_ID
        WPD_DEVICE_MODEL_UNIQUE_ID
        WPD_DEVICE_TRANSPORT
        WPD_DEVICE_USE_DEVICE_STAGE

        WPD_COMMAND_SMS_SEND
        WPD_COMMAND_STILL_IMAGE_CAPTURE_INITIATE
        WPD_COMMAND_STORAGE_FORMAT
        WPD_COMMAND_STORAGE_EJECT
        WPD_COMMAND_COMMON_RESET_DEVICE
        WPD_COMMAND_DEVICE_HINTS_GET_CONTENT_LOCATION

        WPD_OBJECT_ID
        WPD_OBJECT_PARENT_ID
        WPD_OBJECT_NAME
        WPD_OBJECT_CONTENT_TYPE
        WPD_OBJECT_SIZE
        WPD_OBJECT_ORIGINAL_FILE_NAME
        WPD_OBJECT_CAN_DELETE

        WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1

        WPD_RESOURCE_DEFAULT

        WPD_PROPERTY_ATTRIBUTE_CAN_WRITE
        WPD_PROPERTY_ATTRIBUTE_CAN_DELETE
    End Enum
#End Region

#Region "Helper Func"
    Private Function GetFmtidPid(ByVal ePropertyKeys As PropertyKeys) As String
        Select Case ePropertyKeys
            Case PropertyKeys.WPD_CLIENT_NAME
                Return WPD_CLIENT_NAME_FMTID_PID
            Case PropertyKeys.WPD_CLIENT_MAJOR_VERSION
                Return WPD_CLIENT_MAJOR_VERSION_FMTID_PID
            Case PropertyKeys.WPD_CLIENT_MINOR_VERSION
                Return WPD_CLIENT_MINOR_VERSION_FMTID_PID
            Case PropertyKeys.WPD_CLIENT_REVISION
                Return WPD_CLIENT_REVISION_FMTID_PID
            Case PropertyKeys.WPD_CLIENT_WMDRM_APPLICATION_PRIVATE_KEY
                Return WPD_CLIENT_WMDRM_APPLICATION_PRIVATE_KEY_FMTID_PID
            Case PropertyKeys.WPD_CLIENT_WMDRM_APPLICATION_CERTIFICATE
                Return WPD_CLIENT_WMDRM_APPLICATION_CERTIFICATE_FMTID_PID
            Case PropertyKeys.WPD_CLIENT_SECURITY_QUALITY_OF_SERVICE
                Return WPD_CLIENT_SECURITY_QUALITY_OF_SERVICE_FMTID_PID
            Case PropertyKeys.WPD_CLIENT_DESIRED_ACCESS
                Return WPD_CLIENT_DESIRED_ACCESS_FMTID_PID
            Case PropertyKeys.WPD_CLIENT_SHARE_MODE
                Return WPD_CLIENT_SHARE_MODE_FMTID_PID
            Case PropertyKeys.WPD_CLIENT_EVENT_COOKIE
                Return WPD_CLIENT_EVENT_COOKIE_FMTID_PID

            Case PropertyKeys.WPD_DEVICE_SYNC_PARTNER
                Return WPD_DEVICE_SYNC_PARTNER_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_FIRMWARE_VERSION
                Return WPD_DEVICE_FIRMWARE_VERSION_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_POWER_LEVEL
                Return WPD_DEVICE_POWER_LEVEL_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_POWER_SOURCE
                Return WPD_DEVICE_POWER_SOURCE_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_PROTOCOL
                Return WPD_DEVICE_PROTOCOL_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_MANUFACTURER
                Return WPD_DEVICE_MANUFACTURER_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_MODEL
                Return WPD_DEVICE_MODEL_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_SERIAL_NUMBER
                Return WPD_DEVICE_SERIAL_NUMBER_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_SUPPORTS_NON_CONSUMABLE
                Return WPD_DEVICE_SUPPORTS_NON_CONSUMABLE_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_DATETIME
                Return WPD_DEVICE_DATETIME_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_FRIENDLY_NAME
                Return WPD_DEVICE_FRIENDLY_NAME_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_SUPPORTED_DRM_SCHEMES
                Return WPD_DEVICE_SUPPORTED_DRM_SCHEMES_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_SUPPORTED_FORMATS_ARE_ORDERED
                Return WPD_DEVICE_SUPPORTED_FORMATS_ARE_ORDERED_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_TYPE
                Return WPD_DEVICE_TYPE_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_NETWORK_IDENTIFIER
                Return WPD_DEVICE_NETWORK_IDENTIFIER_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_FUNCTIONAL_UNIQUE_ID
                Return WPD_DEVICE_FUNCTIONAL_UNIQUE_ID_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_MODEL_UNIQUE_ID
                Return WPD_DEVICE_MODEL_UNIQUE_ID_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_TRANSPORT
                Return WPD_DEVICE_TRANSPORT_FMTID_PID
            Case PropertyKeys.WPD_DEVICE_USE_DEVICE_STAGE
                Return WPD_DEVICE_USE_DEVICE_STAGE_FMTID_PID

            Case PropertyKeys.WPD_COMMAND_STILL_IMAGE_CAPTURE_INITIATE
                Return WPD_COMMAND_STILL_IMAGE_CAPTURE_INITIATE_FMTID_PID
            Case PropertyKeys.WPD_COMMAND_SMS_SEND
                Return WPD_COMMAND_SMS_SEND_FMTID_PID
            Case PropertyKeys.WPD_COMMAND_STORAGE_FORMAT
                Return WPD_COMMAND_STORAGE_FORMAT_FMTID_PID
            Case PropertyKeys.WPD_COMMAND_STORAGE_EJECT
                Return WPD_COMMAND_STORAGE_EJECT_FMTID_PID
            Case PropertyKeys.WPD_COMMAND_DEVICE_HINTS_GET_CONTENT_LOCATION
                Return WPD_COMMAND_DEVICE_HINTS_GET_CONTENT_LOCATION_FMTID_PID
            Case PropertyKeys.WPD_COMMAND_COMMON_RESET_DEVICE
                Return WPD_COMMAND_COMMON_RESET_DEVICE_FMTID_PID

            Case PropertyKeys.WPD_OBJECT_ID
                Return WPD_OBJECT_ID_FMTID_PID
            Case PropertyKeys.WPD_OBJECT_PARENT_ID
                Return WPD_OBJECT_PARENT_ID_FMTID_PID
            Case PropertyKeys.WPD_OBJECT_NAME
                Return WPD_OBJECT_NAME_FMTID_PID
            Case PropertyKeys.WPD_OBJECT_CONTENT_TYPE
                Return WPD_OBJECT_CONTENT_TYPE_FMTID_PID
            Case PropertyKeys.WPD_OBJECT_SIZE
                Return WPD_OBJECT_SIZE_FMTID_PID
            Case PropertyKeys.WPD_OBJECT_ORIGINAL_FILE_NAME
                Return WPD_OBJECT_ORIGINAL_FILE_NAME_FMTID_PID
            Case PropertyKeys.WPD_OBJECT_CAN_DELETE
                Return WPD_OBJECT_CAN_DELETE_FMTID_PID

            Case PropertyKeys.WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1
                Return WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1_FMTID_PID

            Case PropertyKeys.WPD_RESOURCE_DEFAULT
                Return WPD_RESOURCE_DEFAULT_FMTID_PID

            Case PropertyKeys.WPD_PROPERTY_ATTRIBUTE_CAN_WRITE
                Return WPD_PROPERTY_ATTRIBUTE_CAN_WRITE_FMTID_PID
            Case PropertyKeys.WPD_PROPERTY_ATTRIBUTE_CAN_DELETE
                Return WPD_PROPERTY_ATTRIBUTE_CAN_DELETE_FMTID_PID

        End Select
        Return String.Empty
    End Function

    Public Function GetGuidName(ByVal sValue As String) As String
        Select Case sValue
            Case "{38010000-AE6C-4804-98BA-C57B46965FE7}"
                Return "WPD_OBJECT_FORMAT_EXIF"
            Case "{30090000-AE6C-4804-98BA-C57B46965FE7}"
                Return "WPD_OBJECT_FORMAT_MP3"
            Case "{B9820000-AE6C-4804-98BA-C57B46965FE7}"
                Return "WPD_OBJECT_FORMAT_MP4"
            Case "{23F05BBC-15DE-4C2A-A55B-A9AF5CE412EF}"
                Return "WPD_FUNCTIONAL_CATEGORY_STORAGE"
            Case "{99ED0160-17FF-4C44-9D98-1D7A6F941921}"
                Return "WPD_CONTENT_TYPE_Functional_Object"
            Case "{27E2E392-A111-48E0-AB0C-E17705A05F85}"
                Return "WPD_CONTENT_TYPE_Folder"
            Case "{EF2107D5-A52A-4243-A26B-62D4176D7603}"
                Return "WPD_CONTENT_TYPE_Image"
            Case "{680ADF52-950A-4041-9B41-65E393648155}"
                Return "WPD_CONTENT_TYPE_Document"
            Case "{EABA8313-4525-4707-9F0E-87C6808E9435}"
                Return "WPD_CONTENT_TYPE_Contact"
            Case "{346B8932-4C36-40D8-9415-1828291F9DE9}"
                Return "WPD_CONTENT_TYPE_ContactGroup"
            Case "{4AD2C85E-5E2D-45E5-8864-4F229E3C6CF0}"
                Return "WPD_CONTENT_TYPE_Audio"
            Case "{9261B03C-3D78-4519-85E3-02C5E1F50BB9}"
                Return "WPD_CONTENT_TYPE_Video"
            Case "{60A169CF-F2AE-4E21-9375-9677F11C1C6E}"
                Return "WPD_CONTENT_TYPE_Television"
            Case "{1A33F7E4-AF13-48F5-994E-77369DFE04A3}"
                Return "WPD_CONTENT_TYPE_Playlist"
            Case "{00F0C3AC-A593-49AC-9219-24ABCA5A2563}"
                Return "WPD_CONTENT_TYPE_MixedContentAlbum"
            Case "{AA18737E-5009-48FA-AE21-85F24383B4E6}"
                Return "WPD_CONTENT_TYPE_AudioAlbum"
            Case "{75793148-15F5-4A30-A813-54ED8A37E226}"
                Return "WPD_CONTENT_TYPE_ImageAlbum"
            Case "{012B0DB7-D4C1-45D6-B081-94B87779614F}"
                Return "WPD_CONTENT_TYPE_VideoAlbum"
            Case "{9CD20ECF-3B50-414F-A641-E473FFE45751}"
                Return "WPD_CONTENT_TYPE_Memo"
            Case "{8038044A-7E51-4F8F-883D-1D0623D14533}"
                Return "WPD_CONTENT_TYPE_Email"
            Case "{0FED060E-8793-4B1E-90C9-48AC389AC631}"
                Return "WPD_CONTENT_TYPE_Appointment"
            Case "{63252F2C-887F-4CB6-B1AC-D29855DCEF6C}"
                Return "WPD_CONTENT_TYPE_Task"
            Case "{D269F96A-247C-4BFF-98FB-97F3C49220E6}"
                Return "WPD_CONTENT_TYPE_Program"
            Case "{0085E0A6-8D34-45D7-BC5C-447E59C73D48}"
                Return "WPD_CONTENT_TYPE_GenericFile"
            Case "{A1FD5967-6023-49A0-9DF1-F8060BE751B0}"
                Return "WPD_CONTENT_TYPE_Calendar"
            Case "{E80EAAF8-B2DB-4133-B67E-1BEF4B4A6E5F}"
                Return "WPD_CONTENT_TYPE_GenericMessage"
            Case "{031DA7EE-18C8-4205-847E-89A11261D0F3}"
                Return "WPD_CONTENT_TYPE_NetworkAssociation"
            Case "{DC3876E8-A948-4060-9050-CBD77E8A3D87}"
                Return "WPD_CONTENT_TYPE_Certificate"
            Case "{0BAC070A-9F5F-4DA4-A8F6-3DE44D68FD6C}"
                Return "WPD_CONTENT_TYPE_WirelessProfile"
            Case "{5E88B3CC-3E65-4E62-BFFF-229495253AB0}"
                Return "WPD_CONTENT_TYPE_MediaCast"
            Case "{821089F5-1D91-4DC9-BE3C-BBB1B35B18CE}"
                Return "WPD_CONTENT_TYPE_Section"
            Case "{28D8D31E-249C-454E-AABC-34883168E634}"
                Return "WPD_CONTENT_TYPE_Unspecified"
            Case "{80E170D2-1055-4A3E-B952-82CC4F8A8689}"
                Return "WPD_CONTENT_TYPE_All"
            Case "{30010000-AE6C-4804-98BA-C57B46965FE7}"
                Return "WPD_OBJECT_FORMAT_PROPERTIES_ONLY"
            Case "{08EA466B-E3A4-4336-A1F3-A44D2B5C438C}"
                Return "WPD_FUNCTIONAL_CATEGORY_DEVICE"
            Case "{30000000-AE6C-4804-98BA-C57B46965FE7}"
                Return "WPD_OBJECT_FORMAT_UNSPECIFIED"
            Case "{4D545058-1A2E-4106-A357-771E0819FC56}"
                Return "WPD_CATEGORY_MTP_EXT_VENDOR_OPERATIONS"
            Case Else
                Return "Unknown GUID: " & sValue
        End Select
    End Function

    Public Function GetStringFromPropertyKey(ByRef tPropertyKey As WpdStruct.PROPERTYKEY) As String

        Dim sFMTID As String
        Dim lPID As Integer

        sFMTID = "{" & tPropertyKey.fmtid.ToString.ToUpper & "}"
        lPID = tPropertyKey.pid

        Select Case sFMTID
            Case "{2ED8BA05-0AD3-42DC-B0D0-BC95AC396AC8}"
                Select Case lPID
                    Case 2
                        Return "WPD_MEDIA_TOTAL_BITRATE"
                    Case 3
                        Return "WPD_MEDIA_BITRATE_TYPE"
                    Case 4
                        Return "WPD_MEDIA_COPYRIGHT"
                    Case 5
                        Return "WPD_MEDIA_SUBSCRIPTION_CONTENT_ID"
                    Case 6
                        Return "WPD_MEDIA_USE_COUNT"
                    Case 7
                        Return "WPD_MEDIA_SKIP_COUNT"
                    Case 8
                        Return "WPD_MEDIA_LAST_ACCESSED_TIME"
                    Case 9
                        Return "WPD_MEDIA_PARENTAL_RATING"
                    Case 10
                        Return "WPD_MEDIA_META_GENRE"
                    Case 11
                        Return "WPD_MEDIA_COMPOSER"
                    Case 12
                        Return "WPD_MEDIA_EFFECTIVE_RATING"
                    Case 13
                        Return "WPD_MEDIA_SUB_TITLE"
                    Case 14
                        Return "WPD_MEDIA_RELEASE_DATE"
                    Case 15
                        Return "WPD_MEDIA_SAMPLE_RATE"
                    Case 16
                        Return "WPD_MEDIA_STAR_RATING"
                    Case 17
                        Return "WPD_MEDIA_USER_EFFECTIVE_RATING"
                    Case 18
                        Return "WPD_MEDIA_TITLE"
                    Case 19
                        Return "WPD_MEDIA_DURATION"
                    Case 20
                        Return "WPD_MEDIA_BUY_NOW"
                    Case 21
                        Return "WPD_MEDIA_ENCODING_PROFILE"
                    Case 22
                        Return "WPD_MEDIA_WIDTH"
                    Case 23
                        Return "WPD_MEDIA_HEIGHT"
                    Case 24
                        Return "WPD_MEDIA_ARTIST"
                    Case 25
                        Return "WPD_MEDIA_ALBUM_ARTIST"
                    Case 26
                        Return "WPD_MEDIA_OWNER"
                    Case 27
                        Return "WPD_MEDIA_MANAGING_EDITOR"
                    Case 28
                        Return "WPD_MEDIA_WEBMASTER"
                    Case 29
                        Return "WPD_MEDIA_SOURCE_URL"
                    Case 30
                        Return "WPD_MEDIA_DESTINATION_URL"
                    Case 31
                        Return "WPD_MEDIA_DESCRIPTION"
                    Case 32
                        Return "WPD_MEDIA_GENRE"
                    Case 33
                        Return "WPD_MEDIA_TIME_BOOKMARK"
                    Case 34
                        Return "WPD_MEDIA_OBJECT_BOOKMARK"
                    Case 35
                        Return "WPD_MEDIA_LAST_BUILD_DATE"
                    Case 36
                        Return "WPD_MEDIA_BYTE_BOOKMARK"
                    Case 37
                        Return "WPD_MEDIA_TIME_TO_LIVE"
                    Case 38
                        Return "WPD_MEDIA_GUID"
                    Case 39
                        Return "WPD_MEDIA_SUB_DESCRIPTION"
                    Case Else
                        Return "unknown"
                End Select

            Case "{346F2163-F998-4146-8B01-D19B4C00DE9A}"
                Select Case lPID
                    Case 2
                        Return "WPD_VIDEO_AUTHOR"
                    Case 4
                        Return "WPD_VIDEO_RECORDEDTV_STATION_NAME"
                    Case 5
                        Return "WPD_VIDEO_RECORDEDTV_CHANNEL_NUMBER"
                    Case 7
                        Return "WPD_VIDEO_RECORDEDTV_REPEAT"
                    Case 8
                        Return "WPD_VIDEO_BUFFER_SIZE"
                    Case 9
                        Return "WPD_VIDEO_CREDITS"
                    Case 10
                        Return "WPD_VIDEO_KEY_FRAME_DISTANCE"
                    Case 11
                        Return "WPD_VIDEO_QUALITY_SETTING"
                    Case 12
                        Return "WPD_VIDEO_SCAN_TYPE"
                    Case 13
                        Return "WPD_VIDEO_BITRATE"
                    Case 14
                        Return "WPD_VIDEO_FOURCC_CODE"
                    Case 15
                        Return "WPD_VIDEO_FRAMERATE"
                    Case Else
                        Return "unknown"
                End Select

            Case "{B324F56A-DC5D-46E5-B6DF-D2EA414888C6}"
                Select Case lPID
                    Case 3
                        Return "WPD_MUSIC_ALBUM"
                    Case 4
                        Return "WPD_MUSIC_TRACK"
                    Case 6
                        Return "WPD_MUSIC_LYRICS"
                    Case 8
                        Return "WPD_MUSIC_MOOD"
                    Case 9
                        Return "WPD_AUDIO_BITRATE"
                    Case 10
                        Return "WPD_AUDIO_CHANNEL_COUNT"
                    Case 11
                        Return "WPD_AUDIO_FORMAT_CODE"
                    Case 12
                        Return "WPD_AUDIO_BIT_DEPTH"
                    Case 13
                        Return "WPD_AUDIO_BLOCK_ALIGNMENT"
                    Case Else
                        Return "unknown"
                End Select

            Case "{01A3057A-74D6-4E80-BEA7-DC4C212CE50A}"
                Select Case lPID
                    Case 2
                        Return "WPD_STORAGE_TYPE"
                    Case 3
                        Return "WPD_STORAGE_FILE_SYSTEM_TYPE"
                    Case 4
                        Return "WPD_STORAGE_CAPACITY"
                    Case 5
                        Return "WPD_STORAGE_FREE_SPACE_IN_BYTES"
                    Case 6
                        Return "WPD_STORAGE_FREE_SPACE_IN_OBJECTS"
                    Case 7
                        Return "WPD_STORAGE_DESCRIPTION"
                    Case 8
                        Return "WPD_STORAGE_SERIAL_NUMBER"
                    Case 9
                        Return "WPD_STORAGE_MAX_OBJECT_SIZE"
                    Case 10
                        Return "WPD_STORAGE_CAPACITY_IN_OBJECTS"
                    Case 11
                        Return "WPD_STORAGE_ACCESS_CAPABILITY"
                    Case Else
                        Return "unknown"
                End Select

            Case "{4D545058-1A2E-4106-A357-771E0819FC56}"
                Select Case lPID
                    Case 11
                        Return "WPD_COMMAND_MTP_EXT_GET_SUPPORTED_VENDOR_OPCODES"
                    Case 12
                        Return "WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITHOUT_DATA_PHASE"
                    Case 13
                        Return "WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITH_DATA_TO_READ"
                    Case 14
                        Return "WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITH_DATA_TO_WRITE"
                    Case 15
                        Return "WPD_COMMAND_MTP_EXT_READ_DATA"
                    Case 16
                        Return "WPD_COMMAND_MTP_EXT_WRITE_DATA"
                    Case 17
                        Return "WPD_COMMAND_MTP_EXT_END_DATA_TRANSFER"
                    Case 18
                        Return "WPD_COMMAND_MTP_EXT_GET_VENDOR_EXTENSION_DESCRIPTION"
                    Case 1001
                        Return "WPD_PROPERTY_MTP_EXT_OPERATION_CODE"
                    Case 1002
                        Return "WPD_PROPERTY_MTP_EXT_OPERATION_PARAMS"
                    Case 1003
                        Return "WPD_PROPERTY_MTP_EXT_RESPONSE_CODE"
                    Case 1004
                        Return "WPD_PROPERTY_MTP_EXT_RESPONSE_PARAMS"
                    Case 1005
                        Return "WPD_PROPERTY_MTP_EXT_VENDOR_OPERATION_CODES"
                    Case 1006
                        Return "WPD_PROPERTY_MTP_EXT_TRANSFER_CONTEXT"
                    Case 1007
                        Return "WPD_PROPERTY_MTP_EXT_TRANSFER_TOTAL_DATA_SIZE"
                    Case 1008
                        Return "WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_TO_READ"
                    Case 1009
                        Return "WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_READ"
                    Case 1010
                        Return "WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_TO_WRITE"
                    Case 1011
                        Return "WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_WRITTEN"
                    Case 1012
                        Return "WPD_PROPERTY_MTP_EXT_TRANSFER_DATA"
                    Case 1013
                        Return "WPD_PROPERTY_MTP_EXT_OPTIMAL_TRANSFER_BUFFER_SIZE"
                    Case 1014
                        Return "WPD_PROPERTY_MTP_EXT_VENDOR_EXTENSION_DESCRIPTION"
                    Case Else
                        Return "unknown"
                End Select

            Case "{EF1E43DD-A9ED-4341-8BCC-186192AEA089}"
                Select Case lPID
                    Case 2
                        Return "WPD_COMMAND_OBJECT_MANAGEMENT_CREATE_OBJECT_WITH_PROPERTIES_ONLY"
                    Case 3
                        Return "WPD_COMMAND_OBJECT_MANAGEMENT_CREATE_OBJECT_WITH_PROPERTIES_AND_DATA"
                    Case 4
                        Return "WPD_COMMAND_OBJECT_MANAGEMENT_WRITE_OBJECT_DATA"
                    Case 5
                        Return "WPD_COMMAND_OBJECT_MANAGEMENT_COMMIT_OBJECT"
                    Case 6
                        Return "WPD_COMMAND_OBJECT_MANAGEMENT_REVERT_OBJECT"
                    Case 7
                        Return "WPD_COMMAND_OBJECT_MANAGEMENT_DELETE_OBJECTS"
                    Case 8
                        Return "WPD_COMMAND_OBJECT_MANAGEMENT_MOVE_OBJECTS"
                    Case 9
                        Return "WPD_COMMAND_OBJECT_MANAGEMENT_COPY_OBJECTS"
                    Case 10
                        Return "WPD_COMMAND_OBJECT_MANAGEMENT_UPDATE_OBJECT_WITH_PROPERTIES_AND_DATA"
                    Case 1001
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_CREATION_PROPERTIES"
                    Case 1002
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_CONTEXT"
                    Case 1003
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_NUM_BYTES_TO_WRITE"
                    Case 1004
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_NUM_BYTES_WRITTEN"
                    Case 1005
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_DATA"
                    Case 1006
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_OBJECT_ID"
                    Case 1007
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_DELETE_OPTIONS"
                    Case 1008
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_OPTIMAL_TRANSFER_BUFFER_SIZE"
                    Case 1009
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_OBJECT_IDS"
                    Case 1010
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_DELETE_RESULTS"
                    Case 1011
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_DESTINATION_FOLDER_OBJECT_ID"
                    Case 1012
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_MOVE_RESULTS"
                    Case 1013
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_COPY_RESULTS"
                    Case 1014
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_UPDATE_PROPERTIES"
                    Case 1015
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_PROPERTY_KEYS"
                    Case 1016
                        Return "WPD_PROPERTY_OBJECT_MANAGEMENT_OBJECT_FORMAT"
                    Case 5001
                        Return "WPD_OPTION_OBJECT_MANAGEMENT_RECURSIVE_DELETE_SUPPORTED"
                    Case Else
                        Return "unknown"
                End Select

            Case "{11C824DD-04CD-4E4E-8C7B-F6EFB794D84E}"
                Select Case lPID
                    Case 2
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_LIST_START"
                    Case 3
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_LIST_NEXT"
                    Case 4
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_LIST_END"
                    Case 5
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_FORMAT_START"
                    Case 6
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_FORMAT_NEXT"
                    Case 7
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_BULK_GET_VALUES_BY_OBJECT_FORMAT_END"
                    Case 8
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_BULK_SET_VALUES_BY_OBJECT_LIST_START"
                    Case 9
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_BULK_SET_VALUES_BY_OBJECT_LIST_NEXT"
                    Case 10
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_BULK_SET_VALUES_BY_OBJECT_LIST_END"
                    Case 1001
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_OBJECT_IDS"
                    Case 1002
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_CONTEXT"
                    Case 1003
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_VALUES"
                    Case 1004
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_PROPERTY_KEYS"
                    Case 1005
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_DEPTH"
                    Case 1006
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_PARENT_OBJECT_ID"
                    Case 1007
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_OBJECT_FORMAT"
                    Case 1008
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_BULK_WRITE_RESULTS"
                    Case Else
                        Return "unknown"
                End Select

            Case "{0CABEC78-6B74-41C6-9216-2639D1FCE356}"
                Select Case lPID
                    Case 2
                        Return "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_COMMANDS"
                    Case 3
                        Return "WPD_COMMAND_CAPABILITIES_GET_COMMAND_OPTIONS"
                    Case 4
                        Return "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_FUNCTIONAL_CATEGORIES"
                    Case 5
                        Return "WPD_COMMAND_CAPABILITIES_GET_FUNCTIONAL_OBJECTS"
                    Case 6
                        Return "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_CONTENT_TYPES"
                    Case 7
                        Return "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_FORMATS"
                    Case 8
                        Return "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_FORMAT_PROPERTIES"
                    Case 9
                        Return "WPD_COMMAND_CAPABILITIES_GET_FIXED_PROPERTY_ATTRIBUTES"
                    Case 10
                        Return "WPD_COMMAND_CAPABILITIES_GET_SUPPORTED_EVENTS"
                    Case 11
                        Return "WPD_COMMAND_CAPABILITIES_GET_EVENT_OPTIONS"
                    Case 1001
                        Return "WPD_PROPERTY_CAPABILITIES_SUPPORTED_COMMANDS"
                    Case 1002
                        Return "WPD_PROPERTY_CAPABILITIES_COMMAND"
                    Case 1003
                        Return "WPD_PROPERTY_CAPABILITIES_COMMAND_OPTION"
                    Case 1004
                        Return "WPD_PROPERTY_CAPABILITIES_FUNCTIONAL_CATEGORIES"
                    Case 1005
                        Return "WPD_PROPERTY_CAPABILITIES_FUNCTIONAL_CATEGORY"
                    Case 1006
                        Return "WPD_PROPERTY_CAPABILITIES_FUNCTIONAL_OBJECTS"
                    Case 1007
                        Return "WPD_PROPERTY_CAPABILITIES_CONTENT_TYPES"
                    Case 1008
                        Return "WPD_PROPERTY_CAPABILITIES_CONTENT_TYPE"
                    Case 1009
                        Return "WPD_PROPERTY_CAPABILITIES_FORMATS"
                    Case 1010
                        Return "WPD_PROPERTY_CAPABILITIES_FORMAT"
                    Case 1011
                        Return "WPD_PROPERTY_CAPABILITIES_PROPERTY_KEYS"
                    Case 1012
                        Return "WPD_PROPERTY_CAPABILITIES_PROPERTY_ATTRIBUTES"
                    Case 1013
                        Return "WPD_PROPERTY_CAPABILITIES_SUPPORTED_EVENTS"
                    Case 1014
                        Return "WPD_PROPERTY_CAPABILITIES_EVENT"
                    Case 1015
                        Return "WPD_PROPERTY_CAPABILITIES_EVENT_OPTIONS"
                    Case Else
                        Return "unknown"
                End Select

            Case "{B3A2B22D-A595-4108-BE0A-FC3C965F3D4A}"
                Select Case lPID
                    Case 2
                        Return "WPD_COMMAND_OBJECT_RESOURCES_GET_SUPPORTED"
                    Case 3
                        Return "WPD_COMMAND_OBJECT_RESOURCES_GET_ATTRIBUTES"
                    Case 4
                        Return "WPD_COMMAND_OBJECT_RESOURCES_OPEN"
                    Case 5
                        Return "WPD_COMMAND_OBJECT_RESOURCES_READ"
                    Case 6
                        Return "WPD_COMMAND_OBJECT_RESOURCES_WRITE"
                    Case 7
                        Return "WPD_COMMAND_OBJECT_RESOURCES_CLOSE"
                    Case 8
                        Return "WPD_COMMAND_OBJECT_RESOURCES_DELETE"
                    Case 9
                        Return "WPD_COMMAND_OBJECT_RESOURCES_CREATE_RESOURCE"
                    Case 10
                        Return "WPD_COMMAND_OBJECT_RESOURCES_REVERT"
                    Case 11
                        Return "WPD_COMMAND_OBJECT_RESOURCES_SEEK"
                    Case 1001
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_OBJECT_ID"
                    Case 1002
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_ACCESS_MODE"
                    Case 1003
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_RESOURCE_KEYS"
                    Case 1004
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_RESOURCE_ATTRIBUTES"
                    Case 1005
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_CONTEXT"
                    Case 1006
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_TO_READ"
                    Case 1007
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_READ"
                    Case 1008
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_TO_WRITE"
                    Case 1009
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_NUM_BYTES_WRITTEN"
                    Case 1010
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_DATA"
                    Case 1011
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_OPTIMAL_TRANSFER_BUFFER_SIZE"
                    Case 1012
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_SEEK_OFFSET"
                    Case 1013
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_SEEK_ORIGIN_FLAG"
                    Case 1014
                        Return "WPD_PROPERTY_OBJECT_RESOURCES_POSITION_FROM_START"
                    Case 5001
                        Return "WPD_OPTION_OBJECT_RESOURCES_SEEK_ON_READ_SUPPORTED"
                    Case 5002
                        Return "WPD_OPTION_OBJECT_RESOURCES_SEEK_ON_WRITE_SUPPORTED"
                End Select

            Case "{9E5582E4-0814-44E6-981A-B2998D583804}"
                Select Case lPID
                    Case 2
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_GET_SUPPORTED"
                    Case 3
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_GET_ATTRIBUTES"
                    Case 4
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_GET"
                    Case 5
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_SET"
                    Case 6
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_GET_ALL"
                    Case 7
                        Return "WPD_COMMAND_OBJECT_PROPERTIES_DELETE"
                    Case 1001
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_OBJECT_ID"
                    Case 1002
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_KEYS"
                    Case 1003
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_ATTRIBUTES"
                    Case 1004
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_VALUES"
                    Case 1005
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_WRITE_RESULTS"
                    Case 1006
                        Return "WPD_PROPERTY_OBJECT_PROPERTIES_PROPERTY_DELETE_RESULTS"
                    Case Else
                        Return "unknown"
                End Select

            Case "{B7474E91-E7F8-4AD9-B400-AD1A4B58EEEC}"
                Select Case lPID
                    Case 2
                        Return "WPD_COMMAND_OBJECT_ENUMERATION_START_FIND"
                    Case 3
                        Return "WPD_COMMAND_OBJECT_ENUMERATION_FIND_NEXT"
                    Case 4
                        Return "WPD_COMMAND_OBJECT_ENUMERATION_END"
                    Case 1001
                        Return "WPD_PROPERTY_OBJECT_ENUMERATION_PARENT"
                    Case 1002
                        Return "WPD_PROPERTY_OBJECT_ENUMERATION_FILTER"
                    Case 1003
                        Return "WPD_PROPERTY_OBJECT_ENUMERATION_OBJECT_IDS"
                    Case 1004
                        Return "WPD_PROPERTY_OBJECT_ENUMERATION_CONTEXT"
                    Case 1005
                        Return "WPD_PROPERTY_OBJECT_ENUMERATION_NUM_OBJECTS_REQUESTED"
                    Case Else
                        Return "unknown"
                End Select

            Case "{26D4979A-E643-4626-9E2B-736DC0C92FDC}"
                Select Case lPID
                    Case 2
                        Return "WPD_DEVICE_SYNC_PARTNER"
                    Case 3
                        Return "WPD_DEVICE_FIRMWARE_VERSION"
                    Case 4
                        Return "WPD_DEVICE_POWER_LEVEL"
                    Case 5
                        Return "WPD_DEVICE_POWER_SOURCE"
                    Case 6
                        Return "WPD_DEVICE_PROTOCOL"
                    Case 7
                        Return "WPD_DEVICE_MANUFACTURER"
                    Case 8
                        Return "WPD_DEVICE_MODEL"
                    Case 9
                        Return "WPD_DEVICE_SERIAL_NUMBER"
                    Case 10
                        Return "WPD_DEVICE_SUPPORTS_NON_CONSUMABLE"
                    Case 11
                        Return "WPD_DEVICE_DATETIME"
                    Case 12
                        Return "WPD_DEVICE_FRIENDLY_NAME"
                    Case 13
                        Return "WPD_DEVICE_SUPPORTED_DRM_SCHEMES"
                    Case 14
                        Return "WPD_DEVICE_SUPPORTED_FORMATS_ARE_ORDERED"
                    Case 15
                        Return "WPD_DEVICE_TYPE"
                    Case 16
                        Return "WPD_DEVICE_NETWORK_IDENTIFIER"
                    Case 17
                        Return "WPD_DEVICE_NETWORK_IDENTIFIER"
                    Case Else
                        Return "unknown"
                End Select

            Case "{463DD662-7FC4-4291-911C-7F4C9CCA9799}"
                Select Case lPID
                    Case 2
                        Return "WPD_DEVICE_FUNCTIONAL_UNIQUE_ID"
                    Case 3
                        Return "WPD_DEVICE_MODEL_UNIQUE_ID"
                    Case 4
                        Return "WPD_DEVICE_TRANSPORT"
                    Case 5
                        Return "WPD_DEVICE_USE_DEVICE_STAGE"
                    Case Else
                        Return "unknown"
                End Select

            Case "{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}"
                Select Case lPID
                    Case 2
                        Return "WPD_OBJECT_ID"
                    Case 3
                        Return "WPD_OBJECT_PARENT_ID"
                    Case 4
                        Return "WPD_OBJECT_NAME"
                    Case 5
                        Return "WPD_OBJECT"
                    Case 6
                        Return "WPD_OBJECT_FORMAT"
                    Case 7
                        Return "WPD_OBJECT_CONTENT_TYPE"
                    Case 9
                        Return "WPD_OBJECT_ISHIDDEN"
                    Case 10
                        Return "WPD_OBJECT_ISSYSTEM"
                    Case 11
                        Return "WPD_OBJECT_SIZE"
                    Case 12
                        Return "WPD_OBJECT_ORIGINAL_FILE_NAME"
                    Case 13
                        Return "WPD_OBJECT_NON_CONSUMABLE"
                    Case 14
                        Return "WPD_OBJECT_REFERENCES"
                    Case 15
                        Return "WPD_OBJECT_KEYWORDS"
                    Case 16
                        Return "WPD_OBJECT_SYNC_ID"
                    Case 17
                        Return "WPD_OBJECT_IS_DRM_PROTECTED"
                    Case 18
                        Return "WPD_OBJECT_DATE_CREATED"
                    Case 19
                        Return "WPD_OBJECT_PROPERTIES_V1"
                    Case 20
                        Return "WPD_OBJECT_DATE_AUTHORED"
                    Case 21
                        Return "WPD_OBJECT_BACK_REFERENCES"
                    Case 23
                        Return "WPD_OBJECT_CONTAINER_FUNCTIONAL_OBJECT_ID"
                    Case 24
                        Return "WPD_OBJECT_GENERATE_THUMBNAIL_FROM_RESOURCE"
                    Case 25
                        Return "WPD_OBJECT_HINT_LOCATION_DISPLAY_NAME"
                    Case 26
                        Return "WPD_OBJECT_CAN_DELETE"
                    Case 27
                        Return "WPD_OBJECT_LANGUAGE_LOCALE"
                    Case Else
                        Return "unknown"
                End Select

            Case "{8F052D93-ABCA-4FC5-A5AC-B01DF4DBE598}"
                Select Case lPID
                    Case 2
                        Return "WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1"
                    Case Else
                        Return "unknown"
                End Select

            Case "{4D545058-8900-40B3-8F1D-DC246E1E8370}"
                Return "WPD_PROPERTIES_MTP_VENDOR_EXTENDED_OBJECT_PROPS"

            Case "{4D545058-4FCE-4578-95C8-8698A9BC0F49}"
                Return "WPD_PROPERTIES_MTP_VENDOR_EXTENDED_DEVICE_PROPS"

            Case Else

                Return GetGuidName(sFMTID) '"Unknown GUID: " & sFMTID

        End Select

        Return String.Empty
    End Function

    Public Function GetPropertyStr(ByVal Content As PortableDeviceContent, ByVal ObjId As String, ByRef Key As WpdStruct.PROPERTYKEY) As String
        Dim sRet As String = String.Empty
        Using IPDevProperties As PortableDeviceProperties = Content.Properties
            Using IPDevKeyCol As New PortableDeviceKeyCollection
                If IPDevKeyCol.Add(Key) = True Then
                    Using IPDevValues As PortableDeviceValues = IPDevProperties.GetValues(ObjId, IPDevKeyCol)
                        sRet = IPDevValues.GetStringValue(Key)
                    End Using
                End If
            End Using
        End Using
        GetPropertyStr = sRet
    End Function

    Public Function GetPropertyUInt(ByVal Content As PortableDeviceContent, ByVal ObjId As String, ByRef Key As WpdStruct.PROPERTYKEY) As UInteger
        Dim iRet As UInteger = 0
        Using IPDevProperties As PortableDeviceProperties = Content.Properties
            Using IPDevKeyCol As New PortableDeviceKeyCollection
                If IPDevKeyCol.Add(Key) = True Then
                    Using IPDevValues As PortableDeviceValues = IPDevProperties.GetValues(ObjId, IPDevKeyCol)
                        iRet = IPDevValues.GetUnsignedIntegerValue(Key)
                    End Using
                End If
            End Using
        End Using
        GetPropertyUInt = iRet
    End Function

    Public Function GetPropertyInt(ByVal Content As PortableDeviceContent, ByVal ObjId As String, ByRef Key As WpdStruct.PROPERTYKEY) As Integer
        Dim iRet As Integer = 0
        Using IPDevProperties As PortableDeviceProperties = Content.Properties
            Using IPDevKeyCol As New PortableDeviceKeyCollection
                If IPDevKeyCol.Add(Key) = True Then
                    Using IPDevValues As PortableDeviceValues = IPDevProperties.GetValues(ObjId, IPDevKeyCol)
                        iRet = IPDevValues.GetSignedIntegerValue(Key)
                    End Using
                End If
            End Using
        End Using
        GetPropertyInt = iRet
    End Function

    Public Function GetPropertyBool(ByVal Content As PortableDeviceContent, ByVal ObjId As String, ByRef Key As WpdStruct.PROPERTYKEY) As Boolean
        Dim bRet As Boolean = False
        Using IPDevProperties As PortableDeviceProperties = Content.Properties
            Using IPDevKeyCol As New PortableDeviceKeyCollection
                If IPDevKeyCol.Add(Key) = True Then
                    Using IPDevValues As PortableDeviceValues = IPDevProperties.GetValues(ObjId, IPDevKeyCol)
                        bRet = IPDevValues.GetBoolValue(Key)
                    End Using
                End If
            End Using
        End Using
        GetPropertyBool = bRet
    End Function

    Public Function GetPropertyKey(ByVal ePropertyKeys As PropertyKeys) As WpdStruct.PROPERTYKEY
        Dim tREFPROPERTYKEY As New WpdStruct.PROPERTYKEY
        Dim sSplitPropKey As String() = GetFmtidPid(ePropertyKeys).Split(CChar(","))
        With tREFPROPERTYKEY
            .fmtid = Guid.Parse(sSplitPropKey(0))
            .pid = Integer.Parse(sSplitPropKey(1))
        End With
        Return tREFPROPERTYKEY
    End Function
#End Region

End Module